# coding: utf-8

"""
    Univention Directory Manager REST interface

    Schema definition for the objects in the Univention Directory Manager REST interface.  # noqa: E501

    The version of the OpenAPI document: 1.0.2
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from openapi_client_udm.configuration import Configuration


class ComputersLinuxOptions(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'posix': 'bool',
        'kerberos': 'bool',
        'samba': 'bool',
        'pki': 'bool',
        'nagios': 'bool',
        'radius_authenticator': 'bool'
    }

    attribute_map = {
        'posix': 'posix',
        'kerberos': 'kerberos',
        'samba': 'samba',
        'pki': 'pki',
        'nagios': 'nagios',
        'radius_authenticator': 'radiusAuthenticator'
    }

    def __init__(self, posix=True, kerberos=True, samba=True, pki=False, nagios=False, radius_authenticator=False, local_vars_configuration=None):  # noqa: E501
        """ComputersLinuxOptions - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._posix = None
        self._kerberos = None
        self._samba = None
        self._pki = None
        self._nagios = None
        self._radius_authenticator = None
        self.discriminator = None

        if posix is not None:
            self.posix = posix
        if kerberos is not None:
            self.kerberos = kerberos
        if samba is not None:
            self.samba = samba
        if pki is not None:
            self.pki = pki
        if nagios is not None:
            self.nagios = nagios
        if radius_authenticator is not None:
            self.radius_authenticator = radius_authenticator

    @property
    def posix(self):
        """Gets the posix of this ComputersLinuxOptions.  # noqa: E501

        Posix account  # noqa: E501

        :return: The posix of this ComputersLinuxOptions.  # noqa: E501
        :rtype: bool
        """
        return self._posix

    @posix.setter
    def posix(self, posix):
        """Sets the posix of this ComputersLinuxOptions.

        Posix account  # noqa: E501

        :param posix: The posix of this ComputersLinuxOptions.  # noqa: E501
        :type posix: bool
        """

        self._posix = posix

    @property
    def kerberos(self):
        """Gets the kerberos of this ComputersLinuxOptions.  # noqa: E501

        Kerberos principal  # noqa: E501

        :return: The kerberos of this ComputersLinuxOptions.  # noqa: E501
        :rtype: bool
        """
        return self._kerberos

    @kerberos.setter
    def kerberos(self, kerberos):
        """Sets the kerberos of this ComputersLinuxOptions.

        Kerberos principal  # noqa: E501

        :param kerberos: The kerberos of this ComputersLinuxOptions.  # noqa: E501
        :type kerberos: bool
        """

        self._kerberos = kerberos

    @property
    def samba(self):
        """Gets the samba of this ComputersLinuxOptions.  # noqa: E501

        Samba account  # noqa: E501

        :return: The samba of this ComputersLinuxOptions.  # noqa: E501
        :rtype: bool
        """
        return self._samba

    @samba.setter
    def samba(self, samba):
        """Sets the samba of this ComputersLinuxOptions.

        Samba account  # noqa: E501

        :param samba: The samba of this ComputersLinuxOptions.  # noqa: E501
        :type samba: bool
        """

        self._samba = samba

    @property
    def pki(self):
        """Gets the pki of this ComputersLinuxOptions.  # noqa: E501

        Public key infrastructure account  # noqa: E501

        :return: The pki of this ComputersLinuxOptions.  # noqa: E501
        :rtype: bool
        """
        return self._pki

    @pki.setter
    def pki(self, pki):
        """Sets the pki of this ComputersLinuxOptions.

        Public key infrastructure account  # noqa: E501

        :param pki: The pki of this ComputersLinuxOptions.  # noqa: E501
        :type pki: bool
        """

        self._pki = pki

    @property
    def nagios(self):
        """Gets the nagios of this ComputersLinuxOptions.  # noqa: E501

        Nagios support  # noqa: E501

        :return: The nagios of this ComputersLinuxOptions.  # noqa: E501
        :rtype: bool
        """
        return self._nagios

    @nagios.setter
    def nagios(self, nagios):
        """Sets the nagios of this ComputersLinuxOptions.

        Nagios support  # noqa: E501

        :param nagios: The nagios of this ComputersLinuxOptions.  # noqa: E501
        :type nagios: bool
        """

        self._nagios = nagios

    @property
    def radius_authenticator(self):
        """Gets the radius_authenticator of this ComputersLinuxOptions.  # noqa: E501

        RADIUS Authenticator  # noqa: E501

        :return: The radius_authenticator of this ComputersLinuxOptions.  # noqa: E501
        :rtype: bool
        """
        return self._radius_authenticator

    @radius_authenticator.setter
    def radius_authenticator(self, radius_authenticator):
        """Sets the radius_authenticator of this ComputersLinuxOptions.

        RADIUS Authenticator  # noqa: E501

        :param radius_authenticator: The radius_authenticator of this ComputersLinuxOptions.  # noqa: E501
        :type radius_authenticator: bool
        """

        self._radius_authenticator = radius_authenticator

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ComputersLinuxOptions):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ComputersLinuxOptions):
            return True

        return self.to_dict() != other.to_dict()
