# coding: utf-8

"""
    Univention Directory Manager REST interface

    Schema definition for the objects in the Univention Directory Manager REST interface.  # noqa: E501

    The version of the OpenAPI document: 1.0.2
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from openapi_client_udm.configuration import Configuration


class EmbeddedError(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'embedded': 'dict(str, object)',
        'code': 'int',
        'message': 'str',
        'title': 'str',
        'traceback': 'str'
    }

    attribute_map = {
        'embedded': '_embedded',
        'code': 'code',
        'message': 'message',
        'title': 'title',
        'traceback': 'traceback'
    }

    def __init__(self, embedded=None, code=None, message=None, title=None, traceback=None, local_vars_configuration=None):  # noqa: E501
        """EmbeddedError - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._embedded = None
        self._code = None
        self._message = None
        self._title = None
        self._traceback = None
        self.discriminator = None

        if embedded is not None:
            self.embedded = embedded
        if code is not None:
            self.code = code
        if message is not None:
            self.message = message
        if title is not None:
            self.title = title
        self.traceback = traceback

    @property
    def embedded(self):
        """Gets the embedded of this EmbeddedError.  # noqa: E501


        :return: The embedded of this EmbeddedError.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._embedded

    @embedded.setter
    def embedded(self, embedded):
        """Sets the embedded of this EmbeddedError.


        :param embedded: The embedded of this EmbeddedError.  # noqa: E501
        :type embedded: dict(str, object)
        """

        self._embedded = embedded

    @property
    def code(self):
        """Gets the code of this EmbeddedError.  # noqa: E501

        HTTP status code equivalent.  # noqa: E501

        :return: The code of this EmbeddedError.  # noqa: E501
        :rtype: int
        """
        return self._code

    @code.setter
    def code(self, code):
        """Sets the code of this EmbeddedError.

        HTTP status code equivalent.  # noqa: E501

        :param code: The code of this EmbeddedError.  # noqa: E501
        :type code: int
        """
        if (self.local_vars_configuration.client_side_validation and
                code is not None and code > 599):  # noqa: E501
            raise ValueError("Invalid value for `code`, must be a value less than or equal to `599`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                code is not None and code < 400):  # noqa: E501
            raise ValueError("Invalid value for `code`, must be a value greater than or equal to `400`")  # noqa: E501

        self._code = code

    @property
    def message(self):
        """Gets the message of this EmbeddedError.  # noqa: E501

        A human readable error message.  # noqa: E501

        :return: The message of this EmbeddedError.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this EmbeddedError.

        A human readable error message.  # noqa: E501

        :param message: The message of this EmbeddedError.  # noqa: E501
        :type message: str
        """

        self._message = message

    @property
    def title(self):
        """Gets the title of this EmbeddedError.  # noqa: E501

        short title for the error.  # noqa: E501

        :return: The title of this EmbeddedError.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this EmbeddedError.

        short title for the error.  # noqa: E501

        :param title: The title of this EmbeddedError.  # noqa: E501
        :type title: str
        """

        self._title = title

    @property
    def traceback(self):
        """Gets the traceback of this EmbeddedError.  # noqa: E501

        A stacktrace (if enabled and server error).  # noqa: E501

        :return: The traceback of this EmbeddedError.  # noqa: E501
        :rtype: str
        """
        return self._traceback

    @traceback.setter
    def traceback(self, traceback):
        """Sets the traceback of this EmbeddedError.

        A stacktrace (if enabled and server error).  # noqa: E501

        :param traceback: The traceback of this EmbeddedError.  # noqa: E501
        :type traceback: str
        """

        self._traceback = traceback

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EmbeddedError):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, EmbeddedError):
            return True

        return self.to_dict() != other.to_dict()
