# coding: utf-8

"""
    Univention Directory Manager REST interface

    Schema definition for the objects in the Univention Directory Manager REST interface.  # noqa: E501

    The version of the OpenAPI document: 1.0.2
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from openapi_client_udm.configuration import Configuration


class SettingsMsprintconnectionpolicy(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'dn': 'str',
        'properties': 'dict(str, object)',
        'options': 'dict(str, object)',
        'policies': 'SettingsMsprintconnectionpolicyPolicies',
        'position': 'str',
        'links': 'Links',
        'embedded': 'dict(str, object)',
        'uuid': 'str',
        'object_type': 'str',
        'uri': 'str'
    }

    attribute_map = {
        'dn': 'dn',
        'properties': 'properties',
        'options': 'options',
        'policies': 'policies',
        'position': 'position',
        'links': '_links',
        'embedded': '_embedded',
        'uuid': 'uuid',
        'object_type': 'objectType',
        'uri': 'uri'
    }

    def __init__(self, dn=None, properties=None, options=None, policies=None, position=None, links=None, embedded=None, uuid=None, object_type=None, uri=None, local_vars_configuration=None):  # noqa: E501
        """SettingsMsprintconnectionpolicy - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._dn = None
        self._properties = None
        self._options = None
        self._policies = None
        self._position = None
        self._links = None
        self._embedded = None
        self._uuid = None
        self._object_type = None
        self._uri = None
        self.discriminator = None

        if dn is not None:
            self.dn = dn
        if properties is not None:
            self.properties = properties
        if options is not None:
            self.options = options
        if policies is not None:
            self.policies = policies
        if position is not None:
            self.position = position
        if links is not None:
            self.links = links
        if embedded is not None:
            self.embedded = embedded
        if uuid is not None:
            self.uuid = uuid
        if object_type is not None:
            self.object_type = object_type
        if uri is not None:
            self.uri = uri

    @property
    def dn(self):
        """Gets the dn of this SettingsMsprintconnectionpolicy.  # noqa: E501

        The LDAP Distinguished Name (DN).  # noqa: E501

        :return: The dn of this SettingsMsprintconnectionpolicy.  # noqa: E501
        :rtype: str
        """
        return self._dn

    @dn.setter
    def dn(self, dn):
        """Sets the dn of this SettingsMsprintconnectionpolicy.

        The LDAP Distinguished Name (DN).  # noqa: E501

        :param dn: The dn of this SettingsMsprintconnectionpolicy.  # noqa: E501
        :type dn: str
        """
        if (self.local_vars_configuration.client_side_validation and
                dn is not None and len(dn) < 3):
            raise ValueError("Invalid value for `dn`, length must be greater than or equal to `3`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                dn is not None and not re.search(r'^.+=.+$', dn)):  # noqa: E501
            raise ValueError(r"Invalid value for `dn`, must be a follow pattern or equal to `/^.+=.+$/`")  # noqa: E501

        self._dn = dn

    @property
    def properties(self):
        """Gets the properties of this SettingsMsprintconnectionpolicy.  # noqa: E501

        Object type specific `UDM` properties.  # noqa: E501

        :return: The properties of this SettingsMsprintconnectionpolicy.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this SettingsMsprintconnectionpolicy.

        Object type specific `UDM` properties.  # noqa: E501

        :param properties: The properties of this SettingsMsprintconnectionpolicy.  # noqa: E501
        :type properties: dict(str, object)
        """

        self._properties = properties

    @property
    def options(self):
        """Gets the options of this SettingsMsprintconnectionpolicy.  # noqa: E501

        Object type specific `UDM` options.  # noqa: E501

        :return: The options of this SettingsMsprintconnectionpolicy.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._options

    @options.setter
    def options(self, options):
        """Sets the options of this SettingsMsprintconnectionpolicy.

        Object type specific `UDM` options.  # noqa: E501

        :param options: The options of this SettingsMsprintconnectionpolicy.  # noqa: E501
        :type options: dict(str, object)
        """

        self._options = options

    @property
    def policies(self):
        """Gets the policies of this SettingsMsprintconnectionpolicy.  # noqa: E501


        :return: The policies of this SettingsMsprintconnectionpolicy.  # noqa: E501
        :rtype: SettingsMsprintconnectionpolicyPolicies
        """
        return self._policies

    @policies.setter
    def policies(self, policies):
        """Sets the policies of this SettingsMsprintconnectionpolicy.


        :param policies: The policies of this SettingsMsprintconnectionpolicy.  # noqa: E501
        :type policies: SettingsMsprintconnectionpolicyPolicies
        """

        self._policies = policies

    @property
    def position(self):
        """Gets the position of this SettingsMsprintconnectionpolicy.  # noqa: E501

        DN of LDAP node below which the object is located. Changing this causes a move of the object. When changing no other changes are applied.  # noqa: E501

        :return: The position of this SettingsMsprintconnectionpolicy.  # noqa: E501
        :rtype: str
        """
        return self._position

    @position.setter
    def position(self, position):
        """Sets the position of this SettingsMsprintconnectionpolicy.

        DN of LDAP node below which the object is located. Changing this causes a move of the object. When changing no other changes are applied.  # noqa: E501

        :param position: The position of this SettingsMsprintconnectionpolicy.  # noqa: E501
        :type position: str
        """

        self._position = position

    @property
    def links(self):
        """Gets the links of this SettingsMsprintconnectionpolicy.  # noqa: E501


        :return: The links of this SettingsMsprintconnectionpolicy.  # noqa: E501
        :rtype: Links
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this SettingsMsprintconnectionpolicy.


        :param links: The links of this SettingsMsprintconnectionpolicy.  # noqa: E501
        :type links: Links
        """

        self._links = links

    @property
    def embedded(self):
        """Gets the embedded of this SettingsMsprintconnectionpolicy.  # noqa: E501

        Hypertext Application Language (HAL) embedded resources.  # noqa: E501

        :return: The embedded of this SettingsMsprintconnectionpolicy.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._embedded

    @embedded.setter
    def embedded(self, embedded):
        """Sets the embedded of this SettingsMsprintconnectionpolicy.

        Hypertext Application Language (HAL) embedded resources.  # noqa: E501

        :param embedded: The embedded of this SettingsMsprintconnectionpolicy.  # noqa: E501
        :type embedded: dict(str, object)
        """

        self._embedded = embedded

    @property
    def uuid(self):
        """Gets the uuid of this SettingsMsprintconnectionpolicy.  # noqa: E501

        The LDAP Entry-UUID.  # noqa: E501

        :return: The uuid of this SettingsMsprintconnectionpolicy.  # noqa: E501
        :rtype: str
        """
        return self._uuid

    @uuid.setter
    def uuid(self, uuid):
        """Sets the uuid of this SettingsMsprintconnectionpolicy.

        The LDAP Entry-UUID.  # noqa: E501

        :param uuid: The uuid of this SettingsMsprintconnectionpolicy.  # noqa: E501
        :type uuid: str
        """
        if (self.local_vars_configuration.client_side_validation and
                uuid is not None and len(uuid) > 36):
            raise ValueError("Invalid value for `uuid`, length must be less than or equal to `36`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                uuid is not None and len(uuid) < 36):
            raise ValueError("Invalid value for `uuid`, length must be greater than or equal to `36`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                uuid is not None and not re.search(r'^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$', uuid)):  # noqa: E501
            raise ValueError(r"Invalid value for `uuid`, must be a follow pattern or equal to `/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/`")  # noqa: E501

        self._uuid = uuid

    @property
    def object_type(self):
        """Gets the object_type of this SettingsMsprintconnectionpolicy.  # noqa: E501

        The UDM Object-Type.  # noqa: E501

        :return: The object_type of this SettingsMsprintconnectionpolicy.  # noqa: E501
        :rtype: str
        """
        return self._object_type

    @object_type.setter
    def object_type(self, object_type):
        """Sets the object_type of this SettingsMsprintconnectionpolicy.

        The UDM Object-Type.  # noqa: E501

        :param object_type: The object_type of this SettingsMsprintconnectionpolicy.  # noqa: E501
        :type object_type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                object_type is not None and len(object_type) < 3):
            raise ValueError("Invalid value for `object_type`, length must be greater than or equal to `3`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                object_type is not None and not re.search(r'^.+\/.+$', object_type)):  # noqa: E501
            raise ValueError(r"Invalid value for `object_type`, must be a follow pattern or equal to `/^.+\/.+$/`")  # noqa: E501

        self._object_type = object_type

    @property
    def uri(self):
        """Gets the uri of this SettingsMsprintconnectionpolicy.  # noqa: E501


        :return: The uri of this SettingsMsprintconnectionpolicy.  # noqa: E501
        :rtype: str
        """
        return self._uri

    @uri.setter
    def uri(self, uri):
        """Sets the uri of this SettingsMsprintconnectionpolicy.


        :param uri: The uri of this SettingsMsprintconnectionpolicy.  # noqa: E501
        :type uri: str
        """

        self._uri = uri

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SettingsMsprintconnectionpolicy):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SettingsMsprintconnectionpolicy):
            return True

        return self.to_dict() != other.to_dict()
