# coding: utf-8

"""
    Univention Directory Manager REST interface

    Schema definition for the objects in the Univention Directory Manager REST interface.  # noqa: E501

    The version of the OpenAPI document: 1.0.2
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from openapi_client_udm.configuration import Configuration


class SettingsPortalEntryRequestPatch(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'dn': 'str',
        'properties': 'dict(str, object)',
        'options': 'dict(str, object)',
        'policies': 'dict(str, object)'
    }

    attribute_map = {
        'dn': 'dn',
        'properties': 'properties',
        'options': 'options',
        'policies': 'policies'
    }

    def __init__(self, dn=None, properties=None, options=None, policies=None, local_vars_configuration=None):  # noqa: E501
        """SettingsPortalEntryRequestPatch - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._dn = None
        self._properties = None
        self._options = None
        self._policies = None
        self.discriminator = None

        if dn is not None:
            self.dn = dn
        if properties is not None:
            self.properties = properties
        if options is not None:
            self.options = options
        if policies is not None:
            self.policies = policies

    @property
    def dn(self):
        """Gets the dn of this SettingsPortalEntryRequestPatch.  # noqa: E501

        The LDAP Distinguished Name (DN).  # noqa: E501

        :return: The dn of this SettingsPortalEntryRequestPatch.  # noqa: E501
        :rtype: str
        """
        return self._dn

    @dn.setter
    def dn(self, dn):
        """Sets the dn of this SettingsPortalEntryRequestPatch.

        The LDAP Distinguished Name (DN).  # noqa: E501

        :param dn: The dn of this SettingsPortalEntryRequestPatch.  # noqa: E501
        :type dn: str
        """
        if (self.local_vars_configuration.client_side_validation and
                dn is not None and len(dn) < 3):
            raise ValueError("Invalid value for `dn`, length must be greater than or equal to `3`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                dn is not None and not re.search(r'^.+=.+$', dn)):  # noqa: E501
            raise ValueError(r"Invalid value for `dn`, must be a follow pattern or equal to `/^.+=.+$/`")  # noqa: E501

        self._dn = dn

    @property
    def properties(self):
        """Gets the properties of this SettingsPortalEntryRequestPatch.  # noqa: E501

        Object type specific `UDM` properties.  # noqa: E501

        :return: The properties of this SettingsPortalEntryRequestPatch.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this SettingsPortalEntryRequestPatch.

        Object type specific `UDM` properties.  # noqa: E501

        :param properties: The properties of this SettingsPortalEntryRequestPatch.  # noqa: E501
        :type properties: dict(str, object)
        """

        self._properties = properties

    @property
    def options(self):
        """Gets the options of this SettingsPortalEntryRequestPatch.  # noqa: E501

        Object type specific `UDM` options.  # noqa: E501

        :return: The options of this SettingsPortalEntryRequestPatch.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._options

    @options.setter
    def options(self, options):
        """Sets the options of this SettingsPortalEntryRequestPatch.

        Object type specific `UDM` options.  # noqa: E501

        :param options: The options of this SettingsPortalEntryRequestPatch.  # noqa: E501
        :type options: dict(str, object)
        """

        self._options = options

    @property
    def policies(self):
        """Gets the policies of this SettingsPortalEntryRequestPatch.  # noqa: E501

        Policies which apply for this object.  # noqa: E501

        :return: The policies of this SettingsPortalEntryRequestPatch.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._policies

    @policies.setter
    def policies(self, policies):
        """Sets the policies of this SettingsPortalEntryRequestPatch.

        Policies which apply for this object.  # noqa: E501

        :param policies: The policies of this SettingsPortalEntryRequestPatch.  # noqa: E501
        :type policies: dict(str, object)
        """

        self._policies = policies

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SettingsPortalEntryRequestPatch):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SettingsPortalEntryRequestPatch):
            return True

        return self.to_dict() != other.to_dict()
