# openapi-client-udm
Schema definition for the objects in the Univention Directory Manager REST interface.

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.2
- Package version: 1.0.2
- Build package: org.openapitools.codegen.languages.PythonLegacyClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import openapi_client_udm
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import openapi_client_udm
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function

import time
import openapi_client_udm
from openapi_client_udm.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://ucs.sawtooth.claremontmakerspace.org/univention/udm
# See configuration.py for a list of all supported configuration parameters.
configuration = openapi_client_udm.Configuration(
    host = "https://ucs.sawtooth.claremontmakerspace.org/univention/udm"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure HTTP basic authorization: basic
configuration = openapi_client_udm.Configuration(
    username = 'YOUR_USERNAME',
    password = 'YOUR_PASSWORD'
)


# Enter a context with an instance of the API client
with openapi_client_udm.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = openapi_client_udm.AppcenterAppApi(api_client)
    dn = 'dn_example' # str | The (urlencoded) LDAP Distinguished Name (DN).
user_agent = '' # str | The user agent. (optional)
accept_language = '' # str | The accepted response languages. (optional)
if_none_match = '' # str | Use request from cache by using the Etag entity tag if it matches. (optional)
if_modified_since = '' # str | Use request from cache by using the Last-Modified date if it matches. (optional)
x_request_id = '' # str | A request-ID used for logging and tracing. (optional)

    try:
        #  Get a representation of the App Metadata object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
        api_response = api_instance.udm_appcenter_app_object(dn, user_agent=user_agent, accept_language=accept_language, if_none_match=if_none_match, if_modified_since=if_modified_since, x_request_id=x_request_id)
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling AppcenterAppApi->udm_appcenter_app_object: %s\n" % e)
    
```

## Documentation for API Endpoints

All URIs are relative to *https://ucs.sawtooth.claremontmakerspace.org/univention/udm*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AppcenterAppApi* | [**udm_appcenter_app_object**](docs/AppcenterAppApi.md#udm_appcenter_app_object) | **GET** /appcenter/app/{dn} |  Get a representation of the App Metadata object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*AppcenterAppApi* | [**udm_appcenter_app_object_create**](docs/AppcenterAppApi.md#udm_appcenter_app_object_create) | **POST** /appcenter/app/ | Create a new App Metadata object
*AppcenterAppApi* | [**udm_appcenter_app_object_modify**](docs/AppcenterAppApi.md#udm_appcenter_app_object_modify) | **PUT** /appcenter/app/{dn} | Modify or move an App Metadata object
*AppcenterAppApi* | [**udm_appcenter_app_object_remove**](docs/AppcenterAppApi.md#udm_appcenter_app_object_remove) | **DELETE** /appcenter/app/{dn} | Remove a App Metadata object
*AppcenterAppApi* | [**udm_appcenter_app_object_search**](docs/AppcenterAppApi.md#udm_appcenter_app_object_search) | **GET** /appcenter/app/ | Search for App Metadata objects
*AppcenterAppApi* | [**udm_appcenter_app_object_template**](docs/AppcenterAppApi.md#udm_appcenter_app_object_template) | **GET** /appcenter/app/add | Get a template for creating an App Metadata object (contains all properties and their default values)
*AppcenterAppApi* | [**udm_appcenter_app_object_update**](docs/AppcenterAppApi.md#udm_appcenter_app_object_update) | **PATCH** /appcenter/app/{dn} | Modify an App Metadata object (moving is currently not possible)
*ComputersComputerApi* | [**udm_computers_computer_object**](docs/ComputersComputerApi.md#udm_computers_computer_object) | **GET** /computers/computer/{dn} |  Get a representation of the Computer object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*ComputersComputerApi* | [**udm_computers_computer_object_search**](docs/ComputersComputerApi.md#udm_computers_computer_object_search) | **GET** /computers/computer/ | Search for Computers objects
*ComputersDomaincontrollerBackupApi* | [**udm_computers_domaincontroller_backup_object**](docs/ComputersDomaincontrollerBackupApi.md#udm_computers_domaincontroller_backup_object) | **GET** /computers/domaincontroller_backup/{dn} |  Get a representation of the Backup Directory Node object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*ComputersDomaincontrollerBackupApi* | [**udm_computers_domaincontroller_backup_object_create**](docs/ComputersDomaincontrollerBackupApi.md#udm_computers_domaincontroller_backup_object_create) | **POST** /computers/domaincontroller_backup/ | Create a new Backup Directory Node object
*ComputersDomaincontrollerBackupApi* | [**udm_computers_domaincontroller_backup_object_modify**](docs/ComputersDomaincontrollerBackupApi.md#udm_computers_domaincontroller_backup_object_modify) | **PUT** /computers/domaincontroller_backup/{dn} | Modify or move an Backup Directory Node object
*ComputersDomaincontrollerBackupApi* | [**udm_computers_domaincontroller_backup_object_remove**](docs/ComputersDomaincontrollerBackupApi.md#udm_computers_domaincontroller_backup_object_remove) | **DELETE** /computers/domaincontroller_backup/{dn} | Remove a Backup Directory Nodes object
*ComputersDomaincontrollerBackupApi* | [**udm_computers_domaincontroller_backup_object_search**](docs/ComputersDomaincontrollerBackupApi.md#udm_computers_domaincontroller_backup_object_search) | **GET** /computers/domaincontroller_backup/ | Search for Backup Directory Nodes objects
*ComputersDomaincontrollerBackupApi* | [**udm_computers_domaincontroller_backup_object_template**](docs/ComputersDomaincontrollerBackupApi.md#udm_computers_domaincontroller_backup_object_template) | **GET** /computers/domaincontroller_backup/add | Get a template for creating an Backup Directory Node object (contains all properties and their default values)
*ComputersDomaincontrollerBackupApi* | [**udm_computers_domaincontroller_backup_object_update**](docs/ComputersDomaincontrollerBackupApi.md#udm_computers_domaincontroller_backup_object_update) | **PATCH** /computers/domaincontroller_backup/{dn} | Modify an Backup Directory Node object (moving is currently not possible)
*ComputersDomaincontrollerMasterApi* | [**udm_computers_domaincontroller_master_object**](docs/ComputersDomaincontrollerMasterApi.md#udm_computers_domaincontroller_master_object) | **GET** /computers/domaincontroller_master/{dn} |  Get a representation of the Primary Directory Node object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*ComputersDomaincontrollerMasterApi* | [**udm_computers_domaincontroller_master_object_create**](docs/ComputersDomaincontrollerMasterApi.md#udm_computers_domaincontroller_master_object_create) | **POST** /computers/domaincontroller_master/ | Create a new Primary Directory Node object
*ComputersDomaincontrollerMasterApi* | [**udm_computers_domaincontroller_master_object_modify**](docs/ComputersDomaincontrollerMasterApi.md#udm_computers_domaincontroller_master_object_modify) | **PUT** /computers/domaincontroller_master/{dn} | Modify or move an Primary Directory Node object
*ComputersDomaincontrollerMasterApi* | [**udm_computers_domaincontroller_master_object_remove**](docs/ComputersDomaincontrollerMasterApi.md#udm_computers_domaincontroller_master_object_remove) | **DELETE** /computers/domaincontroller_master/{dn} | Remove a Primary Directory Nodes object
*ComputersDomaincontrollerMasterApi* | [**udm_computers_domaincontroller_master_object_search**](docs/ComputersDomaincontrollerMasterApi.md#udm_computers_domaincontroller_master_object_search) | **GET** /computers/domaincontroller_master/ | Search for Primary Directory Nodes objects
*ComputersDomaincontrollerMasterApi* | [**udm_computers_domaincontroller_master_object_template**](docs/ComputersDomaincontrollerMasterApi.md#udm_computers_domaincontroller_master_object_template) | **GET** /computers/domaincontroller_master/add | Get a template for creating an Primary Directory Node object (contains all properties and their default values)
*ComputersDomaincontrollerMasterApi* | [**udm_computers_domaincontroller_master_object_update**](docs/ComputersDomaincontrollerMasterApi.md#udm_computers_domaincontroller_master_object_update) | **PATCH** /computers/domaincontroller_master/{dn} | Modify an Primary Directory Node object (moving is currently not possible)
*ComputersDomaincontrollerSlaveApi* | [**udm_computers_domaincontroller_slave_object**](docs/ComputersDomaincontrollerSlaveApi.md#udm_computers_domaincontroller_slave_object) | **GET** /computers/domaincontroller_slave/{dn} |  Get a representation of the Replica Directory Node object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*ComputersDomaincontrollerSlaveApi* | [**udm_computers_domaincontroller_slave_object_create**](docs/ComputersDomaincontrollerSlaveApi.md#udm_computers_domaincontroller_slave_object_create) | **POST** /computers/domaincontroller_slave/ | Create a new Replica Directory Node object
*ComputersDomaincontrollerSlaveApi* | [**udm_computers_domaincontroller_slave_object_modify**](docs/ComputersDomaincontrollerSlaveApi.md#udm_computers_domaincontroller_slave_object_modify) | **PUT** /computers/domaincontroller_slave/{dn} | Modify or move an Replica Directory Node object
*ComputersDomaincontrollerSlaveApi* | [**udm_computers_domaincontroller_slave_object_remove**](docs/ComputersDomaincontrollerSlaveApi.md#udm_computers_domaincontroller_slave_object_remove) | **DELETE** /computers/domaincontroller_slave/{dn} | Remove a Replica Directory Nodes object
*ComputersDomaincontrollerSlaveApi* | [**udm_computers_domaincontroller_slave_object_search**](docs/ComputersDomaincontrollerSlaveApi.md#udm_computers_domaincontroller_slave_object_search) | **GET** /computers/domaincontroller_slave/ | Search for Replica Directory Nodes objects
*ComputersDomaincontrollerSlaveApi* | [**udm_computers_domaincontroller_slave_object_template**](docs/ComputersDomaincontrollerSlaveApi.md#udm_computers_domaincontroller_slave_object_template) | **GET** /computers/domaincontroller_slave/add | Get a template for creating an Replica Directory Node object (contains all properties and their default values)
*ComputersDomaincontrollerSlaveApi* | [**udm_computers_domaincontroller_slave_object_update**](docs/ComputersDomaincontrollerSlaveApi.md#udm_computers_domaincontroller_slave_object_update) | **PATCH** /computers/domaincontroller_slave/{dn} | Modify an Replica Directory Node object (moving is currently not possible)
*ComputersIpmanagedclientApi* | [**udm_computers_ipmanagedclient_object**](docs/ComputersIpmanagedclientApi.md#udm_computers_ipmanagedclient_object) | **GET** /computers/ipmanagedclient/{dn} |  Get a representation of the IP client object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*ComputersIpmanagedclientApi* | [**udm_computers_ipmanagedclient_object_create**](docs/ComputersIpmanagedclientApi.md#udm_computers_ipmanagedclient_object_create) | **POST** /computers/ipmanagedclient/ | Create a new IP client object
*ComputersIpmanagedclientApi* | [**udm_computers_ipmanagedclient_object_modify**](docs/ComputersIpmanagedclientApi.md#udm_computers_ipmanagedclient_object_modify) | **PUT** /computers/ipmanagedclient/{dn} | Modify or move an IP client object
*ComputersIpmanagedclientApi* | [**udm_computers_ipmanagedclient_object_remove**](docs/ComputersIpmanagedclientApi.md#udm_computers_ipmanagedclient_object_remove) | **DELETE** /computers/ipmanagedclient/{dn} | Remove a IP clients object
*ComputersIpmanagedclientApi* | [**udm_computers_ipmanagedclient_object_search**](docs/ComputersIpmanagedclientApi.md#udm_computers_ipmanagedclient_object_search) | **GET** /computers/ipmanagedclient/ | Search for IP clients objects
*ComputersIpmanagedclientApi* | [**udm_computers_ipmanagedclient_object_template**](docs/ComputersIpmanagedclientApi.md#udm_computers_ipmanagedclient_object_template) | **GET** /computers/ipmanagedclient/add | Get a template for creating an IP client object (contains all properties and their default values)
*ComputersIpmanagedclientApi* | [**udm_computers_ipmanagedclient_object_update**](docs/ComputersIpmanagedclientApi.md#udm_computers_ipmanagedclient_object_update) | **PATCH** /computers/ipmanagedclient/{dn} | Modify an IP client object (moving is currently not possible)
*ComputersLinuxApi* | [**udm_computers_linux_object**](docs/ComputersLinuxApi.md#udm_computers_linux_object) | **GET** /computers/linux/{dn} |  Get a representation of the Linux Computer object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*ComputersLinuxApi* | [**udm_computers_linux_object_create**](docs/ComputersLinuxApi.md#udm_computers_linux_object_create) | **POST** /computers/linux/ | Create a new Linux Computer object
*ComputersLinuxApi* | [**udm_computers_linux_object_modify**](docs/ComputersLinuxApi.md#udm_computers_linux_object_modify) | **PUT** /computers/linux/{dn} | Modify or move an Linux Computer object
*ComputersLinuxApi* | [**udm_computers_linux_object_remove**](docs/ComputersLinuxApi.md#udm_computers_linux_object_remove) | **DELETE** /computers/linux/{dn} | Remove a Linux Computers object
*ComputersLinuxApi* | [**udm_computers_linux_object_search**](docs/ComputersLinuxApi.md#udm_computers_linux_object_search) | **GET** /computers/linux/ | Search for Linux Computers objects
*ComputersLinuxApi* | [**udm_computers_linux_object_template**](docs/ComputersLinuxApi.md#udm_computers_linux_object_template) | **GET** /computers/linux/add | Get a template for creating an Linux Computer object (contains all properties and their default values)
*ComputersLinuxApi* | [**udm_computers_linux_object_update**](docs/ComputersLinuxApi.md#udm_computers_linux_object_update) | **PATCH** /computers/linux/{dn} | Modify an Linux Computer object (moving is currently not possible)
*ComputersMacosApi* | [**udm_computers_macos_object**](docs/ComputersMacosApi.md#udm_computers_macos_object) | **GET** /computers/macos/{dn} |  Get a representation of the macOS Client object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*ComputersMacosApi* | [**udm_computers_macos_object_create**](docs/ComputersMacosApi.md#udm_computers_macos_object_create) | **POST** /computers/macos/ | Create a new macOS Client object
*ComputersMacosApi* | [**udm_computers_macos_object_modify**](docs/ComputersMacosApi.md#udm_computers_macos_object_modify) | **PUT** /computers/macos/{dn} | Modify or move an macOS Client object
*ComputersMacosApi* | [**udm_computers_macos_object_remove**](docs/ComputersMacosApi.md#udm_computers_macos_object_remove) | **DELETE** /computers/macos/{dn} | Remove a macOS Clients object
*ComputersMacosApi* | [**udm_computers_macos_object_search**](docs/ComputersMacosApi.md#udm_computers_macos_object_search) | **GET** /computers/macos/ | Search for macOS Clients objects
*ComputersMacosApi* | [**udm_computers_macos_object_template**](docs/ComputersMacosApi.md#udm_computers_macos_object_template) | **GET** /computers/macos/add | Get a template for creating an macOS Client object (contains all properties and their default values)
*ComputersMacosApi* | [**udm_computers_macos_object_update**](docs/ComputersMacosApi.md#udm_computers_macos_object_update) | **PATCH** /computers/macos/{dn} | Modify an macOS Client object (moving is currently not possible)
*ComputersMemberserverApi* | [**udm_computers_memberserver_object**](docs/ComputersMemberserverApi.md#udm_computers_memberserver_object) | **GET** /computers/memberserver/{dn} |  Get a representation of the Managed Node object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*ComputersMemberserverApi* | [**udm_computers_memberserver_object_create**](docs/ComputersMemberserverApi.md#udm_computers_memberserver_object_create) | **POST** /computers/memberserver/ | Create a new Managed Node object
*ComputersMemberserverApi* | [**udm_computers_memberserver_object_modify**](docs/ComputersMemberserverApi.md#udm_computers_memberserver_object_modify) | **PUT** /computers/memberserver/{dn} | Modify or move an Managed Node object
*ComputersMemberserverApi* | [**udm_computers_memberserver_object_remove**](docs/ComputersMemberserverApi.md#udm_computers_memberserver_object_remove) | **DELETE** /computers/memberserver/{dn} | Remove a Managed Nodes object
*ComputersMemberserverApi* | [**udm_computers_memberserver_object_search**](docs/ComputersMemberserverApi.md#udm_computers_memberserver_object_search) | **GET** /computers/memberserver/ | Search for Managed Nodes objects
*ComputersMemberserverApi* | [**udm_computers_memberserver_object_template**](docs/ComputersMemberserverApi.md#udm_computers_memberserver_object_template) | **GET** /computers/memberserver/add | Get a template for creating an Managed Node object (contains all properties and their default values)
*ComputersMemberserverApi* | [**udm_computers_memberserver_object_update**](docs/ComputersMemberserverApi.md#udm_computers_memberserver_object_update) | **PATCH** /computers/memberserver/{dn} | Modify an Managed Node object (moving is currently not possible)
*ComputersTrustaccountApi* | [**udm_computers_trustaccount_object**](docs/ComputersTrustaccountApi.md#udm_computers_trustaccount_object) | **GET** /computers/trustaccount/{dn} |  Get a representation of the Domain trust account object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*ComputersTrustaccountApi* | [**udm_computers_trustaccount_object_create**](docs/ComputersTrustaccountApi.md#udm_computers_trustaccount_object_create) | **POST** /computers/trustaccount/ | Create a new Domain trust account object
*ComputersTrustaccountApi* | [**udm_computers_trustaccount_object_modify**](docs/ComputersTrustaccountApi.md#udm_computers_trustaccount_object_modify) | **PUT** /computers/trustaccount/{dn} | Modify or move an Domain trust account object
*ComputersTrustaccountApi* | [**udm_computers_trustaccount_object_remove**](docs/ComputersTrustaccountApi.md#udm_computers_trustaccount_object_remove) | **DELETE** /computers/trustaccount/{dn} | Remove a Domain trust accounts object
*ComputersTrustaccountApi* | [**udm_computers_trustaccount_object_search**](docs/ComputersTrustaccountApi.md#udm_computers_trustaccount_object_search) | **GET** /computers/trustaccount/ | Search for Domain trust accounts objects
*ComputersTrustaccountApi* | [**udm_computers_trustaccount_object_template**](docs/ComputersTrustaccountApi.md#udm_computers_trustaccount_object_template) | **GET** /computers/trustaccount/add | Get a template for creating an Domain trust account object (contains all properties and their default values)
*ComputersTrustaccountApi* | [**udm_computers_trustaccount_object_update**](docs/ComputersTrustaccountApi.md#udm_computers_trustaccount_object_update) | **PATCH** /computers/trustaccount/{dn} | Modify an Domain trust account object (moving is currently not possible)
*ComputersUbuntuApi* | [**udm_computers_ubuntu_object**](docs/ComputersUbuntuApi.md#udm_computers_ubuntu_object) | **GET** /computers/ubuntu/{dn} |  Get a representation of the Ubuntu Computer object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*ComputersUbuntuApi* | [**udm_computers_ubuntu_object_create**](docs/ComputersUbuntuApi.md#udm_computers_ubuntu_object_create) | **POST** /computers/ubuntu/ | Create a new Ubuntu Computer object
*ComputersUbuntuApi* | [**udm_computers_ubuntu_object_modify**](docs/ComputersUbuntuApi.md#udm_computers_ubuntu_object_modify) | **PUT** /computers/ubuntu/{dn} | Modify or move an Ubuntu Computer object
*ComputersUbuntuApi* | [**udm_computers_ubuntu_object_remove**](docs/ComputersUbuntuApi.md#udm_computers_ubuntu_object_remove) | **DELETE** /computers/ubuntu/{dn} | Remove a Ubuntu Computers object
*ComputersUbuntuApi* | [**udm_computers_ubuntu_object_search**](docs/ComputersUbuntuApi.md#udm_computers_ubuntu_object_search) | **GET** /computers/ubuntu/ | Search for Ubuntu Computers objects
*ComputersUbuntuApi* | [**udm_computers_ubuntu_object_template**](docs/ComputersUbuntuApi.md#udm_computers_ubuntu_object_template) | **GET** /computers/ubuntu/add | Get a template for creating an Ubuntu Computer object (contains all properties and their default values)
*ComputersUbuntuApi* | [**udm_computers_ubuntu_object_update**](docs/ComputersUbuntuApi.md#udm_computers_ubuntu_object_update) | **PATCH** /computers/ubuntu/{dn} | Modify an Ubuntu Computer object (moving is currently not possible)
*ComputersWindowsApi* | [**udm_computers_windows_object**](docs/ComputersWindowsApi.md#udm_computers_windows_object) | **GET** /computers/windows/{dn} |  Get a representation of the Windows Workstation/Server object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*ComputersWindowsApi* | [**udm_computers_windows_object_create**](docs/ComputersWindowsApi.md#udm_computers_windows_object_create) | **POST** /computers/windows/ | Create a new Windows Workstation/Server object
*ComputersWindowsApi* | [**udm_computers_windows_object_modify**](docs/ComputersWindowsApi.md#udm_computers_windows_object_modify) | **PUT** /computers/windows/{dn} | Modify or move an Windows Workstation/Server object
*ComputersWindowsApi* | [**udm_computers_windows_object_remove**](docs/ComputersWindowsApi.md#udm_computers_windows_object_remove) | **DELETE** /computers/windows/{dn} | Remove a Windows Workstations/Servers object
*ComputersWindowsApi* | [**udm_computers_windows_object_search**](docs/ComputersWindowsApi.md#udm_computers_windows_object_search) | **GET** /computers/windows/ | Search for Windows Workstations/Servers objects
*ComputersWindowsApi* | [**udm_computers_windows_object_template**](docs/ComputersWindowsApi.md#udm_computers_windows_object_template) | **GET** /computers/windows/add | Get a template for creating an Windows Workstation/Server object (contains all properties and their default values)
*ComputersWindowsApi* | [**udm_computers_windows_object_update**](docs/ComputersWindowsApi.md#udm_computers_windows_object_update) | **PATCH** /computers/windows/{dn} | Modify an Windows Workstation/Server object (moving is currently not possible)
*ComputersWindowsDomaincontrollerApi* | [**udm_computers_windows_domaincontroller_object**](docs/ComputersWindowsDomaincontrollerApi.md#udm_computers_windows_domaincontroller_object) | **GET** /computers/windows_domaincontroller/{dn} |  Get a representation of the Windows Domaincontroller object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*ComputersWindowsDomaincontrollerApi* | [**udm_computers_windows_domaincontroller_object_create**](docs/ComputersWindowsDomaincontrollerApi.md#udm_computers_windows_domaincontroller_object_create) | **POST** /computers/windows_domaincontroller/ | Create a new Windows Domaincontroller object
*ComputersWindowsDomaincontrollerApi* | [**udm_computers_windows_domaincontroller_object_modify**](docs/ComputersWindowsDomaincontrollerApi.md#udm_computers_windows_domaincontroller_object_modify) | **PUT** /computers/windows_domaincontroller/{dn} | Modify or move an Windows Domaincontroller object
*ComputersWindowsDomaincontrollerApi* | [**udm_computers_windows_domaincontroller_object_remove**](docs/ComputersWindowsDomaincontrollerApi.md#udm_computers_windows_domaincontroller_object_remove) | **DELETE** /computers/windows_domaincontroller/{dn} | Remove a Windows Domaincontrollers object
*ComputersWindowsDomaincontrollerApi* | [**udm_computers_windows_domaincontroller_object_search**](docs/ComputersWindowsDomaincontrollerApi.md#udm_computers_windows_domaincontroller_object_search) | **GET** /computers/windows_domaincontroller/ | Search for Windows Domaincontrollers objects
*ComputersWindowsDomaincontrollerApi* | [**udm_computers_windows_domaincontroller_object_template**](docs/ComputersWindowsDomaincontrollerApi.md#udm_computers_windows_domaincontroller_object_template) | **GET** /computers/windows_domaincontroller/add | Get a template for creating an Windows Domaincontroller object (contains all properties and their default values)
*ComputersWindowsDomaincontrollerApi* | [**udm_computers_windows_domaincontroller_object_update**](docs/ComputersWindowsDomaincontrollerApi.md#udm_computers_windows_domaincontroller_object_update) | **PATCH** /computers/windows_domaincontroller/{dn} | Modify an Windows Domaincontroller object (moving is currently not possible)
*ContainerCnApi* | [**udm_container_cn_object**](docs/ContainerCnApi.md#udm_container_cn_object) | **GET** /container/cn/{dn} |  Get a representation of the Container object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*ContainerCnApi* | [**udm_container_cn_object_create**](docs/ContainerCnApi.md#udm_container_cn_object_create) | **POST** /container/cn/ | Create a new Container object
*ContainerCnApi* | [**udm_container_cn_object_modify**](docs/ContainerCnApi.md#udm_container_cn_object_modify) | **PUT** /container/cn/{dn} | Modify or move an Container object
*ContainerCnApi* | [**udm_container_cn_object_remove**](docs/ContainerCnApi.md#udm_container_cn_object_remove) | **DELETE** /container/cn/{dn} | Remove a Containers object
*ContainerCnApi* | [**udm_container_cn_object_search**](docs/ContainerCnApi.md#udm_container_cn_object_search) | **GET** /container/cn/ | Search for Containers objects
*ContainerCnApi* | [**udm_container_cn_object_template**](docs/ContainerCnApi.md#udm_container_cn_object_template) | **GET** /container/cn/add | Get a template for creating an Container object (contains all properties and their default values)
*ContainerCnApi* | [**udm_container_cn_object_update**](docs/ContainerCnApi.md#udm_container_cn_object_update) | **PATCH** /container/cn/{dn} | Modify an Container object (moving is currently not possible)
*ContainerDcApi* | [**udm_container_dc_object**](docs/ContainerDcApi.md#udm_container_dc_object) | **GET** /container/dc/{dn} |  Get a representation of the Domain Container object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*ContainerDcApi* | [**udm_container_dc_object_modify**](docs/ContainerDcApi.md#udm_container_dc_object_modify) | **PUT** /container/dc/{dn} | Modify or move an Domain Container object
*ContainerDcApi* | [**udm_container_dc_object_search**](docs/ContainerDcApi.md#udm_container_dc_object_search) | **GET** /container/dc/ | Search for Domain Containers objects
*ContainerDcApi* | [**udm_container_dc_object_update**](docs/ContainerDcApi.md#udm_container_dc_object_update) | **PATCH** /container/dc/{dn} | Modify an Domain Container object (moving is currently not possible)
*ContainerMsgpoApi* | [**udm_container_msgpo_object**](docs/ContainerMsgpoApi.md#udm_container_msgpo_object) | **GET** /container/msgpo/{dn} |  Get a representation of the Container: MS Group Policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*ContainerMsgpoApi* | [**udm_container_msgpo_object_create**](docs/ContainerMsgpoApi.md#udm_container_msgpo_object_create) | **POST** /container/msgpo/ | Create a new Container: MS Group Policy object
*ContainerMsgpoApi* | [**udm_container_msgpo_object_modify**](docs/ContainerMsgpoApi.md#udm_container_msgpo_object_modify) | **PUT** /container/msgpo/{dn} | Modify or move an Container: MS Group Policy object
*ContainerMsgpoApi* | [**udm_container_msgpo_object_remove**](docs/ContainerMsgpoApi.md#udm_container_msgpo_object_remove) | **DELETE** /container/msgpo/{dn} | Remove a Container: MS Group Policy object
*ContainerMsgpoApi* | [**udm_container_msgpo_object_search**](docs/ContainerMsgpoApi.md#udm_container_msgpo_object_search) | **GET** /container/msgpo/ | Search for Container: MS Group Policy objects
*ContainerMsgpoApi* | [**udm_container_msgpo_object_template**](docs/ContainerMsgpoApi.md#udm_container_msgpo_object_template) | **GET** /container/msgpo/add | Get a template for creating an Container: MS Group Policy object (contains all properties and their default values)
*ContainerMsgpoApi* | [**udm_container_msgpo_object_update**](docs/ContainerMsgpoApi.md#udm_container_msgpo_object_update) | **PATCH** /container/msgpo/{dn} | Modify an Container: MS Group Policy object (moving is currently not possible)
*ContainerOuApi* | [**udm_container_ou_object**](docs/ContainerOuApi.md#udm_container_ou_object) | **GET** /container/ou/{dn} |  Get a representation of the Organisational Unit object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*ContainerOuApi* | [**udm_container_ou_object_create**](docs/ContainerOuApi.md#udm_container_ou_object_create) | **POST** /container/ou/ | Create a new Organisational Unit object
*ContainerOuApi* | [**udm_container_ou_object_modify**](docs/ContainerOuApi.md#udm_container_ou_object_modify) | **PUT** /container/ou/{dn} | Modify or move an Organisational Unit object
*ContainerOuApi* | [**udm_container_ou_object_remove**](docs/ContainerOuApi.md#udm_container_ou_object_remove) | **DELETE** /container/ou/{dn} | Remove a Organisational Units object
*ContainerOuApi* | [**udm_container_ou_object_search**](docs/ContainerOuApi.md#udm_container_ou_object_search) | **GET** /container/ou/ | Search for Organisational Units objects
*ContainerOuApi* | [**udm_container_ou_object_template**](docs/ContainerOuApi.md#udm_container_ou_object_template) | **GET** /container/ou/add | Get a template for creating an Organisational Unit object (contains all properties and their default values)
*ContainerOuApi* | [**udm_container_ou_object_update**](docs/ContainerOuApi.md#udm_container_ou_object_update) | **PATCH** /container/ou/{dn} | Modify an Organisational Unit object (moving is currently not possible)
*DhcpDhcpApi* | [**udm_dhcp_dhcp_object**](docs/DhcpDhcpApi.md#udm_dhcp_dhcp_object) | **GET** /dhcp/dhcp/{dn} |  Get a representation of the DHCP service object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*DhcpDhcpApi* | [**udm_dhcp_dhcp_object_search**](docs/DhcpDhcpApi.md#udm_dhcp_dhcp_object_search) | **GET** /dhcp/dhcp/ | Search for DHCP services objects
*DhcpHostApi* | [**udm_dhcp_host_object**](docs/DhcpHostApi.md#udm_dhcp_host_object) | **GET** /dhcp/host/{dn} |  Get a representation of the DHCP host object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*DhcpHostApi* | [**udm_dhcp_host_object_create**](docs/DhcpHostApi.md#udm_dhcp_host_object_create) | **POST** /dhcp/host/ | Create a new DHCP host object
*DhcpHostApi* | [**udm_dhcp_host_object_modify**](docs/DhcpHostApi.md#udm_dhcp_host_object_modify) | **PUT** /dhcp/host/{dn} | Modify or move an DHCP host object
*DhcpHostApi* | [**udm_dhcp_host_object_remove**](docs/DhcpHostApi.md#udm_dhcp_host_object_remove) | **DELETE** /dhcp/host/{dn} | Remove a DHCP hosts object
*DhcpHostApi* | [**udm_dhcp_host_object_search**](docs/DhcpHostApi.md#udm_dhcp_host_object_search) | **GET** /dhcp/host/ | Search for DHCP hosts objects
*DhcpHostApi* | [**udm_dhcp_host_object_template**](docs/DhcpHostApi.md#udm_dhcp_host_object_template) | **GET** /dhcp/host/add | Get a template for creating an DHCP host object (contains all properties and their default values)
*DhcpHostApi* | [**udm_dhcp_host_object_update**](docs/DhcpHostApi.md#udm_dhcp_host_object_update) | **PATCH** /dhcp/host/{dn} | Modify an DHCP host object (moving is currently not possible)
*DhcpPoolApi* | [**udm_dhcp_pool_object**](docs/DhcpPoolApi.md#udm_dhcp_pool_object) | **GET** /dhcp/pool/{dn} |  Get a representation of the DHCP pool object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*DhcpPoolApi* | [**udm_dhcp_pool_object_create**](docs/DhcpPoolApi.md#udm_dhcp_pool_object_create) | **POST** /dhcp/pool/ | Create a new DHCP pool object
*DhcpPoolApi* | [**udm_dhcp_pool_object_modify**](docs/DhcpPoolApi.md#udm_dhcp_pool_object_modify) | **PUT** /dhcp/pool/{dn} | Modify or move an DHCP pool object
*DhcpPoolApi* | [**udm_dhcp_pool_object_remove**](docs/DhcpPoolApi.md#udm_dhcp_pool_object_remove) | **DELETE** /dhcp/pool/{dn} | Remove a DHCP pools object
*DhcpPoolApi* | [**udm_dhcp_pool_object_search**](docs/DhcpPoolApi.md#udm_dhcp_pool_object_search) | **GET** /dhcp/pool/ | Search for DHCP pools objects
*DhcpPoolApi* | [**udm_dhcp_pool_object_template**](docs/DhcpPoolApi.md#udm_dhcp_pool_object_template) | **GET** /dhcp/pool/add | Get a template for creating an DHCP pool object (contains all properties and their default values)
*DhcpPoolApi* | [**udm_dhcp_pool_object_update**](docs/DhcpPoolApi.md#udm_dhcp_pool_object_update) | **PATCH** /dhcp/pool/{dn} | Modify an DHCP pool object (moving is currently not possible)
*DhcpServerApi* | [**udm_dhcp_server_object**](docs/DhcpServerApi.md#udm_dhcp_server_object) | **GET** /dhcp/server/{dn} |  Get a representation of the DHCP server object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*DhcpServerApi* | [**udm_dhcp_server_object_create**](docs/DhcpServerApi.md#udm_dhcp_server_object_create) | **POST** /dhcp/server/ | Create a new DHCP server object
*DhcpServerApi* | [**udm_dhcp_server_object_modify**](docs/DhcpServerApi.md#udm_dhcp_server_object_modify) | **PUT** /dhcp/server/{dn} | Modify or move an DHCP server object
*DhcpServerApi* | [**udm_dhcp_server_object_remove**](docs/DhcpServerApi.md#udm_dhcp_server_object_remove) | **DELETE** /dhcp/server/{dn} | Remove a DHCP servers object
*DhcpServerApi* | [**udm_dhcp_server_object_search**](docs/DhcpServerApi.md#udm_dhcp_server_object_search) | **GET** /dhcp/server/ | Search for DHCP servers objects
*DhcpServerApi* | [**udm_dhcp_server_object_template**](docs/DhcpServerApi.md#udm_dhcp_server_object_template) | **GET** /dhcp/server/add | Get a template for creating an DHCP server object (contains all properties and their default values)
*DhcpServerApi* | [**udm_dhcp_server_object_update**](docs/DhcpServerApi.md#udm_dhcp_server_object_update) | **PATCH** /dhcp/server/{dn} | Modify an DHCP server object (moving is currently not possible)
*DhcpServiceApi* | [**udm_dhcp_service_object**](docs/DhcpServiceApi.md#udm_dhcp_service_object) | **GET** /dhcp/service/{dn} |  Get a representation of the DHCP service object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*DhcpServiceApi* | [**udm_dhcp_service_object_create**](docs/DhcpServiceApi.md#udm_dhcp_service_object_create) | **POST** /dhcp/service/ | Create a new DHCP service object
*DhcpServiceApi* | [**udm_dhcp_service_object_modify**](docs/DhcpServiceApi.md#udm_dhcp_service_object_modify) | **PUT** /dhcp/service/{dn} | Modify or move an DHCP service object
*DhcpServiceApi* | [**udm_dhcp_service_object_remove**](docs/DhcpServiceApi.md#udm_dhcp_service_object_remove) | **DELETE** /dhcp/service/{dn} | Remove a DHCP services object
*DhcpServiceApi* | [**udm_dhcp_service_object_search**](docs/DhcpServiceApi.md#udm_dhcp_service_object_search) | **GET** /dhcp/service/ | Search for DHCP services objects
*DhcpServiceApi* | [**udm_dhcp_service_object_template**](docs/DhcpServiceApi.md#udm_dhcp_service_object_template) | **GET** /dhcp/service/add | Get a template for creating an DHCP service object (contains all properties and their default values)
*DhcpServiceApi* | [**udm_dhcp_service_object_update**](docs/DhcpServiceApi.md#udm_dhcp_service_object_update) | **PATCH** /dhcp/service/{dn} | Modify an DHCP service object (moving is currently not possible)
*DhcpSharedApi* | [**udm_dhcp_shared_object**](docs/DhcpSharedApi.md#udm_dhcp_shared_object) | **GET** /dhcp/shared/{dn} |  Get a representation of the Shared network object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*DhcpSharedApi* | [**udm_dhcp_shared_object_create**](docs/DhcpSharedApi.md#udm_dhcp_shared_object_create) | **POST** /dhcp/shared/ | Create a new Shared network object
*DhcpSharedApi* | [**udm_dhcp_shared_object_modify**](docs/DhcpSharedApi.md#udm_dhcp_shared_object_modify) | **PUT** /dhcp/shared/{dn} | Modify or move an Shared network object
*DhcpSharedApi* | [**udm_dhcp_shared_object_remove**](docs/DhcpSharedApi.md#udm_dhcp_shared_object_remove) | **DELETE** /dhcp/shared/{dn} | Remove a Shared network object
*DhcpSharedApi* | [**udm_dhcp_shared_object_search**](docs/DhcpSharedApi.md#udm_dhcp_shared_object_search) | **GET** /dhcp/shared/ | Search for Shared network objects
*DhcpSharedApi* | [**udm_dhcp_shared_object_template**](docs/DhcpSharedApi.md#udm_dhcp_shared_object_template) | **GET** /dhcp/shared/add | Get a template for creating an Shared network object (contains all properties and their default values)
*DhcpSharedApi* | [**udm_dhcp_shared_object_update**](docs/DhcpSharedApi.md#udm_dhcp_shared_object_update) | **PATCH** /dhcp/shared/{dn} | Modify an Shared network object (moving is currently not possible)
*DhcpSharedsubnetApi* | [**udm_dhcp_sharedsubnet_object**](docs/DhcpSharedsubnetApi.md#udm_dhcp_sharedsubnet_object) | **GET** /dhcp/sharedsubnet/{dn} |  Get a representation of the Shared DHCP subnet object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*DhcpSharedsubnetApi* | [**udm_dhcp_sharedsubnet_object_create**](docs/DhcpSharedsubnetApi.md#udm_dhcp_sharedsubnet_object_create) | **POST** /dhcp/sharedsubnet/ | Create a new Shared DHCP subnet object
*DhcpSharedsubnetApi* | [**udm_dhcp_sharedsubnet_object_modify**](docs/DhcpSharedsubnetApi.md#udm_dhcp_sharedsubnet_object_modify) | **PUT** /dhcp/sharedsubnet/{dn} | Modify or move an Shared DHCP subnet object
*DhcpSharedsubnetApi* | [**udm_dhcp_sharedsubnet_object_remove**](docs/DhcpSharedsubnetApi.md#udm_dhcp_sharedsubnet_object_remove) | **DELETE** /dhcp/sharedsubnet/{dn} | Remove a Shared DHCP subnets object
*DhcpSharedsubnetApi* | [**udm_dhcp_sharedsubnet_object_search**](docs/DhcpSharedsubnetApi.md#udm_dhcp_sharedsubnet_object_search) | **GET** /dhcp/sharedsubnet/ | Search for Shared DHCP subnets objects
*DhcpSharedsubnetApi* | [**udm_dhcp_sharedsubnet_object_template**](docs/DhcpSharedsubnetApi.md#udm_dhcp_sharedsubnet_object_template) | **GET** /dhcp/sharedsubnet/add | Get a template for creating an Shared DHCP subnet object (contains all properties and their default values)
*DhcpSharedsubnetApi* | [**udm_dhcp_sharedsubnet_object_update**](docs/DhcpSharedsubnetApi.md#udm_dhcp_sharedsubnet_object_update) | **PATCH** /dhcp/sharedsubnet/{dn} | Modify an Shared DHCP subnet object (moving is currently not possible)
*DhcpSubnetApi* | [**udm_dhcp_subnet_object**](docs/DhcpSubnetApi.md#udm_dhcp_subnet_object) | **GET** /dhcp/subnet/{dn} |  Get a representation of the DHCP subnet object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*DhcpSubnetApi* | [**udm_dhcp_subnet_object_create**](docs/DhcpSubnetApi.md#udm_dhcp_subnet_object_create) | **POST** /dhcp/subnet/ | Create a new DHCP subnet object
*DhcpSubnetApi* | [**udm_dhcp_subnet_object_modify**](docs/DhcpSubnetApi.md#udm_dhcp_subnet_object_modify) | **PUT** /dhcp/subnet/{dn} | Modify or move an DHCP subnet object
*DhcpSubnetApi* | [**udm_dhcp_subnet_object_remove**](docs/DhcpSubnetApi.md#udm_dhcp_subnet_object_remove) | **DELETE** /dhcp/subnet/{dn} | Remove a DHCP subnets object
*DhcpSubnetApi* | [**udm_dhcp_subnet_object_search**](docs/DhcpSubnetApi.md#udm_dhcp_subnet_object_search) | **GET** /dhcp/subnet/ | Search for DHCP subnets objects
*DhcpSubnetApi* | [**udm_dhcp_subnet_object_template**](docs/DhcpSubnetApi.md#udm_dhcp_subnet_object_template) | **GET** /dhcp/subnet/add | Get a template for creating an DHCP subnet object (contains all properties and their default values)
*DhcpSubnetApi* | [**udm_dhcp_subnet_object_update**](docs/DhcpSubnetApi.md#udm_dhcp_subnet_object_update) | **PATCH** /dhcp/subnet/{dn} | Modify an DHCP subnet object (moving is currently not possible)
*DnsAliasApi* | [**udm_dns_alias_object**](docs/DnsAliasApi.md#udm_dns_alias_object) | **GET** /dns/alias/{dn} |  Get a representation of the Alias record object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*DnsAliasApi* | [**udm_dns_alias_object_create**](docs/DnsAliasApi.md#udm_dns_alias_object_create) | **POST** /dns/alias/ | Create a new Alias record object
*DnsAliasApi* | [**udm_dns_alias_object_modify**](docs/DnsAliasApi.md#udm_dns_alias_object_modify) | **PUT** /dns/alias/{dn} | Modify or move an Alias record object
*DnsAliasApi* | [**udm_dns_alias_object_remove**](docs/DnsAliasApi.md#udm_dns_alias_object_remove) | **DELETE** /dns/alias/{dn} | Remove a Alias records object
*DnsAliasApi* | [**udm_dns_alias_object_search**](docs/DnsAliasApi.md#udm_dns_alias_object_search) | **GET** /dns/alias/ | Search for Alias records objects
*DnsAliasApi* | [**udm_dns_alias_object_template**](docs/DnsAliasApi.md#udm_dns_alias_object_template) | **GET** /dns/alias/add | Get a template for creating an Alias record object (contains all properties and their default values)
*DnsAliasApi* | [**udm_dns_alias_object_update**](docs/DnsAliasApi.md#udm_dns_alias_object_update) | **PATCH** /dns/alias/{dn} | Modify an Alias record object (moving is currently not possible)
*DnsDnsApi* | [**udm_dns_dns_object**](docs/DnsDnsApi.md#udm_dns_dns_object) | **GET** /dns/dns/{dn} |  Get a representation of the DNS zone object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*DnsDnsApi* | [**udm_dns_dns_object_search**](docs/DnsDnsApi.md#udm_dns_dns_object_search) | **GET** /dns/dns/ | Search for DNS zones objects
*DnsForwardZoneApi* | [**udm_dns_forward_zone_object**](docs/DnsForwardZoneApi.md#udm_dns_forward_zone_object) | **GET** /dns/forward_zone/{dn} |  Get a representation of the Forward lookup zone object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*DnsForwardZoneApi* | [**udm_dns_forward_zone_object_create**](docs/DnsForwardZoneApi.md#udm_dns_forward_zone_object_create) | **POST** /dns/forward_zone/ | Create a new Forward lookup zone object
*DnsForwardZoneApi* | [**udm_dns_forward_zone_object_modify**](docs/DnsForwardZoneApi.md#udm_dns_forward_zone_object_modify) | **PUT** /dns/forward_zone/{dn} | Modify or move an Forward lookup zone object
*DnsForwardZoneApi* | [**udm_dns_forward_zone_object_remove**](docs/DnsForwardZoneApi.md#udm_dns_forward_zone_object_remove) | **DELETE** /dns/forward_zone/{dn} | Remove a Forward lookup zones object
*DnsForwardZoneApi* | [**udm_dns_forward_zone_object_search**](docs/DnsForwardZoneApi.md#udm_dns_forward_zone_object_search) | **GET** /dns/forward_zone/ | Search for Forward lookup zones objects
*DnsForwardZoneApi* | [**udm_dns_forward_zone_object_template**](docs/DnsForwardZoneApi.md#udm_dns_forward_zone_object_template) | **GET** /dns/forward_zone/add | Get a template for creating an Forward lookup zone object (contains all properties and their default values)
*DnsForwardZoneApi* | [**udm_dns_forward_zone_object_update**](docs/DnsForwardZoneApi.md#udm_dns_forward_zone_object_update) | **PATCH** /dns/forward_zone/{dn} | Modify an Forward lookup zone object (moving is currently not possible)
*DnsHostRecordApi* | [**udm_dns_host_record_object**](docs/DnsHostRecordApi.md#udm_dns_host_record_object) | **GET** /dns/host_record/{dn} |  Get a representation of the Host record object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*DnsHostRecordApi* | [**udm_dns_host_record_object_create**](docs/DnsHostRecordApi.md#udm_dns_host_record_object_create) | **POST** /dns/host_record/ | Create a new Host record object
*DnsHostRecordApi* | [**udm_dns_host_record_object_modify**](docs/DnsHostRecordApi.md#udm_dns_host_record_object_modify) | **PUT** /dns/host_record/{dn} | Modify or move an Host record object
*DnsHostRecordApi* | [**udm_dns_host_record_object_remove**](docs/DnsHostRecordApi.md#udm_dns_host_record_object_remove) | **DELETE** /dns/host_record/{dn} | Remove a Host records object
*DnsHostRecordApi* | [**udm_dns_host_record_object_search**](docs/DnsHostRecordApi.md#udm_dns_host_record_object_search) | **GET** /dns/host_record/ | Search for Host records objects
*DnsHostRecordApi* | [**udm_dns_host_record_object_template**](docs/DnsHostRecordApi.md#udm_dns_host_record_object_template) | **GET** /dns/host_record/add | Get a template for creating an Host record object (contains all properties and their default values)
*DnsHostRecordApi* | [**udm_dns_host_record_object_update**](docs/DnsHostRecordApi.md#udm_dns_host_record_object_update) | **PATCH** /dns/host_record/{dn} | Modify an Host record object (moving is currently not possible)
*DnsNsRecordApi* | [**udm_dns_ns_record_object**](docs/DnsNsRecordApi.md#udm_dns_ns_record_object) | **GET** /dns/ns_record/{dn} |  Get a representation of the Nameserver record object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*DnsNsRecordApi* | [**udm_dns_ns_record_object_create**](docs/DnsNsRecordApi.md#udm_dns_ns_record_object_create) | **POST** /dns/ns_record/ | Create a new Nameserver record object
*DnsNsRecordApi* | [**udm_dns_ns_record_object_modify**](docs/DnsNsRecordApi.md#udm_dns_ns_record_object_modify) | **PUT** /dns/ns_record/{dn} | Modify or move an Nameserver record object
*DnsNsRecordApi* | [**udm_dns_ns_record_object_remove**](docs/DnsNsRecordApi.md#udm_dns_ns_record_object_remove) | **DELETE** /dns/ns_record/{dn} | Remove a Nameserver records object
*DnsNsRecordApi* | [**udm_dns_ns_record_object_search**](docs/DnsNsRecordApi.md#udm_dns_ns_record_object_search) | **GET** /dns/ns_record/ | Search for Nameserver records objects
*DnsNsRecordApi* | [**udm_dns_ns_record_object_template**](docs/DnsNsRecordApi.md#udm_dns_ns_record_object_template) | **GET** /dns/ns_record/add | Get a template for creating an Nameserver record object (contains all properties and their default values)
*DnsNsRecordApi* | [**udm_dns_ns_record_object_update**](docs/DnsNsRecordApi.md#udm_dns_ns_record_object_update) | **PATCH** /dns/ns_record/{dn} | Modify an Nameserver record object (moving is currently not possible)
*DnsPtrRecordApi* | [**udm_dns_ptr_record_object**](docs/DnsPtrRecordApi.md#udm_dns_ptr_record_object) | **GET** /dns/ptr_record/{dn} |  Get a representation of the Pointer record object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*DnsPtrRecordApi* | [**udm_dns_ptr_record_object_create**](docs/DnsPtrRecordApi.md#udm_dns_ptr_record_object_create) | **POST** /dns/ptr_record/ | Create a new Pointer record object
*DnsPtrRecordApi* | [**udm_dns_ptr_record_object_modify**](docs/DnsPtrRecordApi.md#udm_dns_ptr_record_object_modify) | **PUT** /dns/ptr_record/{dn} | Modify or move an Pointer record object
*DnsPtrRecordApi* | [**udm_dns_ptr_record_object_remove**](docs/DnsPtrRecordApi.md#udm_dns_ptr_record_object_remove) | **DELETE** /dns/ptr_record/{dn} | Remove a Pointer records object
*DnsPtrRecordApi* | [**udm_dns_ptr_record_object_search**](docs/DnsPtrRecordApi.md#udm_dns_ptr_record_object_search) | **GET** /dns/ptr_record/ | Search for Pointer records objects
*DnsPtrRecordApi* | [**udm_dns_ptr_record_object_template**](docs/DnsPtrRecordApi.md#udm_dns_ptr_record_object_template) | **GET** /dns/ptr_record/add | Get a template for creating an Pointer record object (contains all properties and their default values)
*DnsPtrRecordApi* | [**udm_dns_ptr_record_object_update**](docs/DnsPtrRecordApi.md#udm_dns_ptr_record_object_update) | **PATCH** /dns/ptr_record/{dn} | Modify an Pointer record object (moving is currently not possible)
*DnsReverseZoneApi* | [**udm_dns_reverse_zone_object**](docs/DnsReverseZoneApi.md#udm_dns_reverse_zone_object) | **GET** /dns/reverse_zone/{dn} |  Get a representation of the Reverse lookup zone object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*DnsReverseZoneApi* | [**udm_dns_reverse_zone_object_create**](docs/DnsReverseZoneApi.md#udm_dns_reverse_zone_object_create) | **POST** /dns/reverse_zone/ | Create a new Reverse lookup zone object
*DnsReverseZoneApi* | [**udm_dns_reverse_zone_object_modify**](docs/DnsReverseZoneApi.md#udm_dns_reverse_zone_object_modify) | **PUT** /dns/reverse_zone/{dn} | Modify or move an Reverse lookup zone object
*DnsReverseZoneApi* | [**udm_dns_reverse_zone_object_remove**](docs/DnsReverseZoneApi.md#udm_dns_reverse_zone_object_remove) | **DELETE** /dns/reverse_zone/{dn} | Remove a Reverse lookup zones object
*DnsReverseZoneApi* | [**udm_dns_reverse_zone_object_search**](docs/DnsReverseZoneApi.md#udm_dns_reverse_zone_object_search) | **GET** /dns/reverse_zone/ | Search for Reverse lookup zones objects
*DnsReverseZoneApi* | [**udm_dns_reverse_zone_object_template**](docs/DnsReverseZoneApi.md#udm_dns_reverse_zone_object_template) | **GET** /dns/reverse_zone/add | Get a template for creating an Reverse lookup zone object (contains all properties and their default values)
*DnsReverseZoneApi* | [**udm_dns_reverse_zone_object_update**](docs/DnsReverseZoneApi.md#udm_dns_reverse_zone_object_update) | **PATCH** /dns/reverse_zone/{dn} | Modify an Reverse lookup zone object (moving is currently not possible)
*DnsSrvRecordApi* | [**udm_dns_srv_record_object**](docs/DnsSrvRecordApi.md#udm_dns_srv_record_object) | **GET** /dns/srv_record/{dn} |  Get a representation of the Service record object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*DnsSrvRecordApi* | [**udm_dns_srv_record_object_create**](docs/DnsSrvRecordApi.md#udm_dns_srv_record_object_create) | **POST** /dns/srv_record/ | Create a new Service record object
*DnsSrvRecordApi* | [**udm_dns_srv_record_object_modify**](docs/DnsSrvRecordApi.md#udm_dns_srv_record_object_modify) | **PUT** /dns/srv_record/{dn} | Modify or move an Service record object
*DnsSrvRecordApi* | [**udm_dns_srv_record_object_remove**](docs/DnsSrvRecordApi.md#udm_dns_srv_record_object_remove) | **DELETE** /dns/srv_record/{dn} | Remove a Service records object
*DnsSrvRecordApi* | [**udm_dns_srv_record_object_search**](docs/DnsSrvRecordApi.md#udm_dns_srv_record_object_search) | **GET** /dns/srv_record/ | Search for Service records objects
*DnsSrvRecordApi* | [**udm_dns_srv_record_object_template**](docs/DnsSrvRecordApi.md#udm_dns_srv_record_object_template) | **GET** /dns/srv_record/add | Get a template for creating an Service record object (contains all properties and their default values)
*DnsSrvRecordApi* | [**udm_dns_srv_record_object_update**](docs/DnsSrvRecordApi.md#udm_dns_srv_record_object_update) | **PATCH** /dns/srv_record/{dn} | Modify an Service record object (moving is currently not possible)
*DnsTxtRecordApi* | [**udm_dns_txt_record_object**](docs/DnsTxtRecordApi.md#udm_dns_txt_record_object) | **GET** /dns/txt_record/{dn} |  Get a representation of the TXT record object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*DnsTxtRecordApi* | [**udm_dns_txt_record_object_create**](docs/DnsTxtRecordApi.md#udm_dns_txt_record_object_create) | **POST** /dns/txt_record/ | Create a new TXT record object
*DnsTxtRecordApi* | [**udm_dns_txt_record_object_modify**](docs/DnsTxtRecordApi.md#udm_dns_txt_record_object_modify) | **PUT** /dns/txt_record/{dn} | Modify or move an TXT record object
*DnsTxtRecordApi* | [**udm_dns_txt_record_object_remove**](docs/DnsTxtRecordApi.md#udm_dns_txt_record_object_remove) | **DELETE** /dns/txt_record/{dn} | Remove a TXT record object
*DnsTxtRecordApi* | [**udm_dns_txt_record_object_search**](docs/DnsTxtRecordApi.md#udm_dns_txt_record_object_search) | **GET** /dns/txt_record/ | Search for TXT record objects
*DnsTxtRecordApi* | [**udm_dns_txt_record_object_template**](docs/DnsTxtRecordApi.md#udm_dns_txt_record_object_template) | **GET** /dns/txt_record/add | Get a template for creating an TXT record object (contains all properties and their default values)
*DnsTxtRecordApi* | [**udm_dns_txt_record_object_update**](docs/DnsTxtRecordApi.md#udm_dns_txt_record_object_update) | **PATCH** /dns/txt_record/{dn} | Modify an TXT record object (moving is currently not possible)
*GroupsGroupApi* | [**udm_groups_group_object**](docs/GroupsGroupApi.md#udm_groups_group_object) | **GET** /groups/group/{dn} |  Get a representation of the Group object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*GroupsGroupApi* | [**udm_groups_group_object_create**](docs/GroupsGroupApi.md#udm_groups_group_object_create) | **POST** /groups/group/ | Create a new Group object
*GroupsGroupApi* | [**udm_groups_group_object_modify**](docs/GroupsGroupApi.md#udm_groups_group_object_modify) | **PUT** /groups/group/{dn} | Modify or move an Group object
*GroupsGroupApi* | [**udm_groups_group_object_remove**](docs/GroupsGroupApi.md#udm_groups_group_object_remove) | **DELETE** /groups/group/{dn} | Remove a Groups object
*GroupsGroupApi* | [**udm_groups_group_object_search**](docs/GroupsGroupApi.md#udm_groups_group_object_search) | **GET** /groups/group/ | Search for Groups objects
*GroupsGroupApi* | [**udm_groups_group_object_template**](docs/GroupsGroupApi.md#udm_groups_group_object_template) | **GET** /groups/group/add | Get a template for creating an Group object (contains all properties and their default values)
*GroupsGroupApi* | [**udm_groups_group_object_update**](docs/GroupsGroupApi.md#udm_groups_group_object_update) | **PATCH** /groups/group/{dn} | Modify an Group object (moving is currently not possible)
*KerberosKdcentryApi* | [**udm_kerberos_kdcentry_object**](docs/KerberosKdcentryApi.md#udm_kerberos_kdcentry_object) | **GET** /kerberos/kdcentry/{dn} |  Get a representation of the KDC Entry object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*KerberosKdcentryApi* | [**udm_kerberos_kdcentry_object_create**](docs/KerberosKdcentryApi.md#udm_kerberos_kdcentry_object_create) | **POST** /kerberos/kdcentry/ | Create a new KDC Entry object
*KerberosKdcentryApi* | [**udm_kerberos_kdcentry_object_modify**](docs/KerberosKdcentryApi.md#udm_kerberos_kdcentry_object_modify) | **PUT** /kerberos/kdcentry/{dn} | Modify or move an KDC Entry object
*KerberosKdcentryApi* | [**udm_kerberos_kdcentry_object_remove**](docs/KerberosKdcentryApi.md#udm_kerberos_kdcentry_object_remove) | **DELETE** /kerberos/kdcentry/{dn} | Remove a KDC Entries object
*KerberosKdcentryApi* | [**udm_kerberos_kdcentry_object_search**](docs/KerberosKdcentryApi.md#udm_kerberos_kdcentry_object_search) | **GET** /kerberos/kdcentry/ | Search for KDC Entries objects
*KerberosKdcentryApi* | [**udm_kerberos_kdcentry_object_template**](docs/KerberosKdcentryApi.md#udm_kerberos_kdcentry_object_template) | **GET** /kerberos/kdcentry/add | Get a template for creating an KDC Entry object (contains all properties and their default values)
*KerberosKdcentryApi* | [**udm_kerberos_kdcentry_object_update**](docs/KerberosKdcentryApi.md#udm_kerberos_kdcentry_object_update) | **PATCH** /kerberos/kdcentry/{dn} | Modify an KDC Entry object (moving is currently not possible)
*MailDomainApi* | [**udm_mail_domain_object**](docs/MailDomainApi.md#udm_mail_domain_object) | **GET** /mail/domain/{dn} |  Get a representation of the Mail domain object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*MailDomainApi* | [**udm_mail_domain_object_create**](docs/MailDomainApi.md#udm_mail_domain_object_create) | **POST** /mail/domain/ | Create a new Mail domain object
*MailDomainApi* | [**udm_mail_domain_object_modify**](docs/MailDomainApi.md#udm_mail_domain_object_modify) | **PUT** /mail/domain/{dn} | Modify or move an Mail domain object
*MailDomainApi* | [**udm_mail_domain_object_remove**](docs/MailDomainApi.md#udm_mail_domain_object_remove) | **DELETE** /mail/domain/{dn} | Remove a Mail domains object
*MailDomainApi* | [**udm_mail_domain_object_search**](docs/MailDomainApi.md#udm_mail_domain_object_search) | **GET** /mail/domain/ | Search for Mail domains objects
*MailDomainApi* | [**udm_mail_domain_object_template**](docs/MailDomainApi.md#udm_mail_domain_object_template) | **GET** /mail/domain/add | Get a template for creating an Mail domain object (contains all properties and their default values)
*MailDomainApi* | [**udm_mail_domain_object_update**](docs/MailDomainApi.md#udm_mail_domain_object_update) | **PATCH** /mail/domain/{dn} | Modify an Mail domain object (moving is currently not possible)
*MailFolderApi* | [**udm_mail_folder_object**](docs/MailFolderApi.md#udm_mail_folder_object) | **GET** /mail/folder/{dn} |  Get a representation of the IMAP mail folder object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*MailFolderApi* | [**udm_mail_folder_object_create**](docs/MailFolderApi.md#udm_mail_folder_object_create) | **POST** /mail/folder/ | Create a new IMAP mail folder object
*MailFolderApi* | [**udm_mail_folder_object_modify**](docs/MailFolderApi.md#udm_mail_folder_object_modify) | **PUT** /mail/folder/{dn} | Modify or move an IMAP mail folder object
*MailFolderApi* | [**udm_mail_folder_object_remove**](docs/MailFolderApi.md#udm_mail_folder_object_remove) | **DELETE** /mail/folder/{dn} | Remove a IMAP mail folders object
*MailFolderApi* | [**udm_mail_folder_object_search**](docs/MailFolderApi.md#udm_mail_folder_object_search) | **GET** /mail/folder/ | Search for IMAP mail folders objects
*MailFolderApi* | [**udm_mail_folder_object_template**](docs/MailFolderApi.md#udm_mail_folder_object_template) | **GET** /mail/folder/add | Get a template for creating an IMAP mail folder object (contains all properties and their default values)
*MailFolderApi* | [**udm_mail_folder_object_update**](docs/MailFolderApi.md#udm_mail_folder_object_update) | **PATCH** /mail/folder/{dn} | Modify an IMAP mail folder object (moving is currently not possible)
*MailListsApi* | [**udm_mail_lists_object**](docs/MailListsApi.md#udm_mail_lists_object) | **GET** /mail/lists/{dn} |  Get a representation of the Mailing list object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*MailListsApi* | [**udm_mail_lists_object_create**](docs/MailListsApi.md#udm_mail_lists_object_create) | **POST** /mail/lists/ | Create a new Mailing list object
*MailListsApi* | [**udm_mail_lists_object_modify**](docs/MailListsApi.md#udm_mail_lists_object_modify) | **PUT** /mail/lists/{dn} | Modify or move an Mailing list object
*MailListsApi* | [**udm_mail_lists_object_remove**](docs/MailListsApi.md#udm_mail_lists_object_remove) | **DELETE** /mail/lists/{dn} | Remove a Mailing lists object
*MailListsApi* | [**udm_mail_lists_object_search**](docs/MailListsApi.md#udm_mail_lists_object_search) | **GET** /mail/lists/ | Search for Mailing lists objects
*MailListsApi* | [**udm_mail_lists_object_template**](docs/MailListsApi.md#udm_mail_lists_object_template) | **GET** /mail/lists/add | Get a template for creating an Mailing list object (contains all properties and their default values)
*MailListsApi* | [**udm_mail_lists_object_update**](docs/MailListsApi.md#udm_mail_lists_object_update) | **PATCH** /mail/lists/{dn} | Modify an Mailing list object (moving is currently not possible)
*MailMailApi* | [**udm_mail_mail_object**](docs/MailMailApi.md#udm_mail_mail_object) | **GET** /mail/mail/{dn} |  Get a representation of the Mail object object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*MailMailApi* | [**udm_mail_mail_object_search**](docs/MailMailApi.md#udm_mail_mail_object_search) | **GET** /mail/mail/ | Search for Mail objects objects
*MonitoringAlertApi* | [**udm_monitoring_alert_object**](docs/MonitoringAlertApi.md#udm_monitoring_alert_object) | **GET** /monitoring/alert/{dn} |  Get a representation of the Alert object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*MonitoringAlertApi* | [**udm_monitoring_alert_object_create**](docs/MonitoringAlertApi.md#udm_monitoring_alert_object_create) | **POST** /monitoring/alert/ | Create a new Alert object
*MonitoringAlertApi* | [**udm_monitoring_alert_object_modify**](docs/MonitoringAlertApi.md#udm_monitoring_alert_object_modify) | **PUT** /monitoring/alert/{dn} | Modify or move an Alert object
*MonitoringAlertApi* | [**udm_monitoring_alert_object_remove**](docs/MonitoringAlertApi.md#udm_monitoring_alert_object_remove) | **DELETE** /monitoring/alert/{dn} | Remove a Alerts object
*MonitoringAlertApi* | [**udm_monitoring_alert_object_search**](docs/MonitoringAlertApi.md#udm_monitoring_alert_object_search) | **GET** /monitoring/alert/ | Search for Alerts objects
*MonitoringAlertApi* | [**udm_monitoring_alert_object_template**](docs/MonitoringAlertApi.md#udm_monitoring_alert_object_template) | **GET** /monitoring/alert/add | Get a template for creating an Alert object (contains all properties and their default values)
*MonitoringAlertApi* | [**udm_monitoring_alert_object_update**](docs/MonitoringAlertApi.md#udm_monitoring_alert_object_update) | **PATCH** /monitoring/alert/{dn} | Modify an Alert object (moving is currently not possible)
*MsDomainpolicyApi* | [**udm_ms_domainpolicy_object**](docs/MsDomainpolicyApi.md#udm_ms_domainpolicy_object) | **GET** /ms/domainpolicy/{dn} |  Get a representation of the MS Domain Policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*MsDomainpolicyApi* | [**udm_ms_domainpolicy_object_create**](docs/MsDomainpolicyApi.md#udm_ms_domainpolicy_object_create) | **POST** /ms/domainpolicy/ | Create a new MS Domain Policy object
*MsDomainpolicyApi* | [**udm_ms_domainpolicy_object_modify**](docs/MsDomainpolicyApi.md#udm_ms_domainpolicy_object_modify) | **PUT** /ms/domainpolicy/{dn} | Modify or move an MS Domain Policy object
*MsDomainpolicyApi* | [**udm_ms_domainpolicy_object_remove**](docs/MsDomainpolicyApi.md#udm_ms_domainpolicy_object_remove) | **DELETE** /ms/domainpolicy/{dn} | Remove a MS Domain Policy object
*MsDomainpolicyApi* | [**udm_ms_domainpolicy_object_search**](docs/MsDomainpolicyApi.md#udm_ms_domainpolicy_object_search) | **GET** /ms/domainpolicy/ | Search for MS Domain Policy objects
*MsDomainpolicyApi* | [**udm_ms_domainpolicy_object_template**](docs/MsDomainpolicyApi.md#udm_ms_domainpolicy_object_template) | **GET** /ms/domainpolicy/add | Get a template for creating an MS Domain Policy object (contains all properties and their default values)
*MsDomainpolicyApi* | [**udm_ms_domainpolicy_object_update**](docs/MsDomainpolicyApi.md#udm_ms_domainpolicy_object_update) | **PATCH** /ms/domainpolicy/{dn} | Modify an MS Domain Policy object (moving is currently not possible)
*MsGpipsecFilterApi* | [**udm_ms_gpipsec_filter_object**](docs/MsGpipsecFilterApi.md#udm_ms_gpipsec_filter_object) | **GET** /ms/gpipsec-filter/{dn} |  Get a representation of the MS IPsec policy: filter object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*MsGpipsecFilterApi* | [**udm_ms_gpipsec_filter_object_create**](docs/MsGpipsecFilterApi.md#udm_ms_gpipsec_filter_object_create) | **POST** /ms/gpipsec-filter/ | Create a new MS IPsec policy: filter object
*MsGpipsecFilterApi* | [**udm_ms_gpipsec_filter_object_modify**](docs/MsGpipsecFilterApi.md#udm_ms_gpipsec_filter_object_modify) | **PUT** /ms/gpipsec-filter/{dn} | Modify or move an MS IPsec policy: filter object
*MsGpipsecFilterApi* | [**udm_ms_gpipsec_filter_object_remove**](docs/MsGpipsecFilterApi.md#udm_ms_gpipsec_filter_object_remove) | **DELETE** /ms/gpipsec-filter/{dn} | Remove a MS IPsec policy: filter object
*MsGpipsecFilterApi* | [**udm_ms_gpipsec_filter_object_search**](docs/MsGpipsecFilterApi.md#udm_ms_gpipsec_filter_object_search) | **GET** /ms/gpipsec-filter/ | Search for MS IPsec policy: filter objects
*MsGpipsecFilterApi* | [**udm_ms_gpipsec_filter_object_template**](docs/MsGpipsecFilterApi.md#udm_ms_gpipsec_filter_object_template) | **GET** /ms/gpipsec-filter/add | Get a template for creating an MS IPsec policy: filter object (contains all properties and their default values)
*MsGpipsecFilterApi* | [**udm_ms_gpipsec_filter_object_update**](docs/MsGpipsecFilterApi.md#udm_ms_gpipsec_filter_object_update) | **PATCH** /ms/gpipsec-filter/{dn} | Modify an MS IPsec policy: filter object (moving is currently not possible)
*MsGpipsecIsakmpPolicyApi* | [**udm_ms_gpipsec_isakmp_policy_object**](docs/MsGpipsecIsakmpPolicyApi.md#udm_ms_gpipsec_isakmp_policy_object) | **GET** /ms/gpipsec-isakmp-policy/{dn} |  Get a representation of the MS IPsec policy: ISAKMP Policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*MsGpipsecIsakmpPolicyApi* | [**udm_ms_gpipsec_isakmp_policy_object_create**](docs/MsGpipsecIsakmpPolicyApi.md#udm_ms_gpipsec_isakmp_policy_object_create) | **POST** /ms/gpipsec-isakmp-policy/ | Create a new MS IPsec policy: ISAKMP Policy object
*MsGpipsecIsakmpPolicyApi* | [**udm_ms_gpipsec_isakmp_policy_object_modify**](docs/MsGpipsecIsakmpPolicyApi.md#udm_ms_gpipsec_isakmp_policy_object_modify) | **PUT** /ms/gpipsec-isakmp-policy/{dn} | Modify or move an MS IPsec policy: ISAKMP Policy object
*MsGpipsecIsakmpPolicyApi* | [**udm_ms_gpipsec_isakmp_policy_object_remove**](docs/MsGpipsecIsakmpPolicyApi.md#udm_ms_gpipsec_isakmp_policy_object_remove) | **DELETE** /ms/gpipsec-isakmp-policy/{dn} | Remove a MS IPsec policy: ISAKMP Policy object
*MsGpipsecIsakmpPolicyApi* | [**udm_ms_gpipsec_isakmp_policy_object_search**](docs/MsGpipsecIsakmpPolicyApi.md#udm_ms_gpipsec_isakmp_policy_object_search) | **GET** /ms/gpipsec-isakmp-policy/ | Search for MS IPsec policy: ISAKMP Policy objects
*MsGpipsecIsakmpPolicyApi* | [**udm_ms_gpipsec_isakmp_policy_object_template**](docs/MsGpipsecIsakmpPolicyApi.md#udm_ms_gpipsec_isakmp_policy_object_template) | **GET** /ms/gpipsec-isakmp-policy/add | Get a template for creating an MS IPsec policy: ISAKMP Policy object (contains all properties and their default values)
*MsGpipsecIsakmpPolicyApi* | [**udm_ms_gpipsec_isakmp_policy_object_update**](docs/MsGpipsecIsakmpPolicyApi.md#udm_ms_gpipsec_isakmp_policy_object_update) | **PATCH** /ms/gpipsec-isakmp-policy/{dn} | Modify an MS IPsec policy: ISAKMP Policy object (moving is currently not possible)
*MsGpipsecNegotiationPolicyApi* | [**udm_ms_gpipsec_negotiation_policy_object**](docs/MsGpipsecNegotiationPolicyApi.md#udm_ms_gpipsec_negotiation_policy_object) | **GET** /ms/gpipsec-negotiation-policy/{dn} |  Get a representation of the MS IPsec policy: Negotiation Policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*MsGpipsecNegotiationPolicyApi* | [**udm_ms_gpipsec_negotiation_policy_object_create**](docs/MsGpipsecNegotiationPolicyApi.md#udm_ms_gpipsec_negotiation_policy_object_create) | **POST** /ms/gpipsec-negotiation-policy/ | Create a new MS IPsec policy: Negotiation Policy object
*MsGpipsecNegotiationPolicyApi* | [**udm_ms_gpipsec_negotiation_policy_object_modify**](docs/MsGpipsecNegotiationPolicyApi.md#udm_ms_gpipsec_negotiation_policy_object_modify) | **PUT** /ms/gpipsec-negotiation-policy/{dn} | Modify or move an MS IPsec policy: Negotiation Policy object
*MsGpipsecNegotiationPolicyApi* | [**udm_ms_gpipsec_negotiation_policy_object_remove**](docs/MsGpipsecNegotiationPolicyApi.md#udm_ms_gpipsec_negotiation_policy_object_remove) | **DELETE** /ms/gpipsec-negotiation-policy/{dn} | Remove a MS IPsec policy: Negotiation Policy object
*MsGpipsecNegotiationPolicyApi* | [**udm_ms_gpipsec_negotiation_policy_object_search**](docs/MsGpipsecNegotiationPolicyApi.md#udm_ms_gpipsec_negotiation_policy_object_search) | **GET** /ms/gpipsec-negotiation-policy/ | Search for MS IPsec policy: Negotiation Policy objects
*MsGpipsecNegotiationPolicyApi* | [**udm_ms_gpipsec_negotiation_policy_object_template**](docs/MsGpipsecNegotiationPolicyApi.md#udm_ms_gpipsec_negotiation_policy_object_template) | **GET** /ms/gpipsec-negotiation-policy/add | Get a template for creating an MS IPsec policy: Negotiation Policy object (contains all properties and their default values)
*MsGpipsecNegotiationPolicyApi* | [**udm_ms_gpipsec_negotiation_policy_object_update**](docs/MsGpipsecNegotiationPolicyApi.md#udm_ms_gpipsec_negotiation_policy_object_update) | **PATCH** /ms/gpipsec-negotiation-policy/{dn} | Modify an MS IPsec policy: Negotiation Policy object (moving is currently not possible)
*MsGpipsecNfaApi* | [**udm_ms_gpipsec_nfa_object**](docs/MsGpipsecNfaApi.md#udm_ms_gpipsec_nfa_object) | **GET** /ms/gpipsec-nfa/{dn} |  Get a representation of the MS IPsec policy: NFA object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*MsGpipsecNfaApi* | [**udm_ms_gpipsec_nfa_object_create**](docs/MsGpipsecNfaApi.md#udm_ms_gpipsec_nfa_object_create) | **POST** /ms/gpipsec-nfa/ | Create a new MS IPsec policy: NFA object
*MsGpipsecNfaApi* | [**udm_ms_gpipsec_nfa_object_modify**](docs/MsGpipsecNfaApi.md#udm_ms_gpipsec_nfa_object_modify) | **PUT** /ms/gpipsec-nfa/{dn} | Modify or move an MS IPsec policy: NFA object
*MsGpipsecNfaApi* | [**udm_ms_gpipsec_nfa_object_remove**](docs/MsGpipsecNfaApi.md#udm_ms_gpipsec_nfa_object_remove) | **DELETE** /ms/gpipsec-nfa/{dn} | Remove a MS IPsec policy: NFA object
*MsGpipsecNfaApi* | [**udm_ms_gpipsec_nfa_object_search**](docs/MsGpipsecNfaApi.md#udm_ms_gpipsec_nfa_object_search) | **GET** /ms/gpipsec-nfa/ | Search for MS IPsec policy: NFA objects
*MsGpipsecNfaApi* | [**udm_ms_gpipsec_nfa_object_template**](docs/MsGpipsecNfaApi.md#udm_ms_gpipsec_nfa_object_template) | **GET** /ms/gpipsec-nfa/add | Get a template for creating an MS IPsec policy: NFA object (contains all properties and their default values)
*MsGpipsecNfaApi* | [**udm_ms_gpipsec_nfa_object_update**](docs/MsGpipsecNfaApi.md#udm_ms_gpipsec_nfa_object_update) | **PATCH** /ms/gpipsec-nfa/{dn} | Modify an MS IPsec policy: NFA object (moving is currently not possible)
*MsGpipsecPolicyApi* | [**udm_ms_gpipsec_policy_object**](docs/MsGpipsecPolicyApi.md#udm_ms_gpipsec_policy_object) | **GET** /ms/gpipsec-policy/{dn} |  Get a representation of the MS IPsec policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*MsGpipsecPolicyApi* | [**udm_ms_gpipsec_policy_object_create**](docs/MsGpipsecPolicyApi.md#udm_ms_gpipsec_policy_object_create) | **POST** /ms/gpipsec-policy/ | Create a new MS IPsec policy object
*MsGpipsecPolicyApi* | [**udm_ms_gpipsec_policy_object_modify**](docs/MsGpipsecPolicyApi.md#udm_ms_gpipsec_policy_object_modify) | **PUT** /ms/gpipsec-policy/{dn} | Modify or move an MS IPsec policy object
*MsGpipsecPolicyApi* | [**udm_ms_gpipsec_policy_object_remove**](docs/MsGpipsecPolicyApi.md#udm_ms_gpipsec_policy_object_remove) | **DELETE** /ms/gpipsec-policy/{dn} | Remove a MS IPsec policy object
*MsGpipsecPolicyApi* | [**udm_ms_gpipsec_policy_object_search**](docs/MsGpipsecPolicyApi.md#udm_ms_gpipsec_policy_object_search) | **GET** /ms/gpipsec-policy/ | Search for MS IPsec policy objects
*MsGpipsecPolicyApi* | [**udm_ms_gpipsec_policy_object_template**](docs/MsGpipsecPolicyApi.md#udm_ms_gpipsec_policy_object_template) | **GET** /ms/gpipsec-policy/add | Get a template for creating an MS IPsec policy object (contains all properties and their default values)
*MsGpipsecPolicyApi* | [**udm_ms_gpipsec_policy_object_update**](docs/MsGpipsecPolicyApi.md#udm_ms_gpipsec_policy_object_update) | **PATCH** /ms/gpipsec-policy/{dn} | Modify an MS IPsec policy object (moving is currently not possible)
*MsGpsiCategoryRegistrationApi* | [**udm_ms_gpsi_category_registration_object**](docs/MsGpsiCategoryRegistrationApi.md#udm_ms_gpsi_category_registration_object) | **GET** /ms/gpsi-category-registration/{dn} |  Get a representation of the MS Software Installation Group Policy: Category Registration object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*MsGpsiCategoryRegistrationApi* | [**udm_ms_gpsi_category_registration_object_create**](docs/MsGpsiCategoryRegistrationApi.md#udm_ms_gpsi_category_registration_object_create) | **POST** /ms/gpsi-category-registration/ | Create a new MS Software Installation Group Policy: Category Registration object
*MsGpsiCategoryRegistrationApi* | [**udm_ms_gpsi_category_registration_object_modify**](docs/MsGpsiCategoryRegistrationApi.md#udm_ms_gpsi_category_registration_object_modify) | **PUT** /ms/gpsi-category-registration/{dn} | Modify or move an MS Software Installation Group Policy: Category Registration object
*MsGpsiCategoryRegistrationApi* | [**udm_ms_gpsi_category_registration_object_remove**](docs/MsGpsiCategoryRegistrationApi.md#udm_ms_gpsi_category_registration_object_remove) | **DELETE** /ms/gpsi-category-registration/{dn} | Remove a MS Software Installation Group Policy: Category Registration object
*MsGpsiCategoryRegistrationApi* | [**udm_ms_gpsi_category_registration_object_search**](docs/MsGpsiCategoryRegistrationApi.md#udm_ms_gpsi_category_registration_object_search) | **GET** /ms/gpsi-category-registration/ | Search for MS Software Installation Group Policy: Category Registration objects
*MsGpsiCategoryRegistrationApi* | [**udm_ms_gpsi_category_registration_object_template**](docs/MsGpsiCategoryRegistrationApi.md#udm_ms_gpsi_category_registration_object_template) | **GET** /ms/gpsi-category-registration/add | Get a template for creating an MS Software Installation Group Policy: Category Registration object (contains all properties and their default values)
*MsGpsiCategoryRegistrationApi* | [**udm_ms_gpsi_category_registration_object_update**](docs/MsGpsiCategoryRegistrationApi.md#udm_ms_gpsi_category_registration_object_update) | **PATCH** /ms/gpsi-category-registration/{dn} | Modify an MS Software Installation Group Policy: Category Registration object (moving is currently not possible)
*MsGpsiClassStoreApi* | [**udm_ms_gpsi_class_store_object**](docs/MsGpsiClassStoreApi.md#udm_ms_gpsi_class_store_object) | **GET** /ms/gpsi-class-store/{dn} |  Get a representation of the Software Installation Group Policy: Class Store object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*MsGpsiClassStoreApi* | [**udm_ms_gpsi_class_store_object_create**](docs/MsGpsiClassStoreApi.md#udm_ms_gpsi_class_store_object_create) | **POST** /ms/gpsi-class-store/ | Create a new Software Installation Group Policy: Class Store object
*MsGpsiClassStoreApi* | [**udm_ms_gpsi_class_store_object_modify**](docs/MsGpsiClassStoreApi.md#udm_ms_gpsi_class_store_object_modify) | **PUT** /ms/gpsi-class-store/{dn} | Modify or move an Software Installation Group Policy: Class Store object
*MsGpsiClassStoreApi* | [**udm_ms_gpsi_class_store_object_remove**](docs/MsGpsiClassStoreApi.md#udm_ms_gpsi_class_store_object_remove) | **DELETE** /ms/gpsi-class-store/{dn} | Remove a Software Installation Group Policy: Class Store object
*MsGpsiClassStoreApi* | [**udm_ms_gpsi_class_store_object_search**](docs/MsGpsiClassStoreApi.md#udm_ms_gpsi_class_store_object_search) | **GET** /ms/gpsi-class-store/ | Search for Software Installation Group Policy: Class Store objects
*MsGpsiClassStoreApi* | [**udm_ms_gpsi_class_store_object_template**](docs/MsGpsiClassStoreApi.md#udm_ms_gpsi_class_store_object_template) | **GET** /ms/gpsi-class-store/add | Get a template for creating an Software Installation Group Policy: Class Store object (contains all properties and their default values)
*MsGpsiClassStoreApi* | [**udm_ms_gpsi_class_store_object_update**](docs/MsGpsiClassStoreApi.md#udm_ms_gpsi_class_store_object_update) | **PATCH** /ms/gpsi-class-store/{dn} | Modify an Software Installation Group Policy: Class Store object (moving is currently not possible)
*MsGpsiPackageRegistrationApi* | [**udm_ms_gpsi_package_registration_object**](docs/MsGpsiPackageRegistrationApi.md#udm_ms_gpsi_package_registration_object) | **GET** /ms/gpsi-package-registration/{dn} |  Get a representation of the Software Installation Group Policy: Package Registration object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*MsGpsiPackageRegistrationApi* | [**udm_ms_gpsi_package_registration_object_create**](docs/MsGpsiPackageRegistrationApi.md#udm_ms_gpsi_package_registration_object_create) | **POST** /ms/gpsi-package-registration/ | Create a new Software Installation Group Policy: Package Registration object
*MsGpsiPackageRegistrationApi* | [**udm_ms_gpsi_package_registration_object_modify**](docs/MsGpsiPackageRegistrationApi.md#udm_ms_gpsi_package_registration_object_modify) | **PUT** /ms/gpsi-package-registration/{dn} | Modify or move an Software Installation Group Policy: Package Registration object
*MsGpsiPackageRegistrationApi* | [**udm_ms_gpsi_package_registration_object_remove**](docs/MsGpsiPackageRegistrationApi.md#udm_ms_gpsi_package_registration_object_remove) | **DELETE** /ms/gpsi-package-registration/{dn} | Remove a Software Installation Group Policy: Package Registration object
*MsGpsiPackageRegistrationApi* | [**udm_ms_gpsi_package_registration_object_search**](docs/MsGpsiPackageRegistrationApi.md#udm_ms_gpsi_package_registration_object_search) | **GET** /ms/gpsi-package-registration/ | Search for Software Installation Group Policy: Package Registration objects
*MsGpsiPackageRegistrationApi* | [**udm_ms_gpsi_package_registration_object_template**](docs/MsGpsiPackageRegistrationApi.md#udm_ms_gpsi_package_registration_object_template) | **GET** /ms/gpsi-package-registration/add | Get a template for creating an Software Installation Group Policy: Package Registration object (contains all properties and their default values)
*MsGpsiPackageRegistrationApi* | [**udm_ms_gpsi_package_registration_object_update**](docs/MsGpsiPackageRegistrationApi.md#udm_ms_gpsi_package_registration_object_update) | **PATCH** /ms/gpsi-package-registration/{dn} | Modify an Software Installation Group Policy: Package Registration object (moving is currently not possible)
*MsGpwlWiredApi* | [**udm_ms_gpwl_wired_object**](docs/MsGpwlWiredApi.md#udm_ms_gpwl_wired_object) | **GET** /ms/gpwl-wired/{dn} |  Get a representation of the MS wired Group Policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*MsGpwlWiredApi* | [**udm_ms_gpwl_wired_object_create**](docs/MsGpwlWiredApi.md#udm_ms_gpwl_wired_object_create) | **POST** /ms/gpwl-wired/ | Create a new MS wired Group Policy object
*MsGpwlWiredApi* | [**udm_ms_gpwl_wired_object_modify**](docs/MsGpwlWiredApi.md#udm_ms_gpwl_wired_object_modify) | **PUT** /ms/gpwl-wired/{dn} | Modify or move an MS wired Group Policy object
*MsGpwlWiredApi* | [**udm_ms_gpwl_wired_object_remove**](docs/MsGpwlWiredApi.md#udm_ms_gpwl_wired_object_remove) | **DELETE** /ms/gpwl-wired/{dn} | Remove a MS wired Group Policy object
*MsGpwlWiredApi* | [**udm_ms_gpwl_wired_object_search**](docs/MsGpwlWiredApi.md#udm_ms_gpwl_wired_object_search) | **GET** /ms/gpwl-wired/ | Search for MS wired Group Policy objects
*MsGpwlWiredApi* | [**udm_ms_gpwl_wired_object_template**](docs/MsGpwlWiredApi.md#udm_ms_gpwl_wired_object_template) | **GET** /ms/gpwl-wired/add | Get a template for creating an MS wired Group Policy object (contains all properties and their default values)
*MsGpwlWiredApi* | [**udm_ms_gpwl_wired_object_update**](docs/MsGpwlWiredApi.md#udm_ms_gpwl_wired_object_update) | **PATCH** /ms/gpwl-wired/{dn} | Modify an MS wired Group Policy object (moving is currently not possible)
*MsGpwlWirelessApi* | [**udm_ms_gpwl_wireless_object**](docs/MsGpwlWirelessApi.md#udm_ms_gpwl_wireless_object) | **GET** /ms/gpwl-wireless/{dn} |  Get a representation of the MS wireless Group Policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*MsGpwlWirelessApi* | [**udm_ms_gpwl_wireless_object_create**](docs/MsGpwlWirelessApi.md#udm_ms_gpwl_wireless_object_create) | **POST** /ms/gpwl-wireless/ | Create a new MS wireless Group Policy object
*MsGpwlWirelessApi* | [**udm_ms_gpwl_wireless_object_modify**](docs/MsGpwlWirelessApi.md#udm_ms_gpwl_wireless_object_modify) | **PUT** /ms/gpwl-wireless/{dn} | Modify or move an MS wireless Group Policy object
*MsGpwlWirelessApi* | [**udm_ms_gpwl_wireless_object_remove**](docs/MsGpwlWirelessApi.md#udm_ms_gpwl_wireless_object_remove) | **DELETE** /ms/gpwl-wireless/{dn} | Remove a MS wireless Group Policy object
*MsGpwlWirelessApi* | [**udm_ms_gpwl_wireless_object_search**](docs/MsGpwlWirelessApi.md#udm_ms_gpwl_wireless_object_search) | **GET** /ms/gpwl-wireless/ | Search for MS wireless Group Policy objects
*MsGpwlWirelessApi* | [**udm_ms_gpwl_wireless_object_template**](docs/MsGpwlWirelessApi.md#udm_ms_gpwl_wireless_object_template) | **GET** /ms/gpwl-wireless/add | Get a template for creating an MS wireless Group Policy object (contains all properties and their default values)
*MsGpwlWirelessApi* | [**udm_ms_gpwl_wireless_object_update**](docs/MsGpwlWirelessApi.md#udm_ms_gpwl_wireless_object_update) | **PATCH** /ms/gpwl-wireless/{dn} | Modify an MS wireless Group Policy object (moving is currently not possible)
*MsGpwlWirelessBlobApi* | [**udm_ms_gpwl_wireless_blob_object**](docs/MsGpwlWirelessBlobApi.md#udm_ms_gpwl_wireless_blob_object) | **GET** /ms/gpwl-wireless-blob/{dn} |  Get a representation of the MS wireless Group Policy blob object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*MsGpwlWirelessBlobApi* | [**udm_ms_gpwl_wireless_blob_object_create**](docs/MsGpwlWirelessBlobApi.md#udm_ms_gpwl_wireless_blob_object_create) | **POST** /ms/gpwl-wireless-blob/ | Create a new MS wireless Group Policy blob object
*MsGpwlWirelessBlobApi* | [**udm_ms_gpwl_wireless_blob_object_modify**](docs/MsGpwlWirelessBlobApi.md#udm_ms_gpwl_wireless_blob_object_modify) | **PUT** /ms/gpwl-wireless-blob/{dn} | Modify or move an MS wireless Group Policy blob object
*MsGpwlWirelessBlobApi* | [**udm_ms_gpwl_wireless_blob_object_remove**](docs/MsGpwlWirelessBlobApi.md#udm_ms_gpwl_wireless_blob_object_remove) | **DELETE** /ms/gpwl-wireless-blob/{dn} | Remove a MS wireless Group Policy blob object
*MsGpwlWirelessBlobApi* | [**udm_ms_gpwl_wireless_blob_object_search**](docs/MsGpwlWirelessBlobApi.md#udm_ms_gpwl_wireless_blob_object_search) | **GET** /ms/gpwl-wireless-blob/ | Search for MS wireless Group Policy blob objects
*MsGpwlWirelessBlobApi* | [**udm_ms_gpwl_wireless_blob_object_template**](docs/MsGpwlWirelessBlobApi.md#udm_ms_gpwl_wireless_blob_object_template) | **GET** /ms/gpwl-wireless-blob/add | Get a template for creating an MS wireless Group Policy blob object (contains all properties and their default values)
*MsGpwlWirelessBlobApi* | [**udm_ms_gpwl_wireless_blob_object_update**](docs/MsGpwlWirelessBlobApi.md#udm_ms_gpwl_wireless_blob_object_update) | **PATCH** /ms/gpwl-wireless-blob/{dn} | Modify an MS wireless Group Policy blob object (moving is currently not possible)
*NagiosNagiosApi* | [**udm_nagios_nagios_object**](docs/NagiosNagiosApi.md#udm_nagios_nagios_object) | **GET** /nagios/nagios/{dn} |  Get a representation of the Nagios object object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*NagiosNagiosApi* | [**udm_nagios_nagios_object_search**](docs/NagiosNagiosApi.md#udm_nagios_nagios_object_search) | **GET** /nagios/nagios/ | Search for Nagios objects objects
*NagiosServiceApi* | [**udm_nagios_service_object**](docs/NagiosServiceApi.md#udm_nagios_service_object) | **GET** /nagios/service/{dn} |  Get a representation of the Nagios service object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*NagiosServiceApi* | [**udm_nagios_service_object_create**](docs/NagiosServiceApi.md#udm_nagios_service_object_create) | **POST** /nagios/service/ | Create a new Nagios service object
*NagiosServiceApi* | [**udm_nagios_service_object_modify**](docs/NagiosServiceApi.md#udm_nagios_service_object_modify) | **PUT** /nagios/service/{dn} | Modify or move an Nagios service object
*NagiosServiceApi* | [**udm_nagios_service_object_remove**](docs/NagiosServiceApi.md#udm_nagios_service_object_remove) | **DELETE** /nagios/service/{dn} | Remove a Nagios services object
*NagiosServiceApi* | [**udm_nagios_service_object_search**](docs/NagiosServiceApi.md#udm_nagios_service_object_search) | **GET** /nagios/service/ | Search for Nagios services objects
*NagiosServiceApi* | [**udm_nagios_service_object_template**](docs/NagiosServiceApi.md#udm_nagios_service_object_template) | **GET** /nagios/service/add | Get a template for creating an Nagios service object (contains all properties and their default values)
*NagiosServiceApi* | [**udm_nagios_service_object_update**](docs/NagiosServiceApi.md#udm_nagios_service_object_update) | **PATCH** /nagios/service/{dn} | Modify an Nagios service object (moving is currently not possible)
*NagiosTimeperiodApi* | [**udm_nagios_timeperiod_object**](docs/NagiosTimeperiodApi.md#udm_nagios_timeperiod_object) | **GET** /nagios/timeperiod/{dn} |  Get a representation of the Nagios time period object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*NagiosTimeperiodApi* | [**udm_nagios_timeperiod_object_create**](docs/NagiosTimeperiodApi.md#udm_nagios_timeperiod_object_create) | **POST** /nagios/timeperiod/ | Create a new Nagios time period object
*NagiosTimeperiodApi* | [**udm_nagios_timeperiod_object_modify**](docs/NagiosTimeperiodApi.md#udm_nagios_timeperiod_object_modify) | **PUT** /nagios/timeperiod/{dn} | Modify or move an Nagios time period object
*NagiosTimeperiodApi* | [**udm_nagios_timeperiod_object_remove**](docs/NagiosTimeperiodApi.md#udm_nagios_timeperiod_object_remove) | **DELETE** /nagios/timeperiod/{dn} | Remove a Nagios time periods object
*NagiosTimeperiodApi* | [**udm_nagios_timeperiod_object_search**](docs/NagiosTimeperiodApi.md#udm_nagios_timeperiod_object_search) | **GET** /nagios/timeperiod/ | Search for Nagios time periods objects
*NagiosTimeperiodApi* | [**udm_nagios_timeperiod_object_template**](docs/NagiosTimeperiodApi.md#udm_nagios_timeperiod_object_template) | **GET** /nagios/timeperiod/add | Get a template for creating an Nagios time period object (contains all properties and their default values)
*NagiosTimeperiodApi* | [**udm_nagios_timeperiod_object_update**](docs/NagiosTimeperiodApi.md#udm_nagios_timeperiod_object_update) | **PATCH** /nagios/timeperiod/{dn} | Modify an Nagios time period object (moving is currently not possible)
*NetworksNetworkApi* | [**udm_networks_network_object**](docs/NetworksNetworkApi.md#udm_networks_network_object) | **GET** /networks/network/{dn} |  Get a representation of the Network object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*NetworksNetworkApi* | [**udm_networks_network_object_create**](docs/NetworksNetworkApi.md#udm_networks_network_object_create) | **POST** /networks/network/ | Create a new Network object
*NetworksNetworkApi* | [**udm_networks_network_object_modify**](docs/NetworksNetworkApi.md#udm_networks_network_object_modify) | **PUT** /networks/network/{dn} | Modify or move an Network object
*NetworksNetworkApi* | [**udm_networks_network_object_remove**](docs/NetworksNetworkApi.md#udm_networks_network_object_remove) | **DELETE** /networks/network/{dn} | Remove a Networks object
*NetworksNetworkApi* | [**udm_networks_network_object_search**](docs/NetworksNetworkApi.md#udm_networks_network_object_search) | **GET** /networks/network/ | Search for Networks objects
*NetworksNetworkApi* | [**udm_networks_network_object_template**](docs/NetworksNetworkApi.md#udm_networks_network_object_template) | **GET** /networks/network/add | Get a template for creating an Network object (contains all properties and their default values)
*NetworksNetworkApi* | [**udm_networks_network_object_update**](docs/NetworksNetworkApi.md#udm_networks_network_object_update) | **PATCH** /networks/network/{dn} | Modify an Network object (moving is currently not possible)
*PoliciesAdminContainerApi* | [**udm_policies_admin_container_object**](docs/PoliciesAdminContainerApi.md#udm_policies_admin_container_object) | **GET** /policies/admin_container/{dn} |  Get a representation of the Univention Directory Manager container settings policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PoliciesAdminContainerApi* | [**udm_policies_admin_container_object_create**](docs/PoliciesAdminContainerApi.md#udm_policies_admin_container_object_create) | **POST** /policies/admin_container/ | Create a new Univention Directory Manager container settings policy object
*PoliciesAdminContainerApi* | [**udm_policies_admin_container_object_modify**](docs/PoliciesAdminContainerApi.md#udm_policies_admin_container_object_modify) | **PUT** /policies/admin_container/{dn} | Modify or move an Univention Directory Manager container settings policy object
*PoliciesAdminContainerApi* | [**udm_policies_admin_container_object_remove**](docs/PoliciesAdminContainerApi.md#udm_policies_admin_container_object_remove) | **DELETE** /policies/admin_container/{dn} | Remove a Univention Directory Manager container settings policies object
*PoliciesAdminContainerApi* | [**udm_policies_admin_container_object_search**](docs/PoliciesAdminContainerApi.md#udm_policies_admin_container_object_search) | **GET** /policies/admin_container/ | Search for Univention Directory Manager container settings policies objects
*PoliciesAdminContainerApi* | [**udm_policies_admin_container_object_template**](docs/PoliciesAdminContainerApi.md#udm_policies_admin_container_object_template) | **GET** /policies/admin_container/add | Get a template for creating an Univention Directory Manager container settings policy object (contains all properties and their default values)
*PoliciesAdminContainerApi* | [**udm_policies_admin_container_object_update**](docs/PoliciesAdminContainerApi.md#udm_policies_admin_container_object_update) | **PATCH** /policies/admin_container/{dn} | Modify an Univention Directory Manager container settings policy object (moving is currently not possible)
*PoliciesDesktopApi* | [**udm_policies_desktop_object**](docs/PoliciesDesktopApi.md#udm_policies_desktop_object) | **GET** /policies/desktop/{dn} |  Get a representation of the Desktop policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PoliciesDesktopApi* | [**udm_policies_desktop_object_create**](docs/PoliciesDesktopApi.md#udm_policies_desktop_object_create) | **POST** /policies/desktop/ | Create a new Desktop policy object
*PoliciesDesktopApi* | [**udm_policies_desktop_object_modify**](docs/PoliciesDesktopApi.md#udm_policies_desktop_object_modify) | **PUT** /policies/desktop/{dn} | Modify or move an Desktop policy object
*PoliciesDesktopApi* | [**udm_policies_desktop_object_remove**](docs/PoliciesDesktopApi.md#udm_policies_desktop_object_remove) | **DELETE** /policies/desktop/{dn} | Remove a Desktop policies object
*PoliciesDesktopApi* | [**udm_policies_desktop_object_search**](docs/PoliciesDesktopApi.md#udm_policies_desktop_object_search) | **GET** /policies/desktop/ | Search for Desktop policies objects
*PoliciesDesktopApi* | [**udm_policies_desktop_object_template**](docs/PoliciesDesktopApi.md#udm_policies_desktop_object_template) | **GET** /policies/desktop/add | Get a template for creating an Desktop policy object (contains all properties and their default values)
*PoliciesDesktopApi* | [**udm_policies_desktop_object_update**](docs/PoliciesDesktopApi.md#udm_policies_desktop_object_update) | **PATCH** /policies/desktop/{dn} | Modify an Desktop policy object (moving is currently not possible)
*PoliciesDhcpBootApi* | [**udm_policies_dhcp_boot_object**](docs/PoliciesDhcpBootApi.md#udm_policies_dhcp_boot_object) | **GET** /policies/dhcp_boot/{dn} |  Get a representation of the DHCP Boot policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PoliciesDhcpBootApi* | [**udm_policies_dhcp_boot_object_create**](docs/PoliciesDhcpBootApi.md#udm_policies_dhcp_boot_object_create) | **POST** /policies/dhcp_boot/ | Create a new DHCP Boot policy object
*PoliciesDhcpBootApi* | [**udm_policies_dhcp_boot_object_modify**](docs/PoliciesDhcpBootApi.md#udm_policies_dhcp_boot_object_modify) | **PUT** /policies/dhcp_boot/{dn} | Modify or move an DHCP Boot policy object
*PoliciesDhcpBootApi* | [**udm_policies_dhcp_boot_object_remove**](docs/PoliciesDhcpBootApi.md#udm_policies_dhcp_boot_object_remove) | **DELETE** /policies/dhcp_boot/{dn} | Remove a DHCP Boot policies object
*PoliciesDhcpBootApi* | [**udm_policies_dhcp_boot_object_search**](docs/PoliciesDhcpBootApi.md#udm_policies_dhcp_boot_object_search) | **GET** /policies/dhcp_boot/ | Search for DHCP Boot policies objects
*PoliciesDhcpBootApi* | [**udm_policies_dhcp_boot_object_template**](docs/PoliciesDhcpBootApi.md#udm_policies_dhcp_boot_object_template) | **GET** /policies/dhcp_boot/add | Get a template for creating an DHCP Boot policy object (contains all properties and their default values)
*PoliciesDhcpBootApi* | [**udm_policies_dhcp_boot_object_update**](docs/PoliciesDhcpBootApi.md#udm_policies_dhcp_boot_object_update) | **PATCH** /policies/dhcp_boot/{dn} | Modify an DHCP Boot policy object (moving is currently not possible)
*PoliciesDhcpDnsApi* | [**udm_policies_dhcp_dns_object**](docs/PoliciesDhcpDnsApi.md#udm_policies_dhcp_dns_object) | **GET** /policies/dhcp_dns/{dn} |  Get a representation of the DHCP DNS policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PoliciesDhcpDnsApi* | [**udm_policies_dhcp_dns_object_create**](docs/PoliciesDhcpDnsApi.md#udm_policies_dhcp_dns_object_create) | **POST** /policies/dhcp_dns/ | Create a new DHCP DNS policy object
*PoliciesDhcpDnsApi* | [**udm_policies_dhcp_dns_object_modify**](docs/PoliciesDhcpDnsApi.md#udm_policies_dhcp_dns_object_modify) | **PUT** /policies/dhcp_dns/{dn} | Modify or move an DHCP DNS policy object
*PoliciesDhcpDnsApi* | [**udm_policies_dhcp_dns_object_remove**](docs/PoliciesDhcpDnsApi.md#udm_policies_dhcp_dns_object_remove) | **DELETE** /policies/dhcp_dns/{dn} | Remove a DHCP DNS policies object
*PoliciesDhcpDnsApi* | [**udm_policies_dhcp_dns_object_search**](docs/PoliciesDhcpDnsApi.md#udm_policies_dhcp_dns_object_search) | **GET** /policies/dhcp_dns/ | Search for DHCP DNS policies objects
*PoliciesDhcpDnsApi* | [**udm_policies_dhcp_dns_object_template**](docs/PoliciesDhcpDnsApi.md#udm_policies_dhcp_dns_object_template) | **GET** /policies/dhcp_dns/add | Get a template for creating an DHCP DNS policy object (contains all properties and their default values)
*PoliciesDhcpDnsApi* | [**udm_policies_dhcp_dns_object_update**](docs/PoliciesDhcpDnsApi.md#udm_policies_dhcp_dns_object_update) | **PATCH** /policies/dhcp_dns/{dn} | Modify an DHCP DNS policy object (moving is currently not possible)
*PoliciesDhcpDnsupdateApi* | [**udm_policies_dhcp_dnsupdate_object**](docs/PoliciesDhcpDnsupdateApi.md#udm_policies_dhcp_dnsupdate_object) | **GET** /policies/dhcp_dnsupdate/{dn} |  Get a representation of the DHCP Dynamic DNS policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PoliciesDhcpDnsupdateApi* | [**udm_policies_dhcp_dnsupdate_object_create**](docs/PoliciesDhcpDnsupdateApi.md#udm_policies_dhcp_dnsupdate_object_create) | **POST** /policies/dhcp_dnsupdate/ | Create a new DHCP Dynamic DNS policy object
*PoliciesDhcpDnsupdateApi* | [**udm_policies_dhcp_dnsupdate_object_modify**](docs/PoliciesDhcpDnsupdateApi.md#udm_policies_dhcp_dnsupdate_object_modify) | **PUT** /policies/dhcp_dnsupdate/{dn} | Modify or move an DHCP Dynamic DNS policy object
*PoliciesDhcpDnsupdateApi* | [**udm_policies_dhcp_dnsupdate_object_remove**](docs/PoliciesDhcpDnsupdateApi.md#udm_policies_dhcp_dnsupdate_object_remove) | **DELETE** /policies/dhcp_dnsupdate/{dn} | Remove a DHCP Dynamic DNS policies object
*PoliciesDhcpDnsupdateApi* | [**udm_policies_dhcp_dnsupdate_object_search**](docs/PoliciesDhcpDnsupdateApi.md#udm_policies_dhcp_dnsupdate_object_search) | **GET** /policies/dhcp_dnsupdate/ | Search for DHCP Dynamic DNS policies objects
*PoliciesDhcpDnsupdateApi* | [**udm_policies_dhcp_dnsupdate_object_template**](docs/PoliciesDhcpDnsupdateApi.md#udm_policies_dhcp_dnsupdate_object_template) | **GET** /policies/dhcp_dnsupdate/add | Get a template for creating an DHCP Dynamic DNS policy object (contains all properties and their default values)
*PoliciesDhcpDnsupdateApi* | [**udm_policies_dhcp_dnsupdate_object_update**](docs/PoliciesDhcpDnsupdateApi.md#udm_policies_dhcp_dnsupdate_object_update) | **PATCH** /policies/dhcp_dnsupdate/{dn} | Modify an DHCP Dynamic DNS policy object (moving is currently not possible)
*PoliciesDhcpLeasetimeApi* | [**udm_policies_dhcp_leasetime_object**](docs/PoliciesDhcpLeasetimeApi.md#udm_policies_dhcp_leasetime_object) | **GET** /policies/dhcp_leasetime/{dn} |  Get a representation of the DHCP lease time policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PoliciesDhcpLeasetimeApi* | [**udm_policies_dhcp_leasetime_object_create**](docs/PoliciesDhcpLeasetimeApi.md#udm_policies_dhcp_leasetime_object_create) | **POST** /policies/dhcp_leasetime/ | Create a new DHCP lease time policy object
*PoliciesDhcpLeasetimeApi* | [**udm_policies_dhcp_leasetime_object_modify**](docs/PoliciesDhcpLeasetimeApi.md#udm_policies_dhcp_leasetime_object_modify) | **PUT** /policies/dhcp_leasetime/{dn} | Modify or move an DHCP lease time policy object
*PoliciesDhcpLeasetimeApi* | [**udm_policies_dhcp_leasetime_object_remove**](docs/PoliciesDhcpLeasetimeApi.md#udm_policies_dhcp_leasetime_object_remove) | **DELETE** /policies/dhcp_leasetime/{dn} | Remove a DHCP lease time policies object
*PoliciesDhcpLeasetimeApi* | [**udm_policies_dhcp_leasetime_object_search**](docs/PoliciesDhcpLeasetimeApi.md#udm_policies_dhcp_leasetime_object_search) | **GET** /policies/dhcp_leasetime/ | Search for DHCP lease time policies objects
*PoliciesDhcpLeasetimeApi* | [**udm_policies_dhcp_leasetime_object_template**](docs/PoliciesDhcpLeasetimeApi.md#udm_policies_dhcp_leasetime_object_template) | **GET** /policies/dhcp_leasetime/add | Get a template for creating an DHCP lease time policy object (contains all properties and their default values)
*PoliciesDhcpLeasetimeApi* | [**udm_policies_dhcp_leasetime_object_update**](docs/PoliciesDhcpLeasetimeApi.md#udm_policies_dhcp_leasetime_object_update) | **PATCH** /policies/dhcp_leasetime/{dn} | Modify an DHCP lease time policy object (moving is currently not possible)
*PoliciesDhcpNetbiosApi* | [**udm_policies_dhcp_netbios_object**](docs/PoliciesDhcpNetbiosApi.md#udm_policies_dhcp_netbios_object) | **GET** /policies/dhcp_netbios/{dn} |  Get a representation of the DHCP NetBIOS policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PoliciesDhcpNetbiosApi* | [**udm_policies_dhcp_netbios_object_create**](docs/PoliciesDhcpNetbiosApi.md#udm_policies_dhcp_netbios_object_create) | **POST** /policies/dhcp_netbios/ | Create a new DHCP NetBIOS policy object
*PoliciesDhcpNetbiosApi* | [**udm_policies_dhcp_netbios_object_modify**](docs/PoliciesDhcpNetbiosApi.md#udm_policies_dhcp_netbios_object_modify) | **PUT** /policies/dhcp_netbios/{dn} | Modify or move an DHCP NetBIOS policy object
*PoliciesDhcpNetbiosApi* | [**udm_policies_dhcp_netbios_object_remove**](docs/PoliciesDhcpNetbiosApi.md#udm_policies_dhcp_netbios_object_remove) | **DELETE** /policies/dhcp_netbios/{dn} | Remove a DHCP NetBIOS policies object
*PoliciesDhcpNetbiosApi* | [**udm_policies_dhcp_netbios_object_search**](docs/PoliciesDhcpNetbiosApi.md#udm_policies_dhcp_netbios_object_search) | **GET** /policies/dhcp_netbios/ | Search for DHCP NetBIOS policies objects
*PoliciesDhcpNetbiosApi* | [**udm_policies_dhcp_netbios_object_template**](docs/PoliciesDhcpNetbiosApi.md#udm_policies_dhcp_netbios_object_template) | **GET** /policies/dhcp_netbios/add | Get a template for creating an DHCP NetBIOS policy object (contains all properties and their default values)
*PoliciesDhcpNetbiosApi* | [**udm_policies_dhcp_netbios_object_update**](docs/PoliciesDhcpNetbiosApi.md#udm_policies_dhcp_netbios_object_update) | **PATCH** /policies/dhcp_netbios/{dn} | Modify an DHCP NetBIOS policy object (moving is currently not possible)
*PoliciesDhcpRoutingApi* | [**udm_policies_dhcp_routing_object**](docs/PoliciesDhcpRoutingApi.md#udm_policies_dhcp_routing_object) | **GET** /policies/dhcp_routing/{dn} |  Get a representation of the DHCP routing policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PoliciesDhcpRoutingApi* | [**udm_policies_dhcp_routing_object_create**](docs/PoliciesDhcpRoutingApi.md#udm_policies_dhcp_routing_object_create) | **POST** /policies/dhcp_routing/ | Create a new DHCP routing policy object
*PoliciesDhcpRoutingApi* | [**udm_policies_dhcp_routing_object_modify**](docs/PoliciesDhcpRoutingApi.md#udm_policies_dhcp_routing_object_modify) | **PUT** /policies/dhcp_routing/{dn} | Modify or move an DHCP routing policy object
*PoliciesDhcpRoutingApi* | [**udm_policies_dhcp_routing_object_remove**](docs/PoliciesDhcpRoutingApi.md#udm_policies_dhcp_routing_object_remove) | **DELETE** /policies/dhcp_routing/{dn} | Remove a DHCP routing policies object
*PoliciesDhcpRoutingApi* | [**udm_policies_dhcp_routing_object_search**](docs/PoliciesDhcpRoutingApi.md#udm_policies_dhcp_routing_object_search) | **GET** /policies/dhcp_routing/ | Search for DHCP routing policies objects
*PoliciesDhcpRoutingApi* | [**udm_policies_dhcp_routing_object_template**](docs/PoliciesDhcpRoutingApi.md#udm_policies_dhcp_routing_object_template) | **GET** /policies/dhcp_routing/add | Get a template for creating an DHCP routing policy object (contains all properties and their default values)
*PoliciesDhcpRoutingApi* | [**udm_policies_dhcp_routing_object_update**](docs/PoliciesDhcpRoutingApi.md#udm_policies_dhcp_routing_object_update) | **PATCH** /policies/dhcp_routing/{dn} | Modify an DHCP routing policy object (moving is currently not possible)
*PoliciesDhcpScopeApi* | [**udm_policies_dhcp_scope_object**](docs/PoliciesDhcpScopeApi.md#udm_policies_dhcp_scope_object) | **GET** /policies/dhcp_scope/{dn} |  Get a representation of the DHCP Allow/Deny policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PoliciesDhcpScopeApi* | [**udm_policies_dhcp_scope_object_create**](docs/PoliciesDhcpScopeApi.md#udm_policies_dhcp_scope_object_create) | **POST** /policies/dhcp_scope/ | Create a new DHCP Allow/Deny policy object
*PoliciesDhcpScopeApi* | [**udm_policies_dhcp_scope_object_modify**](docs/PoliciesDhcpScopeApi.md#udm_policies_dhcp_scope_object_modify) | **PUT** /policies/dhcp_scope/{dn} | Modify or move an DHCP Allow/Deny policy object
*PoliciesDhcpScopeApi* | [**udm_policies_dhcp_scope_object_remove**](docs/PoliciesDhcpScopeApi.md#udm_policies_dhcp_scope_object_remove) | **DELETE** /policies/dhcp_scope/{dn} | Remove a DHCP Allow/Deny policies object
*PoliciesDhcpScopeApi* | [**udm_policies_dhcp_scope_object_search**](docs/PoliciesDhcpScopeApi.md#udm_policies_dhcp_scope_object_search) | **GET** /policies/dhcp_scope/ | Search for DHCP Allow/Deny policies objects
*PoliciesDhcpScopeApi* | [**udm_policies_dhcp_scope_object_template**](docs/PoliciesDhcpScopeApi.md#udm_policies_dhcp_scope_object_template) | **GET** /policies/dhcp_scope/add | Get a template for creating an DHCP Allow/Deny policy object (contains all properties and their default values)
*PoliciesDhcpScopeApi* | [**udm_policies_dhcp_scope_object_update**](docs/PoliciesDhcpScopeApi.md#udm_policies_dhcp_scope_object_update) | **PATCH** /policies/dhcp_scope/{dn} | Modify an DHCP Allow/Deny policy object (moving is currently not possible)
*PoliciesDhcpStatementsApi* | [**udm_policies_dhcp_statements_object**](docs/PoliciesDhcpStatementsApi.md#udm_policies_dhcp_statements_object) | **GET** /policies/dhcp_statements/{dn} |  Get a representation of the DHCP statements policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PoliciesDhcpStatementsApi* | [**udm_policies_dhcp_statements_object_create**](docs/PoliciesDhcpStatementsApi.md#udm_policies_dhcp_statements_object_create) | **POST** /policies/dhcp_statements/ | Create a new DHCP statements policy object
*PoliciesDhcpStatementsApi* | [**udm_policies_dhcp_statements_object_modify**](docs/PoliciesDhcpStatementsApi.md#udm_policies_dhcp_statements_object_modify) | **PUT** /policies/dhcp_statements/{dn} | Modify or move an DHCP statements policy object
*PoliciesDhcpStatementsApi* | [**udm_policies_dhcp_statements_object_remove**](docs/PoliciesDhcpStatementsApi.md#udm_policies_dhcp_statements_object_remove) | **DELETE** /policies/dhcp_statements/{dn} | Remove a DHCP statements policies object
*PoliciesDhcpStatementsApi* | [**udm_policies_dhcp_statements_object_search**](docs/PoliciesDhcpStatementsApi.md#udm_policies_dhcp_statements_object_search) | **GET** /policies/dhcp_statements/ | Search for DHCP statements policies objects
*PoliciesDhcpStatementsApi* | [**udm_policies_dhcp_statements_object_template**](docs/PoliciesDhcpStatementsApi.md#udm_policies_dhcp_statements_object_template) | **GET** /policies/dhcp_statements/add | Get a template for creating an DHCP statements policy object (contains all properties and their default values)
*PoliciesDhcpStatementsApi* | [**udm_policies_dhcp_statements_object_update**](docs/PoliciesDhcpStatementsApi.md#udm_policies_dhcp_statements_object_update) | **PATCH** /policies/dhcp_statements/{dn} | Modify an DHCP statements policy object (moving is currently not possible)
*PoliciesLdapserverApi* | [**udm_policies_ldapserver_object**](docs/PoliciesLdapserverApi.md#udm_policies_ldapserver_object) | **GET** /policies/ldapserver/{dn} |  Get a representation of the LDAP server policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PoliciesLdapserverApi* | [**udm_policies_ldapserver_object_create**](docs/PoliciesLdapserverApi.md#udm_policies_ldapserver_object_create) | **POST** /policies/ldapserver/ | Create a new LDAP server policy object
*PoliciesLdapserverApi* | [**udm_policies_ldapserver_object_modify**](docs/PoliciesLdapserverApi.md#udm_policies_ldapserver_object_modify) | **PUT** /policies/ldapserver/{dn} | Modify or move an LDAP server policy object
*PoliciesLdapserverApi* | [**udm_policies_ldapserver_object_remove**](docs/PoliciesLdapserverApi.md#udm_policies_ldapserver_object_remove) | **DELETE** /policies/ldapserver/{dn} | Remove a LDAP server policies object
*PoliciesLdapserverApi* | [**udm_policies_ldapserver_object_search**](docs/PoliciesLdapserverApi.md#udm_policies_ldapserver_object_search) | **GET** /policies/ldapserver/ | Search for LDAP server policies objects
*PoliciesLdapserverApi* | [**udm_policies_ldapserver_object_template**](docs/PoliciesLdapserverApi.md#udm_policies_ldapserver_object_template) | **GET** /policies/ldapserver/add | Get a template for creating an LDAP server policy object (contains all properties and their default values)
*PoliciesLdapserverApi* | [**udm_policies_ldapserver_object_update**](docs/PoliciesLdapserverApi.md#udm_policies_ldapserver_object_update) | **PATCH** /policies/ldapserver/{dn} | Modify an LDAP server policy object (moving is currently not possible)
*PoliciesMaintenanceApi* | [**udm_policies_maintenance_object**](docs/PoliciesMaintenanceApi.md#udm_policies_maintenance_object) | **GET** /policies/maintenance/{dn} |  Get a representation of the Maintenance policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PoliciesMaintenanceApi* | [**udm_policies_maintenance_object_create**](docs/PoliciesMaintenanceApi.md#udm_policies_maintenance_object_create) | **POST** /policies/maintenance/ | Create a new Maintenance policy object
*PoliciesMaintenanceApi* | [**udm_policies_maintenance_object_modify**](docs/PoliciesMaintenanceApi.md#udm_policies_maintenance_object_modify) | **PUT** /policies/maintenance/{dn} | Modify or move an Maintenance policy object
*PoliciesMaintenanceApi* | [**udm_policies_maintenance_object_remove**](docs/PoliciesMaintenanceApi.md#udm_policies_maintenance_object_remove) | **DELETE** /policies/maintenance/{dn} | Remove a Maintenance policies object
*PoliciesMaintenanceApi* | [**udm_policies_maintenance_object_search**](docs/PoliciesMaintenanceApi.md#udm_policies_maintenance_object_search) | **GET** /policies/maintenance/ | Search for Maintenance policies objects
*PoliciesMaintenanceApi* | [**udm_policies_maintenance_object_template**](docs/PoliciesMaintenanceApi.md#udm_policies_maintenance_object_template) | **GET** /policies/maintenance/add | Get a template for creating an Maintenance policy object (contains all properties and their default values)
*PoliciesMaintenanceApi* | [**udm_policies_maintenance_object_update**](docs/PoliciesMaintenanceApi.md#udm_policies_maintenance_object_update) | **PATCH** /policies/maintenance/{dn} | Modify an Maintenance policy object (moving is currently not possible)
*PoliciesMasterpackagesApi* | [**udm_policies_masterpackages_object**](docs/PoliciesMasterpackagesApi.md#udm_policies_masterpackages_object) | **GET** /policies/masterpackages/{dn} |  Get a representation of the Primary/Backup Node packages policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PoliciesMasterpackagesApi* | [**udm_policies_masterpackages_object_create**](docs/PoliciesMasterpackagesApi.md#udm_policies_masterpackages_object_create) | **POST** /policies/masterpackages/ | Create a new Primary/Backup Node packages policy object
*PoliciesMasterpackagesApi* | [**udm_policies_masterpackages_object_modify**](docs/PoliciesMasterpackagesApi.md#udm_policies_masterpackages_object_modify) | **PUT** /policies/masterpackages/{dn} | Modify or move an Primary/Backup Node packages policy object
*PoliciesMasterpackagesApi* | [**udm_policies_masterpackages_object_remove**](docs/PoliciesMasterpackagesApi.md#udm_policies_masterpackages_object_remove) | **DELETE** /policies/masterpackages/{dn} | Remove a Primary/Backup Node packages policies object
*PoliciesMasterpackagesApi* | [**udm_policies_masterpackages_object_search**](docs/PoliciesMasterpackagesApi.md#udm_policies_masterpackages_object_search) | **GET** /policies/masterpackages/ | Search for Primary/Backup Node packages policies objects
*PoliciesMasterpackagesApi* | [**udm_policies_masterpackages_object_template**](docs/PoliciesMasterpackagesApi.md#udm_policies_masterpackages_object_template) | **GET** /policies/masterpackages/add | Get a template for creating an Primary/Backup Node packages policy object (contains all properties and their default values)
*PoliciesMasterpackagesApi* | [**udm_policies_masterpackages_object_update**](docs/PoliciesMasterpackagesApi.md#udm_policies_masterpackages_object_update) | **PATCH** /policies/masterpackages/{dn} | Modify an Primary/Backup Node packages policy object (moving is currently not possible)
*PoliciesMemberpackagesApi* | [**udm_policies_memberpackages_object**](docs/PoliciesMemberpackagesApi.md#udm_policies_memberpackages_object) | **GET** /policies/memberpackages/{dn} |  Get a representation of the Managed Node packages policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PoliciesMemberpackagesApi* | [**udm_policies_memberpackages_object_create**](docs/PoliciesMemberpackagesApi.md#udm_policies_memberpackages_object_create) | **POST** /policies/memberpackages/ | Create a new Managed Node packages policy object
*PoliciesMemberpackagesApi* | [**udm_policies_memberpackages_object_modify**](docs/PoliciesMemberpackagesApi.md#udm_policies_memberpackages_object_modify) | **PUT** /policies/memberpackages/{dn} | Modify or move an Managed Node packages policy object
*PoliciesMemberpackagesApi* | [**udm_policies_memberpackages_object_remove**](docs/PoliciesMemberpackagesApi.md#udm_policies_memberpackages_object_remove) | **DELETE** /policies/memberpackages/{dn} | Remove a Managed Node packages policies object
*PoliciesMemberpackagesApi* | [**udm_policies_memberpackages_object_search**](docs/PoliciesMemberpackagesApi.md#udm_policies_memberpackages_object_search) | **GET** /policies/memberpackages/ | Search for Managed Node packages policies objects
*PoliciesMemberpackagesApi* | [**udm_policies_memberpackages_object_template**](docs/PoliciesMemberpackagesApi.md#udm_policies_memberpackages_object_template) | **GET** /policies/memberpackages/add | Get a template for creating an Managed Node packages policy object (contains all properties and their default values)
*PoliciesMemberpackagesApi* | [**udm_policies_memberpackages_object_update**](docs/PoliciesMemberpackagesApi.md#udm_policies_memberpackages_object_update) | **PATCH** /policies/memberpackages/{dn} | Modify an Managed Node packages policy object (moving is currently not possible)
*PoliciesNfsmountsApi* | [**udm_policies_nfsmounts_object**](docs/PoliciesNfsmountsApi.md#udm_policies_nfsmounts_object) | **GET** /policies/nfsmounts/{dn} |  Get a representation of the NFS mounts policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PoliciesNfsmountsApi* | [**udm_policies_nfsmounts_object_create**](docs/PoliciesNfsmountsApi.md#udm_policies_nfsmounts_object_create) | **POST** /policies/nfsmounts/ | Create a new NFS mounts policy object
*PoliciesNfsmountsApi* | [**udm_policies_nfsmounts_object_modify**](docs/PoliciesNfsmountsApi.md#udm_policies_nfsmounts_object_modify) | **PUT** /policies/nfsmounts/{dn} | Modify or move an NFS mounts policy object
*PoliciesNfsmountsApi* | [**udm_policies_nfsmounts_object_remove**](docs/PoliciesNfsmountsApi.md#udm_policies_nfsmounts_object_remove) | **DELETE** /policies/nfsmounts/{dn} | Remove a NFS mounts policies object
*PoliciesNfsmountsApi* | [**udm_policies_nfsmounts_object_search**](docs/PoliciesNfsmountsApi.md#udm_policies_nfsmounts_object_search) | **GET** /policies/nfsmounts/ | Search for NFS mounts policies objects
*PoliciesNfsmountsApi* | [**udm_policies_nfsmounts_object_template**](docs/PoliciesNfsmountsApi.md#udm_policies_nfsmounts_object_template) | **GET** /policies/nfsmounts/add | Get a template for creating an NFS mounts policy object (contains all properties and their default values)
*PoliciesNfsmountsApi* | [**udm_policies_nfsmounts_object_update**](docs/PoliciesNfsmountsApi.md#udm_policies_nfsmounts_object_update) | **PATCH** /policies/nfsmounts/{dn} | Modify an NFS mounts policy object (moving is currently not possible)
*PoliciesPolicyApi* | [**udm_policies_policy_object**](docs/PoliciesPolicyApi.md#udm_policies_policy_object) | **GET** /policies/policy/{dn} |  Get a representation of the Policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PoliciesPolicyApi* | [**udm_policies_policy_object_search**](docs/PoliciesPolicyApi.md#udm_policies_policy_object_search) | **GET** /policies/policy/ | Search for Policies objects
*PoliciesPrintserverApi* | [**udm_policies_printserver_object**](docs/PoliciesPrintserverApi.md#udm_policies_printserver_object) | **GET** /policies/printserver/{dn} |  Get a representation of the Print server policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PoliciesPrintserverApi* | [**udm_policies_printserver_object_create**](docs/PoliciesPrintserverApi.md#udm_policies_printserver_object_create) | **POST** /policies/printserver/ | Create a new Print server policy object
*PoliciesPrintserverApi* | [**udm_policies_printserver_object_modify**](docs/PoliciesPrintserverApi.md#udm_policies_printserver_object_modify) | **PUT** /policies/printserver/{dn} | Modify or move an Print server policy object
*PoliciesPrintserverApi* | [**udm_policies_printserver_object_remove**](docs/PoliciesPrintserverApi.md#udm_policies_printserver_object_remove) | **DELETE** /policies/printserver/{dn} | Remove a Print server policies object
*PoliciesPrintserverApi* | [**udm_policies_printserver_object_search**](docs/PoliciesPrintserverApi.md#udm_policies_printserver_object_search) | **GET** /policies/printserver/ | Search for Print server policies objects
*PoliciesPrintserverApi* | [**udm_policies_printserver_object_template**](docs/PoliciesPrintserverApi.md#udm_policies_printserver_object_template) | **GET** /policies/printserver/add | Get a template for creating an Print server policy object (contains all properties and their default values)
*PoliciesPrintserverApi* | [**udm_policies_printserver_object_update**](docs/PoliciesPrintserverApi.md#udm_policies_printserver_object_update) | **PATCH** /policies/printserver/{dn} | Modify an Print server policy object (moving is currently not possible)
*PoliciesPwhistoryApi* | [**udm_policies_pwhistory_object**](docs/PoliciesPwhistoryApi.md#udm_policies_pwhistory_object) | **GET** /policies/pwhistory/{dn} |  Get a representation of the Passwords policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PoliciesPwhistoryApi* | [**udm_policies_pwhistory_object_create**](docs/PoliciesPwhistoryApi.md#udm_policies_pwhistory_object_create) | **POST** /policies/pwhistory/ | Create a new Passwords policy object
*PoliciesPwhistoryApi* | [**udm_policies_pwhistory_object_modify**](docs/PoliciesPwhistoryApi.md#udm_policies_pwhistory_object_modify) | **PUT** /policies/pwhistory/{dn} | Modify or move an Passwords policy object
*PoliciesPwhistoryApi* | [**udm_policies_pwhistory_object_remove**](docs/PoliciesPwhistoryApi.md#udm_policies_pwhistory_object_remove) | **DELETE** /policies/pwhistory/{dn} | Remove a Passwords policies object
*PoliciesPwhistoryApi* | [**udm_policies_pwhistory_object_search**](docs/PoliciesPwhistoryApi.md#udm_policies_pwhistory_object_search) | **GET** /policies/pwhistory/ | Search for Passwords policies objects
*PoliciesPwhistoryApi* | [**udm_policies_pwhistory_object_template**](docs/PoliciesPwhistoryApi.md#udm_policies_pwhistory_object_template) | **GET** /policies/pwhistory/add | Get a template for creating an Passwords policy object (contains all properties and their default values)
*PoliciesPwhistoryApi* | [**udm_policies_pwhistory_object_update**](docs/PoliciesPwhistoryApi.md#udm_policies_pwhistory_object_update) | **PATCH** /policies/pwhistory/{dn} | Modify an Passwords policy object (moving is currently not possible)
*PoliciesRegistryApi* | [**udm_policies_registry_object**](docs/PoliciesRegistryApi.md#udm_policies_registry_object) | **GET** /policies/registry/{dn} |  Get a representation of the Univention Configuration Registry policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PoliciesRegistryApi* | [**udm_policies_registry_object_create**](docs/PoliciesRegistryApi.md#udm_policies_registry_object_create) | **POST** /policies/registry/ | Create a new Univention Configuration Registry policy object
*PoliciesRegistryApi* | [**udm_policies_registry_object_modify**](docs/PoliciesRegistryApi.md#udm_policies_registry_object_modify) | **PUT** /policies/registry/{dn} | Modify or move an Univention Configuration Registry policy object
*PoliciesRegistryApi* | [**udm_policies_registry_object_remove**](docs/PoliciesRegistryApi.md#udm_policies_registry_object_remove) | **DELETE** /policies/registry/{dn} | Remove a Univention Configuration Registry policies object
*PoliciesRegistryApi* | [**udm_policies_registry_object_search**](docs/PoliciesRegistryApi.md#udm_policies_registry_object_search) | **GET** /policies/registry/ | Search for Univention Configuration Registry policies objects
*PoliciesRegistryApi* | [**udm_policies_registry_object_template**](docs/PoliciesRegistryApi.md#udm_policies_registry_object_template) | **GET** /policies/registry/add | Get a template for creating an Univention Configuration Registry policy object (contains all properties and their default values)
*PoliciesRegistryApi* | [**udm_policies_registry_object_update**](docs/PoliciesRegistryApi.md#udm_policies_registry_object_update) | **PATCH** /policies/registry/{dn} | Modify an Univention Configuration Registry policy object (moving is currently not possible)
*PoliciesReleaseApi* | [**udm_policies_release_object**](docs/PoliciesReleaseApi.md#udm_policies_release_object) | **GET** /policies/release/{dn} |  Get a representation of the Automatic updates policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PoliciesReleaseApi* | [**udm_policies_release_object_create**](docs/PoliciesReleaseApi.md#udm_policies_release_object_create) | **POST** /policies/release/ | Create a new Automatic updates policy object
*PoliciesReleaseApi* | [**udm_policies_release_object_modify**](docs/PoliciesReleaseApi.md#udm_policies_release_object_modify) | **PUT** /policies/release/{dn} | Modify or move an Automatic updates policy object
*PoliciesReleaseApi* | [**udm_policies_release_object_remove**](docs/PoliciesReleaseApi.md#udm_policies_release_object_remove) | **DELETE** /policies/release/{dn} | Remove a Automatic updates policies object
*PoliciesReleaseApi* | [**udm_policies_release_object_search**](docs/PoliciesReleaseApi.md#udm_policies_release_object_search) | **GET** /policies/release/ | Search for Automatic updates policies objects
*PoliciesReleaseApi* | [**udm_policies_release_object_template**](docs/PoliciesReleaseApi.md#udm_policies_release_object_template) | **GET** /policies/release/add | Get a template for creating an Automatic updates policy object (contains all properties and their default values)
*PoliciesReleaseApi* | [**udm_policies_release_object_update**](docs/PoliciesReleaseApi.md#udm_policies_release_object_update) | **PATCH** /policies/release/{dn} | Modify an Automatic updates policy object (moving is currently not possible)
*PoliciesRepositoryserverApi* | [**udm_policies_repositoryserver_object**](docs/PoliciesRepositoryserverApi.md#udm_policies_repositoryserver_object) | **GET** /policies/repositoryserver/{dn} |  Get a representation of the Repository server policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PoliciesRepositoryserverApi* | [**udm_policies_repositoryserver_object_create**](docs/PoliciesRepositoryserverApi.md#udm_policies_repositoryserver_object_create) | **POST** /policies/repositoryserver/ | Create a new Repository server policy object
*PoliciesRepositoryserverApi* | [**udm_policies_repositoryserver_object_modify**](docs/PoliciesRepositoryserverApi.md#udm_policies_repositoryserver_object_modify) | **PUT** /policies/repositoryserver/{dn} | Modify or move an Repository server policy object
*PoliciesRepositoryserverApi* | [**udm_policies_repositoryserver_object_remove**](docs/PoliciesRepositoryserverApi.md#udm_policies_repositoryserver_object_remove) | **DELETE** /policies/repositoryserver/{dn} | Remove a Repository server policies object
*PoliciesRepositoryserverApi* | [**udm_policies_repositoryserver_object_search**](docs/PoliciesRepositoryserverApi.md#udm_policies_repositoryserver_object_search) | **GET** /policies/repositoryserver/ | Search for Repository server policies objects
*PoliciesRepositoryserverApi* | [**udm_policies_repositoryserver_object_template**](docs/PoliciesRepositoryserverApi.md#udm_policies_repositoryserver_object_template) | **GET** /policies/repositoryserver/add | Get a template for creating an Repository server policy object (contains all properties and their default values)
*PoliciesRepositoryserverApi* | [**udm_policies_repositoryserver_object_update**](docs/PoliciesRepositoryserverApi.md#udm_policies_repositoryserver_object_update) | **PATCH** /policies/repositoryserver/{dn} | Modify an Repository server policy object (moving is currently not possible)
*PoliciesRepositorysyncApi* | [**udm_policies_repositorysync_object**](docs/PoliciesRepositorysyncApi.md#udm_policies_repositorysync_object) | **GET** /policies/repositorysync/{dn} |  Get a representation of the Repository synchronisation policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PoliciesRepositorysyncApi* | [**udm_policies_repositorysync_object_create**](docs/PoliciesRepositorysyncApi.md#udm_policies_repositorysync_object_create) | **POST** /policies/repositorysync/ | Create a new Repository synchronisation policy object
*PoliciesRepositorysyncApi* | [**udm_policies_repositorysync_object_modify**](docs/PoliciesRepositorysyncApi.md#udm_policies_repositorysync_object_modify) | **PUT** /policies/repositorysync/{dn} | Modify or move an Repository synchronisation policy object
*PoliciesRepositorysyncApi* | [**udm_policies_repositorysync_object_remove**](docs/PoliciesRepositorysyncApi.md#udm_policies_repositorysync_object_remove) | **DELETE** /policies/repositorysync/{dn} | Remove a Repository synchronisation policies object
*PoliciesRepositorysyncApi* | [**udm_policies_repositorysync_object_search**](docs/PoliciesRepositorysyncApi.md#udm_policies_repositorysync_object_search) | **GET** /policies/repositorysync/ | Search for Repository synchronisation policies objects
*PoliciesRepositorysyncApi* | [**udm_policies_repositorysync_object_template**](docs/PoliciesRepositorysyncApi.md#udm_policies_repositorysync_object_template) | **GET** /policies/repositorysync/add | Get a template for creating an Repository synchronisation policy object (contains all properties and their default values)
*PoliciesRepositorysyncApi* | [**udm_policies_repositorysync_object_update**](docs/PoliciesRepositorysyncApi.md#udm_policies_repositorysync_object_update) | **PATCH** /policies/repositorysync/{dn} | Modify an Repository synchronisation policy object (moving is currently not possible)
*PoliciesShareUserquotaApi* | [**udm_policies_share_userquota_object**](docs/PoliciesShareUserquotaApi.md#udm_policies_share_userquota_object) | **GET** /policies/share_userquota/{dn} |  Get a representation of the User quota policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PoliciesShareUserquotaApi* | [**udm_policies_share_userquota_object_create**](docs/PoliciesShareUserquotaApi.md#udm_policies_share_userquota_object_create) | **POST** /policies/share_userquota/ | Create a new User quota policy object
*PoliciesShareUserquotaApi* | [**udm_policies_share_userquota_object_modify**](docs/PoliciesShareUserquotaApi.md#udm_policies_share_userquota_object_modify) | **PUT** /policies/share_userquota/{dn} | Modify or move an User quota policy object
*PoliciesShareUserquotaApi* | [**udm_policies_share_userquota_object_remove**](docs/PoliciesShareUserquotaApi.md#udm_policies_share_userquota_object_remove) | **DELETE** /policies/share_userquota/{dn} | Remove a User quota policies object
*PoliciesShareUserquotaApi* | [**udm_policies_share_userquota_object_search**](docs/PoliciesShareUserquotaApi.md#udm_policies_share_userquota_object_search) | **GET** /policies/share_userquota/ | Search for User quota policies objects
*PoliciesShareUserquotaApi* | [**udm_policies_share_userquota_object_template**](docs/PoliciesShareUserquotaApi.md#udm_policies_share_userquota_object_template) | **GET** /policies/share_userquota/add | Get a template for creating an User quota policy object (contains all properties and their default values)
*PoliciesShareUserquotaApi* | [**udm_policies_share_userquota_object_update**](docs/PoliciesShareUserquotaApi.md#udm_policies_share_userquota_object_update) | **PATCH** /policies/share_userquota/{dn} | Modify an User quota policy object (moving is currently not possible)
*PoliciesSlavepackagesApi* | [**udm_policies_slavepackages_object**](docs/PoliciesSlavepackagesApi.md#udm_policies_slavepackages_object) | **GET** /policies/slavepackages/{dn} |  Get a representation of the Replica Node packages policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PoliciesSlavepackagesApi* | [**udm_policies_slavepackages_object_create**](docs/PoliciesSlavepackagesApi.md#udm_policies_slavepackages_object_create) | **POST** /policies/slavepackages/ | Create a new Replica Node packages policy object
*PoliciesSlavepackagesApi* | [**udm_policies_slavepackages_object_modify**](docs/PoliciesSlavepackagesApi.md#udm_policies_slavepackages_object_modify) | **PUT** /policies/slavepackages/{dn} | Modify or move an Replica Node packages policy object
*PoliciesSlavepackagesApi* | [**udm_policies_slavepackages_object_remove**](docs/PoliciesSlavepackagesApi.md#udm_policies_slavepackages_object_remove) | **DELETE** /policies/slavepackages/{dn} | Remove a Replica Node packages policies object
*PoliciesSlavepackagesApi* | [**udm_policies_slavepackages_object_search**](docs/PoliciesSlavepackagesApi.md#udm_policies_slavepackages_object_search) | **GET** /policies/slavepackages/ | Search for Replica Node packages policies objects
*PoliciesSlavepackagesApi* | [**udm_policies_slavepackages_object_template**](docs/PoliciesSlavepackagesApi.md#udm_policies_slavepackages_object_template) | **GET** /policies/slavepackages/add | Get a template for creating an Replica Node packages policy object (contains all properties and their default values)
*PoliciesSlavepackagesApi* | [**udm_policies_slavepackages_object_update**](docs/PoliciesSlavepackagesApi.md#udm_policies_slavepackages_object_update) | **PATCH** /policies/slavepackages/{dn} | Modify an Replica Node packages policy object (moving is currently not possible)
*PoliciesUmcApi* | [**udm_policies_umc_object**](docs/PoliciesUmcApi.md#udm_policies_umc_object) | **GET** /policies/umc/{dn} |  Get a representation of the UMC policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PoliciesUmcApi* | [**udm_policies_umc_object_create**](docs/PoliciesUmcApi.md#udm_policies_umc_object_create) | **POST** /policies/umc/ | Create a new UMC policy object
*PoliciesUmcApi* | [**udm_policies_umc_object_modify**](docs/PoliciesUmcApi.md#udm_policies_umc_object_modify) | **PUT** /policies/umc/{dn} | Modify or move an UMC policy object
*PoliciesUmcApi* | [**udm_policies_umc_object_remove**](docs/PoliciesUmcApi.md#udm_policies_umc_object_remove) | **DELETE** /policies/umc/{dn} | Remove a UMC policies object
*PoliciesUmcApi* | [**udm_policies_umc_object_search**](docs/PoliciesUmcApi.md#udm_policies_umc_object_search) | **GET** /policies/umc/ | Search for UMC policies objects
*PoliciesUmcApi* | [**udm_policies_umc_object_template**](docs/PoliciesUmcApi.md#udm_policies_umc_object_template) | **GET** /policies/umc/add | Get a template for creating an UMC policy object (contains all properties and their default values)
*PoliciesUmcApi* | [**udm_policies_umc_object_update**](docs/PoliciesUmcApi.md#udm_policies_umc_object_update) | **PATCH** /policies/umc/{dn} | Modify an UMC policy object (moving is currently not possible)
*PortalsAllApi* | [**udm_portals_all_object**](docs/PortalsAllApi.md#udm_portals_all_object) | **GET** /portals/all/{dn} |  Get a representation of the Portal: Settings object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PortalsAllApi* | [**udm_portals_all_object_search**](docs/PortalsAllApi.md#udm_portals_all_object_search) | **GET** /portals/all/ | Search for Portal: Settings objects
*PortalsAnnouncementApi* | [**udm_portals_announcement_object**](docs/PortalsAnnouncementApi.md#udm_portals_announcement_object) | **GET** /portals/announcement/{dn} |  Get a representation of the Portal announcement object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PortalsAnnouncementApi* | [**udm_portals_announcement_object_create**](docs/PortalsAnnouncementApi.md#udm_portals_announcement_object_create) | **POST** /portals/announcement/ | Create a new Portal announcement object
*PortalsAnnouncementApi* | [**udm_portals_announcement_object_modify**](docs/PortalsAnnouncementApi.md#udm_portals_announcement_object_modify) | **PUT** /portals/announcement/{dn} | Modify or move an Portal announcement object
*PortalsAnnouncementApi* | [**udm_portals_announcement_object_remove**](docs/PortalsAnnouncementApi.md#udm_portals_announcement_object_remove) | **DELETE** /portals/announcement/{dn} | Remove a Portal announcements object
*PortalsAnnouncementApi* | [**udm_portals_announcement_object_search**](docs/PortalsAnnouncementApi.md#udm_portals_announcement_object_search) | **GET** /portals/announcement/ | Search for Portal announcements objects
*PortalsAnnouncementApi* | [**udm_portals_announcement_object_template**](docs/PortalsAnnouncementApi.md#udm_portals_announcement_object_template) | **GET** /portals/announcement/add | Get a template for creating an Portal announcement object (contains all properties and their default values)
*PortalsAnnouncementApi* | [**udm_portals_announcement_object_update**](docs/PortalsAnnouncementApi.md#udm_portals_announcement_object_update) | **PATCH** /portals/announcement/{dn} | Modify an Portal announcement object (moving is currently not possible)
*PortalsCategoryApi* | [**udm_portals_category_object**](docs/PortalsCategoryApi.md#udm_portals_category_object) | **GET** /portals/category/{dn} |  Get a representation of the Portal category object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PortalsCategoryApi* | [**udm_portals_category_object_create**](docs/PortalsCategoryApi.md#udm_portals_category_object_create) | **POST** /portals/category/ | Create a new Portal category object
*PortalsCategoryApi* | [**udm_portals_category_object_modify**](docs/PortalsCategoryApi.md#udm_portals_category_object_modify) | **PUT** /portals/category/{dn} | Modify or move an Portal category object
*PortalsCategoryApi* | [**udm_portals_category_object_remove**](docs/PortalsCategoryApi.md#udm_portals_category_object_remove) | **DELETE** /portals/category/{dn} | Remove a Portal categories object
*PortalsCategoryApi* | [**udm_portals_category_object_search**](docs/PortalsCategoryApi.md#udm_portals_category_object_search) | **GET** /portals/category/ | Search for Portal categories objects
*PortalsCategoryApi* | [**udm_portals_category_object_template**](docs/PortalsCategoryApi.md#udm_portals_category_object_template) | **GET** /portals/category/add | Get a template for creating an Portal category object (contains all properties and their default values)
*PortalsCategoryApi* | [**udm_portals_category_object_update**](docs/PortalsCategoryApi.md#udm_portals_category_object_update) | **PATCH** /portals/category/{dn} | Modify an Portal category object (moving is currently not possible)
*PortalsEntryApi* | [**udm_portals_entry_object**](docs/PortalsEntryApi.md#udm_portals_entry_object) | **GET** /portals/entry/{dn} |  Get a representation of the Portal entry object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PortalsEntryApi* | [**udm_portals_entry_object_create**](docs/PortalsEntryApi.md#udm_portals_entry_object_create) | **POST** /portals/entry/ | Create a new Portal entry object
*PortalsEntryApi* | [**udm_portals_entry_object_modify**](docs/PortalsEntryApi.md#udm_portals_entry_object_modify) | **PUT** /portals/entry/{dn} | Modify or move an Portal entry object
*PortalsEntryApi* | [**udm_portals_entry_object_remove**](docs/PortalsEntryApi.md#udm_portals_entry_object_remove) | **DELETE** /portals/entry/{dn} | Remove a Portal entries object
*PortalsEntryApi* | [**udm_portals_entry_object_search**](docs/PortalsEntryApi.md#udm_portals_entry_object_search) | **GET** /portals/entry/ | Search for Portal entries objects
*PortalsEntryApi* | [**udm_portals_entry_object_template**](docs/PortalsEntryApi.md#udm_portals_entry_object_template) | **GET** /portals/entry/add | Get a template for creating an Portal entry object (contains all properties and their default values)
*PortalsEntryApi* | [**udm_portals_entry_object_update**](docs/PortalsEntryApi.md#udm_portals_entry_object_update) | **PATCH** /portals/entry/{dn} | Modify an Portal entry object (moving is currently not possible)
*PortalsFolderApi* | [**udm_portals_folder_object**](docs/PortalsFolderApi.md#udm_portals_folder_object) | **GET** /portals/folder/{dn} |  Get a representation of the Portal folder object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PortalsFolderApi* | [**udm_portals_folder_object_create**](docs/PortalsFolderApi.md#udm_portals_folder_object_create) | **POST** /portals/folder/ | Create a new Portal folder object
*PortalsFolderApi* | [**udm_portals_folder_object_modify**](docs/PortalsFolderApi.md#udm_portals_folder_object_modify) | **PUT** /portals/folder/{dn} | Modify or move an Portal folder object
*PortalsFolderApi* | [**udm_portals_folder_object_remove**](docs/PortalsFolderApi.md#udm_portals_folder_object_remove) | **DELETE** /portals/folder/{dn} | Remove a Portal folders object
*PortalsFolderApi* | [**udm_portals_folder_object_search**](docs/PortalsFolderApi.md#udm_portals_folder_object_search) | **GET** /portals/folder/ | Search for Portal folders objects
*PortalsFolderApi* | [**udm_portals_folder_object_template**](docs/PortalsFolderApi.md#udm_portals_folder_object_template) | **GET** /portals/folder/add | Get a template for creating an Portal folder object (contains all properties and their default values)
*PortalsFolderApi* | [**udm_portals_folder_object_update**](docs/PortalsFolderApi.md#udm_portals_folder_object_update) | **PATCH** /portals/folder/{dn} | Modify an Portal folder object (moving is currently not possible)
*PortalsPortalApi* | [**udm_portals_portal_object**](docs/PortalsPortalApi.md#udm_portals_portal_object) | **GET** /portals/portal/{dn} |  Get a representation of the Portal object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*PortalsPortalApi* | [**udm_portals_portal_object_create**](docs/PortalsPortalApi.md#udm_portals_portal_object_create) | **POST** /portals/portal/ | Create a new Portal object
*PortalsPortalApi* | [**udm_portals_portal_object_modify**](docs/PortalsPortalApi.md#udm_portals_portal_object_modify) | **PUT** /portals/portal/{dn} | Modify or move an Portal object
*PortalsPortalApi* | [**udm_portals_portal_object_remove**](docs/PortalsPortalApi.md#udm_portals_portal_object_remove) | **DELETE** /portals/portal/{dn} | Remove a Portals object
*PortalsPortalApi* | [**udm_portals_portal_object_search**](docs/PortalsPortalApi.md#udm_portals_portal_object_search) | **GET** /portals/portal/ | Search for Portals objects
*PortalsPortalApi* | [**udm_portals_portal_object_template**](docs/PortalsPortalApi.md#udm_portals_portal_object_template) | **GET** /portals/portal/add | Get a template for creating an Portal object (contains all properties and their default values)
*PortalsPortalApi* | [**udm_portals_portal_object_update**](docs/PortalsPortalApi.md#udm_portals_portal_object_update) | **PATCH** /portals/portal/{dn} | Modify an Portal object (moving is currently not possible)
*SamlIdpconfigApi* | [**udm_saml_idpconfig_object**](docs/SamlIdpconfigApi.md#udm_saml_idpconfig_object) | **GET** /saml/idpconfig/{dn} |  Get a representation of the SAML IdP configuration object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SamlIdpconfigApi* | [**udm_saml_idpconfig_object_create**](docs/SamlIdpconfigApi.md#udm_saml_idpconfig_object_create) | **POST** /saml/idpconfig/ | Create a new SAML IdP configuration object
*SamlIdpconfigApi* | [**udm_saml_idpconfig_object_modify**](docs/SamlIdpconfigApi.md#udm_saml_idpconfig_object_modify) | **PUT** /saml/idpconfig/{dn} | Modify or move an SAML IdP configuration object
*SamlIdpconfigApi* | [**udm_saml_idpconfig_object_remove**](docs/SamlIdpconfigApi.md#udm_saml_idpconfig_object_remove) | **DELETE** /saml/idpconfig/{dn} | Remove a SAML IdP configurations object
*SamlIdpconfigApi* | [**udm_saml_idpconfig_object_search**](docs/SamlIdpconfigApi.md#udm_saml_idpconfig_object_search) | **GET** /saml/idpconfig/ | Search for SAML IdP configurations objects
*SamlIdpconfigApi* | [**udm_saml_idpconfig_object_template**](docs/SamlIdpconfigApi.md#udm_saml_idpconfig_object_template) | **GET** /saml/idpconfig/add | Get a template for creating an SAML IdP configuration object (contains all properties and their default values)
*SamlIdpconfigApi* | [**udm_saml_idpconfig_object_update**](docs/SamlIdpconfigApi.md#udm_saml_idpconfig_object_update) | **PATCH** /saml/idpconfig/{dn} | Modify an SAML IdP configuration object (moving is currently not possible)
*SamlServiceproviderApi* | [**udm_saml_serviceprovider_object**](docs/SamlServiceproviderApi.md#udm_saml_serviceprovider_object) | **GET** /saml/serviceprovider/{dn} |  Get a representation of the SAML service provider object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SamlServiceproviderApi* | [**udm_saml_serviceprovider_object_create**](docs/SamlServiceproviderApi.md#udm_saml_serviceprovider_object_create) | **POST** /saml/serviceprovider/ | Create a new SAML service provider object
*SamlServiceproviderApi* | [**udm_saml_serviceprovider_object_modify**](docs/SamlServiceproviderApi.md#udm_saml_serviceprovider_object_modify) | **PUT** /saml/serviceprovider/{dn} | Modify or move an SAML service provider object
*SamlServiceproviderApi* | [**udm_saml_serviceprovider_object_remove**](docs/SamlServiceproviderApi.md#udm_saml_serviceprovider_object_remove) | **DELETE** /saml/serviceprovider/{dn} | Remove a SAML service providers object
*SamlServiceproviderApi* | [**udm_saml_serviceprovider_object_search**](docs/SamlServiceproviderApi.md#udm_saml_serviceprovider_object_search) | **GET** /saml/serviceprovider/ | Search for SAML service providers objects
*SamlServiceproviderApi* | [**udm_saml_serviceprovider_object_template**](docs/SamlServiceproviderApi.md#udm_saml_serviceprovider_object_template) | **GET** /saml/serviceprovider/add | Get a template for creating an SAML service provider object (contains all properties and their default values)
*SamlServiceproviderApi* | [**udm_saml_serviceprovider_object_update**](docs/SamlServiceproviderApi.md#udm_saml_serviceprovider_object_update) | **PATCH** /saml/serviceprovider/{dn} | Modify an SAML service provider object (moving is currently not possible)
*SettingsCnApi* | [**udm_settings_cn_object**](docs/SettingsCnApi.md#udm_settings_cn_object) | **GET** /settings/cn/{dn} |  Get a representation of the Univention Setting object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SettingsCnApi* | [**udm_settings_cn_object_search**](docs/SettingsCnApi.md#udm_settings_cn_object_search) | **GET** /settings/cn/ | Search for Univention Settings objects
*SettingsDataApi* | [**udm_settings_data_object**](docs/SettingsDataApi.md#udm_settings_data_object) | **GET** /settings/data/{dn} |  Get a representation of the Data object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SettingsDataApi* | [**udm_settings_data_object_create**](docs/SettingsDataApi.md#udm_settings_data_object_create) | **POST** /settings/data/ | Create a new Data object
*SettingsDataApi* | [**udm_settings_data_object_modify**](docs/SettingsDataApi.md#udm_settings_data_object_modify) | **PUT** /settings/data/{dn} | Modify or move an Data object
*SettingsDataApi* | [**udm_settings_data_object_remove**](docs/SettingsDataApi.md#udm_settings_data_object_remove) | **DELETE** /settings/data/{dn} | Remove a Data object
*SettingsDataApi* | [**udm_settings_data_object_search**](docs/SettingsDataApi.md#udm_settings_data_object_search) | **GET** /settings/data/ | Search for Data objects
*SettingsDataApi* | [**udm_settings_data_object_template**](docs/SettingsDataApi.md#udm_settings_data_object_template) | **GET** /settings/data/add | Get a template for creating an Data object (contains all properties and their default values)
*SettingsDataApi* | [**udm_settings_data_object_update**](docs/SettingsDataApi.md#udm_settings_data_object_update) | **PATCH** /settings/data/{dn} | Modify an Data object (moving is currently not possible)
*SettingsDefaultApi* | [**udm_settings_default_object**](docs/SettingsDefaultApi.md#udm_settings_default_object) | **GET** /settings/default/{dn} |  Get a representation of the Default preference object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SettingsDefaultApi* | [**udm_settings_default_object_modify**](docs/SettingsDefaultApi.md#udm_settings_default_object_modify) | **PUT** /settings/default/{dn} | Modify or move an Default preference object
*SettingsDefaultApi* | [**udm_settings_default_object_search**](docs/SettingsDefaultApi.md#udm_settings_default_object_search) | **GET** /settings/default/ | Search for Default preferences objects
*SettingsDefaultApi* | [**udm_settings_default_object_update**](docs/SettingsDefaultApi.md#udm_settings_default_object_update) | **PATCH** /settings/default/{dn} | Modify an Default preference object (moving is currently not possible)
*SettingsDirectoryApi* | [**udm_settings_directory_object**](docs/SettingsDirectoryApi.md#udm_settings_directory_object) | **GET** /settings/directory/{dn} |  Get a representation of the Default container object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SettingsDirectoryApi* | [**udm_settings_directory_object_modify**](docs/SettingsDirectoryApi.md#udm_settings_directory_object_modify) | **PUT** /settings/directory/{dn} | Modify or move an Default container object
*SettingsDirectoryApi* | [**udm_settings_directory_object_search**](docs/SettingsDirectoryApi.md#udm_settings_directory_object_search) | **GET** /settings/directory/ | Search for Default containers objects
*SettingsDirectoryApi* | [**udm_settings_directory_object_update**](docs/SettingsDirectoryApi.md#udm_settings_directory_object_update) | **PATCH** /settings/directory/{dn} | Modify an Default container object (moving is currently not possible)
*SettingsExtendedAttributeApi* | [**udm_settings_extended_attribute_object**](docs/SettingsExtendedAttributeApi.md#udm_settings_extended_attribute_object) | **GET** /settings/extended_attribute/{dn} |  Get a representation of the Extended attribute object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SettingsExtendedAttributeApi* | [**udm_settings_extended_attribute_object_create**](docs/SettingsExtendedAttributeApi.md#udm_settings_extended_attribute_object_create) | **POST** /settings/extended_attribute/ | Create a new Extended attribute object
*SettingsExtendedAttributeApi* | [**udm_settings_extended_attribute_object_modify**](docs/SettingsExtendedAttributeApi.md#udm_settings_extended_attribute_object_modify) | **PUT** /settings/extended_attribute/{dn} | Modify or move an Extended attribute object
*SettingsExtendedAttributeApi* | [**udm_settings_extended_attribute_object_remove**](docs/SettingsExtendedAttributeApi.md#udm_settings_extended_attribute_object_remove) | **DELETE** /settings/extended_attribute/{dn} | Remove a Extended attributes object
*SettingsExtendedAttributeApi* | [**udm_settings_extended_attribute_object_search**](docs/SettingsExtendedAttributeApi.md#udm_settings_extended_attribute_object_search) | **GET** /settings/extended_attribute/ | Search for Extended attributes objects
*SettingsExtendedAttributeApi* | [**udm_settings_extended_attribute_object_template**](docs/SettingsExtendedAttributeApi.md#udm_settings_extended_attribute_object_template) | **GET** /settings/extended_attribute/add | Get a template for creating an Extended attribute object (contains all properties and their default values)
*SettingsExtendedAttributeApi* | [**udm_settings_extended_attribute_object_update**](docs/SettingsExtendedAttributeApi.md#udm_settings_extended_attribute_object_update) | **PATCH** /settings/extended_attribute/{dn} | Modify an Extended attribute object (moving is currently not possible)
*SettingsExtendedOptionsApi* | [**udm_settings_extended_options_object**](docs/SettingsExtendedOptionsApi.md#udm_settings_extended_options_object) | **GET** /settings/extended_options/{dn} |  Get a representation of the Extended option object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SettingsExtendedOptionsApi* | [**udm_settings_extended_options_object_create**](docs/SettingsExtendedOptionsApi.md#udm_settings_extended_options_object_create) | **POST** /settings/extended_options/ | Create a new Extended option object
*SettingsExtendedOptionsApi* | [**udm_settings_extended_options_object_modify**](docs/SettingsExtendedOptionsApi.md#udm_settings_extended_options_object_modify) | **PUT** /settings/extended_options/{dn} | Modify or move an Extended option object
*SettingsExtendedOptionsApi* | [**udm_settings_extended_options_object_remove**](docs/SettingsExtendedOptionsApi.md#udm_settings_extended_options_object_remove) | **DELETE** /settings/extended_options/{dn} | Remove a Extended options object
*SettingsExtendedOptionsApi* | [**udm_settings_extended_options_object_search**](docs/SettingsExtendedOptionsApi.md#udm_settings_extended_options_object_search) | **GET** /settings/extended_options/ | Search for Extended options objects
*SettingsExtendedOptionsApi* | [**udm_settings_extended_options_object_template**](docs/SettingsExtendedOptionsApi.md#udm_settings_extended_options_object_template) | **GET** /settings/extended_options/add | Get a template for creating an Extended option object (contains all properties and their default values)
*SettingsExtendedOptionsApi* | [**udm_settings_extended_options_object_update**](docs/SettingsExtendedOptionsApi.md#udm_settings_extended_options_object_update) | **PATCH** /settings/extended_options/{dn} | Modify an Extended option object (moving is currently not possible)
*SettingsLdapaclApi* | [**udm_settings_ldapacl_object**](docs/SettingsLdapaclApi.md#udm_settings_ldapacl_object) | **GET** /settings/ldapacl/{dn} |  Get a representation of the LDAP ACL Extension object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SettingsLdapaclApi* | [**udm_settings_ldapacl_object_create**](docs/SettingsLdapaclApi.md#udm_settings_ldapacl_object_create) | **POST** /settings/ldapacl/ | Create a new LDAP ACL Extension object
*SettingsLdapaclApi* | [**udm_settings_ldapacl_object_modify**](docs/SettingsLdapaclApi.md#udm_settings_ldapacl_object_modify) | **PUT** /settings/ldapacl/{dn} | Modify or move an LDAP ACL Extension object
*SettingsLdapaclApi* | [**udm_settings_ldapacl_object_remove**](docs/SettingsLdapaclApi.md#udm_settings_ldapacl_object_remove) | **DELETE** /settings/ldapacl/{dn} | Remove a LDAP ACL Extensions object
*SettingsLdapaclApi* | [**udm_settings_ldapacl_object_search**](docs/SettingsLdapaclApi.md#udm_settings_ldapacl_object_search) | **GET** /settings/ldapacl/ | Search for LDAP ACL Extensions objects
*SettingsLdapaclApi* | [**udm_settings_ldapacl_object_template**](docs/SettingsLdapaclApi.md#udm_settings_ldapacl_object_template) | **GET** /settings/ldapacl/add | Get a template for creating an LDAP ACL Extension object (contains all properties and their default values)
*SettingsLdapaclApi* | [**udm_settings_ldapacl_object_update**](docs/SettingsLdapaclApi.md#udm_settings_ldapacl_object_update) | **PATCH** /settings/ldapacl/{dn} | Modify an LDAP ACL Extension object (moving is currently not possible)
*SettingsLdapschemaApi* | [**udm_settings_ldapschema_object**](docs/SettingsLdapschemaApi.md#udm_settings_ldapschema_object) | **GET** /settings/ldapschema/{dn} |  Get a representation of the LDAP Schema Extension object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SettingsLdapschemaApi* | [**udm_settings_ldapschema_object_create**](docs/SettingsLdapschemaApi.md#udm_settings_ldapschema_object_create) | **POST** /settings/ldapschema/ | Create a new LDAP Schema Extension object
*SettingsLdapschemaApi* | [**udm_settings_ldapschema_object_modify**](docs/SettingsLdapschemaApi.md#udm_settings_ldapschema_object_modify) | **PUT** /settings/ldapschema/{dn} | Modify or move an LDAP Schema Extension object
*SettingsLdapschemaApi* | [**udm_settings_ldapschema_object_remove**](docs/SettingsLdapschemaApi.md#udm_settings_ldapschema_object_remove) | **DELETE** /settings/ldapschema/{dn} | Remove a LDAP Schema Extensions object
*SettingsLdapschemaApi* | [**udm_settings_ldapschema_object_search**](docs/SettingsLdapschemaApi.md#udm_settings_ldapschema_object_search) | **GET** /settings/ldapschema/ | Search for LDAP Schema Extensions objects
*SettingsLdapschemaApi* | [**udm_settings_ldapschema_object_template**](docs/SettingsLdapschemaApi.md#udm_settings_ldapschema_object_template) | **GET** /settings/ldapschema/add | Get a template for creating an LDAP Schema Extension object (contains all properties and their default values)
*SettingsLdapschemaApi* | [**udm_settings_ldapschema_object_update**](docs/SettingsLdapschemaApi.md#udm_settings_ldapschema_object_update) | **PATCH** /settings/ldapschema/{dn} | Modify an LDAP Schema Extension object (moving is currently not possible)
*SettingsLicenseApi* | [**udm_settings_license_object**](docs/SettingsLicenseApi.md#udm_settings_license_object) | **GET** /settings/license/{dn} |  Get a representation of the License object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SettingsLicenseApi* | [**udm_settings_license_object_remove**](docs/SettingsLicenseApi.md#udm_settings_license_object_remove) | **DELETE** /settings/license/{dn} | Remove a Licenses object
*SettingsLicenseApi* | [**udm_settings_license_object_search**](docs/SettingsLicenseApi.md#udm_settings_license_object_search) | **GET** /settings/license/ | Search for Licenses objects
*SettingsLockApi* | [**udm_settings_lock_object**](docs/SettingsLockApi.md#udm_settings_lock_object) | **GET** /settings/lock/{dn} |  Get a representation of the Lock object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SettingsLockApi* | [**udm_settings_lock_object_modify**](docs/SettingsLockApi.md#udm_settings_lock_object_modify) | **PUT** /settings/lock/{dn} | Modify or move an Lock object
*SettingsLockApi* | [**udm_settings_lock_object_remove**](docs/SettingsLockApi.md#udm_settings_lock_object_remove) | **DELETE** /settings/lock/{dn} | Remove a Locks object
*SettingsLockApi* | [**udm_settings_lock_object_search**](docs/SettingsLockApi.md#udm_settings_lock_object_search) | **GET** /settings/lock/ | Search for Locks objects
*SettingsLockApi* | [**udm_settings_lock_object_update**](docs/SettingsLockApi.md#udm_settings_lock_object_update) | **PATCH** /settings/lock/{dn} | Modify an Lock object (moving is currently not possible)
*SettingsMsprintconnectionpolicyApi* | [**udm_settings_msprintconnectionpolicy_object**](docs/SettingsMsprintconnectionpolicyApi.md#udm_settings_msprintconnectionpolicy_object) | **GET** /settings/msprintconnectionpolicy/{dn} |  Get a representation of the Settings: MS Print Connection Policy object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SettingsMsprintconnectionpolicyApi* | [**udm_settings_msprintconnectionpolicy_object_create**](docs/SettingsMsprintconnectionpolicyApi.md#udm_settings_msprintconnectionpolicy_object_create) | **POST** /settings/msprintconnectionpolicy/ | Create a new Settings: MS Print Connection Policy object
*SettingsMsprintconnectionpolicyApi* | [**udm_settings_msprintconnectionpolicy_object_modify**](docs/SettingsMsprintconnectionpolicyApi.md#udm_settings_msprintconnectionpolicy_object_modify) | **PUT** /settings/msprintconnectionpolicy/{dn} | Modify or move an Settings: MS Print Connection Policy object
*SettingsMsprintconnectionpolicyApi* | [**udm_settings_msprintconnectionpolicy_object_remove**](docs/SettingsMsprintconnectionpolicyApi.md#udm_settings_msprintconnectionpolicy_object_remove) | **DELETE** /settings/msprintconnectionpolicy/{dn} | Remove a Settings: MS Print Connection Policy object
*SettingsMsprintconnectionpolicyApi* | [**udm_settings_msprintconnectionpolicy_object_search**](docs/SettingsMsprintconnectionpolicyApi.md#udm_settings_msprintconnectionpolicy_object_search) | **GET** /settings/msprintconnectionpolicy/ | Search for Settings: MS Print Connection Policy objects
*SettingsMsprintconnectionpolicyApi* | [**udm_settings_msprintconnectionpolicy_object_template**](docs/SettingsMsprintconnectionpolicyApi.md#udm_settings_msprintconnectionpolicy_object_template) | **GET** /settings/msprintconnectionpolicy/add | Get a template for creating an Settings: MS Print Connection Policy object (contains all properties and their default values)
*SettingsMsprintconnectionpolicyApi* | [**udm_settings_msprintconnectionpolicy_object_update**](docs/SettingsMsprintconnectionpolicyApi.md#udm_settings_msprintconnectionpolicy_object_update) | **PATCH** /settings/msprintconnectionpolicy/{dn} | Modify an Settings: MS Print Connection Policy object (moving is currently not possible)
*SettingsMswmifilterApi* | [**udm_settings_mswmifilter_object**](docs/SettingsMswmifilterApi.md#udm_settings_mswmifilter_object) | **GET** /settings/mswmifilter/{dn} |  Get a representation of the Settings: MS WMI Filter object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SettingsMswmifilterApi* | [**udm_settings_mswmifilter_object_create**](docs/SettingsMswmifilterApi.md#udm_settings_mswmifilter_object_create) | **POST** /settings/mswmifilter/ | Create a new Settings: MS WMI Filter object
*SettingsMswmifilterApi* | [**udm_settings_mswmifilter_object_modify**](docs/SettingsMswmifilterApi.md#udm_settings_mswmifilter_object_modify) | **PUT** /settings/mswmifilter/{dn} | Modify or move an Settings: MS WMI Filter object
*SettingsMswmifilterApi* | [**udm_settings_mswmifilter_object_remove**](docs/SettingsMswmifilterApi.md#udm_settings_mswmifilter_object_remove) | **DELETE** /settings/mswmifilter/{dn} | Remove a Settings: MS WMI Filter object
*SettingsMswmifilterApi* | [**udm_settings_mswmifilter_object_search**](docs/SettingsMswmifilterApi.md#udm_settings_mswmifilter_object_search) | **GET** /settings/mswmifilter/ | Search for Settings: MS WMI Filter objects
*SettingsMswmifilterApi* | [**udm_settings_mswmifilter_object_template**](docs/SettingsMswmifilterApi.md#udm_settings_mswmifilter_object_template) | **GET** /settings/mswmifilter/add | Get a template for creating an Settings: MS WMI Filter object (contains all properties and their default values)
*SettingsMswmifilterApi* | [**udm_settings_mswmifilter_object_update**](docs/SettingsMswmifilterApi.md#udm_settings_mswmifilter_object_update) | **PATCH** /settings/mswmifilter/{dn} | Modify an Settings: MS WMI Filter object (moving is currently not possible)
*SettingsPackagesApi* | [**udm_settings_packages_object**](docs/SettingsPackagesApi.md#udm_settings_packages_object) | **GET** /settings/packages/{dn} |  Get a representation of the Package List object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SettingsPackagesApi* | [**udm_settings_packages_object_create**](docs/SettingsPackagesApi.md#udm_settings_packages_object_create) | **POST** /settings/packages/ | Create a new Package List object
*SettingsPackagesApi* | [**udm_settings_packages_object_modify**](docs/SettingsPackagesApi.md#udm_settings_packages_object_modify) | **PUT** /settings/packages/{dn} | Modify or move an Package List object
*SettingsPackagesApi* | [**udm_settings_packages_object_remove**](docs/SettingsPackagesApi.md#udm_settings_packages_object_remove) | **DELETE** /settings/packages/{dn} | Remove a Package Lists object
*SettingsPackagesApi* | [**udm_settings_packages_object_search**](docs/SettingsPackagesApi.md#udm_settings_packages_object_search) | **GET** /settings/packages/ | Search for Package Lists objects
*SettingsPackagesApi* | [**udm_settings_packages_object_template**](docs/SettingsPackagesApi.md#udm_settings_packages_object_template) | **GET** /settings/packages/add | Get a template for creating an Package List object (contains all properties and their default values)
*SettingsPackagesApi* | [**udm_settings_packages_object_update**](docs/SettingsPackagesApi.md#udm_settings_packages_object_update) | **PATCH** /settings/packages/{dn} | Modify an Package List object (moving is currently not possible)
*SettingsPortalApi* | [**udm_settings_portal_object**](docs/SettingsPortalApi.md#udm_settings_portal_object) | **GET** /settings/portal/{dn} |  Get a representation of the Deprecated Portal object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SettingsPortalApi* | [**udm_settings_portal_object_create**](docs/SettingsPortalApi.md#udm_settings_portal_object_create) | **POST** /settings/portal/ | Create a new Deprecated Portal object
*SettingsPortalApi* | [**udm_settings_portal_object_modify**](docs/SettingsPortalApi.md#udm_settings_portal_object_modify) | **PUT** /settings/portal/{dn} | Modify or move an Deprecated Portal object
*SettingsPortalApi* | [**udm_settings_portal_object_remove**](docs/SettingsPortalApi.md#udm_settings_portal_object_remove) | **DELETE** /settings/portal/{dn} | Remove a Deprecated Portals object
*SettingsPortalApi* | [**udm_settings_portal_object_search**](docs/SettingsPortalApi.md#udm_settings_portal_object_search) | **GET** /settings/portal/ | Search for Deprecated Portals objects
*SettingsPortalApi* | [**udm_settings_portal_object_template**](docs/SettingsPortalApi.md#udm_settings_portal_object_template) | **GET** /settings/portal/add | Get a template for creating an Deprecated Portal object (contains all properties and their default values)
*SettingsPortalApi* | [**udm_settings_portal_object_update**](docs/SettingsPortalApi.md#udm_settings_portal_object_update) | **PATCH** /settings/portal/{dn} | Modify an Deprecated Portal object (moving is currently not possible)
*SettingsPortalAllApi* | [**udm_settings_portal_all_object**](docs/SettingsPortalAllApi.md#udm_settings_portal_all_object) | **GET** /settings/portal_all/{dn} |  Get a representation of the Deprecated Portal: Settings object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SettingsPortalAllApi* | [**udm_settings_portal_all_object_search**](docs/SettingsPortalAllApi.md#udm_settings_portal_all_object_search) | **GET** /settings/portal_all/ | Search for Deprecated Portal: Settings objects
*SettingsPortalCategoryApi* | [**udm_settings_portal_category_object**](docs/SettingsPortalCategoryApi.md#udm_settings_portal_category_object) | **GET** /settings/portal_category/{dn} |  Get a representation of the Deprecated Portal category object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SettingsPortalCategoryApi* | [**udm_settings_portal_category_object_create**](docs/SettingsPortalCategoryApi.md#udm_settings_portal_category_object_create) | **POST** /settings/portal_category/ | Create a new Deprecated Portal category object
*SettingsPortalCategoryApi* | [**udm_settings_portal_category_object_modify**](docs/SettingsPortalCategoryApi.md#udm_settings_portal_category_object_modify) | **PUT** /settings/portal_category/{dn} | Modify or move an Deprecated Portal category object
*SettingsPortalCategoryApi* | [**udm_settings_portal_category_object_remove**](docs/SettingsPortalCategoryApi.md#udm_settings_portal_category_object_remove) | **DELETE** /settings/portal_category/{dn} | Remove a Deprecated Portal categories object
*SettingsPortalCategoryApi* | [**udm_settings_portal_category_object_search**](docs/SettingsPortalCategoryApi.md#udm_settings_portal_category_object_search) | **GET** /settings/portal_category/ | Search for Deprecated Portal categories objects
*SettingsPortalCategoryApi* | [**udm_settings_portal_category_object_template**](docs/SettingsPortalCategoryApi.md#udm_settings_portal_category_object_template) | **GET** /settings/portal_category/add | Get a template for creating an Deprecated Portal category object (contains all properties and their default values)
*SettingsPortalCategoryApi* | [**udm_settings_portal_category_object_update**](docs/SettingsPortalCategoryApi.md#udm_settings_portal_category_object_update) | **PATCH** /settings/portal_category/{dn} | Modify an Deprecated Portal category object (moving is currently not possible)
*SettingsPortalEntryApi* | [**udm_settings_portal_entry_object**](docs/SettingsPortalEntryApi.md#udm_settings_portal_entry_object) | **GET** /settings/portal_entry/{dn} |  Get a representation of the Deprecated Portal entry object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SettingsPortalEntryApi* | [**udm_settings_portal_entry_object_create**](docs/SettingsPortalEntryApi.md#udm_settings_portal_entry_object_create) | **POST** /settings/portal_entry/ | Create a new Deprecated Portal entry object
*SettingsPortalEntryApi* | [**udm_settings_portal_entry_object_modify**](docs/SettingsPortalEntryApi.md#udm_settings_portal_entry_object_modify) | **PUT** /settings/portal_entry/{dn} | Modify or move an Deprecated Portal entry object
*SettingsPortalEntryApi* | [**udm_settings_portal_entry_object_remove**](docs/SettingsPortalEntryApi.md#udm_settings_portal_entry_object_remove) | **DELETE** /settings/portal_entry/{dn} | Remove a Deprecated Portal entries object
*SettingsPortalEntryApi* | [**udm_settings_portal_entry_object_search**](docs/SettingsPortalEntryApi.md#udm_settings_portal_entry_object_search) | **GET** /settings/portal_entry/ | Search for Deprecated Portal entries objects
*SettingsPortalEntryApi* | [**udm_settings_portal_entry_object_template**](docs/SettingsPortalEntryApi.md#udm_settings_portal_entry_object_template) | **GET** /settings/portal_entry/add | Get a template for creating an Deprecated Portal entry object (contains all properties and their default values)
*SettingsPortalEntryApi* | [**udm_settings_portal_entry_object_update**](docs/SettingsPortalEntryApi.md#udm_settings_portal_entry_object_update) | **PATCH** /settings/portal_entry/{dn} | Modify an Deprecated Portal entry object (moving is currently not possible)
*SettingsPrintermodelApi* | [**udm_settings_printermodel_object**](docs/SettingsPrintermodelApi.md#udm_settings_printermodel_object) | **GET** /settings/printermodel/{dn} |  Get a representation of the Printer Driver List object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SettingsPrintermodelApi* | [**udm_settings_printermodel_object_create**](docs/SettingsPrintermodelApi.md#udm_settings_printermodel_object_create) | **POST** /settings/printermodel/ | Create a new Printer Driver List object
*SettingsPrintermodelApi* | [**udm_settings_printermodel_object_modify**](docs/SettingsPrintermodelApi.md#udm_settings_printermodel_object_modify) | **PUT** /settings/printermodel/{dn} | Modify or move an Printer Driver List object
*SettingsPrintermodelApi* | [**udm_settings_printermodel_object_remove**](docs/SettingsPrintermodelApi.md#udm_settings_printermodel_object_remove) | **DELETE** /settings/printermodel/{dn} | Remove a Printer Driver Lists object
*SettingsPrintermodelApi* | [**udm_settings_printermodel_object_search**](docs/SettingsPrintermodelApi.md#udm_settings_printermodel_object_search) | **GET** /settings/printermodel/ | Search for Printer Driver Lists objects
*SettingsPrintermodelApi* | [**udm_settings_printermodel_object_template**](docs/SettingsPrintermodelApi.md#udm_settings_printermodel_object_template) | **GET** /settings/printermodel/add | Get a template for creating an Printer Driver List object (contains all properties and their default values)
*SettingsPrintermodelApi* | [**udm_settings_printermodel_object_update**](docs/SettingsPrintermodelApi.md#udm_settings_printermodel_object_update) | **PATCH** /settings/printermodel/{dn} | Modify an Printer Driver List object (moving is currently not possible)
*SettingsPrinteruriApi* | [**udm_settings_printeruri_object**](docs/SettingsPrinteruriApi.md#udm_settings_printeruri_object) | **GET** /settings/printeruri/{dn} |  Get a representation of the Printer URI List object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SettingsPrinteruriApi* | [**udm_settings_printeruri_object_create**](docs/SettingsPrinteruriApi.md#udm_settings_printeruri_object_create) | **POST** /settings/printeruri/ | Create a new Printer URI List object
*SettingsPrinteruriApi* | [**udm_settings_printeruri_object_modify**](docs/SettingsPrinteruriApi.md#udm_settings_printeruri_object_modify) | **PUT** /settings/printeruri/{dn} | Modify or move an Printer URI List object
*SettingsPrinteruriApi* | [**udm_settings_printeruri_object_remove**](docs/SettingsPrinteruriApi.md#udm_settings_printeruri_object_remove) | **DELETE** /settings/printeruri/{dn} | Remove a Printer URI Lists object
*SettingsPrinteruriApi* | [**udm_settings_printeruri_object_search**](docs/SettingsPrinteruriApi.md#udm_settings_printeruri_object_search) | **GET** /settings/printeruri/ | Search for Printer URI Lists objects
*SettingsPrinteruriApi* | [**udm_settings_printeruri_object_template**](docs/SettingsPrinteruriApi.md#udm_settings_printeruri_object_template) | **GET** /settings/printeruri/add | Get a template for creating an Printer URI List object (contains all properties and their default values)
*SettingsPrinteruriApi* | [**udm_settings_printeruri_object_update**](docs/SettingsPrinteruriApi.md#udm_settings_printeruri_object_update) | **PATCH** /settings/printeruri/{dn} | Modify an Printer URI List object (moving is currently not possible)
*SettingsProhibitedUsernameApi* | [**udm_settings_prohibited_username_object**](docs/SettingsProhibitedUsernameApi.md#udm_settings_prohibited_username_object) | **GET** /settings/prohibited_username/{dn} |  Get a representation of the Prohibited user name object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SettingsProhibitedUsernameApi* | [**udm_settings_prohibited_username_object_create**](docs/SettingsProhibitedUsernameApi.md#udm_settings_prohibited_username_object_create) | **POST** /settings/prohibited_username/ | Create a new Prohibited user name object
*SettingsProhibitedUsernameApi* | [**udm_settings_prohibited_username_object_modify**](docs/SettingsProhibitedUsernameApi.md#udm_settings_prohibited_username_object_modify) | **PUT** /settings/prohibited_username/{dn} | Modify or move an Prohibited user name object
*SettingsProhibitedUsernameApi* | [**udm_settings_prohibited_username_object_remove**](docs/SettingsProhibitedUsernameApi.md#udm_settings_prohibited_username_object_remove) | **DELETE** /settings/prohibited_username/{dn} | Remove a Prohibited user names object
*SettingsProhibitedUsernameApi* | [**udm_settings_prohibited_username_object_search**](docs/SettingsProhibitedUsernameApi.md#udm_settings_prohibited_username_object_search) | **GET** /settings/prohibited_username/ | Search for Prohibited user names objects
*SettingsProhibitedUsernameApi* | [**udm_settings_prohibited_username_object_template**](docs/SettingsProhibitedUsernameApi.md#udm_settings_prohibited_username_object_template) | **GET** /settings/prohibited_username/add | Get a template for creating an Prohibited user name object (contains all properties and their default values)
*SettingsProhibitedUsernameApi* | [**udm_settings_prohibited_username_object_update**](docs/SettingsProhibitedUsernameApi.md#udm_settings_prohibited_username_object_update) | **PATCH** /settings/prohibited_username/{dn} | Modify an Prohibited user name object (moving is currently not possible)
*SettingsSambaconfigApi* | [**udm_settings_sambaconfig_object**](docs/SettingsSambaconfigApi.md#udm_settings_sambaconfig_object) | **GET** /settings/sambaconfig/{dn} |  Get a representation of the Samba Configuration object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SettingsSambaconfigApi* | [**udm_settings_sambaconfig_object_modify**](docs/SettingsSambaconfigApi.md#udm_settings_sambaconfig_object_modify) | **PUT** /settings/sambaconfig/{dn} | Modify or move an Samba Configuration object
*SettingsSambaconfigApi* | [**udm_settings_sambaconfig_object_remove**](docs/SettingsSambaconfigApi.md#udm_settings_sambaconfig_object_remove) | **DELETE** /settings/sambaconfig/{dn} | Remove a Samba Configuration settings object
*SettingsSambaconfigApi* | [**udm_settings_sambaconfig_object_search**](docs/SettingsSambaconfigApi.md#udm_settings_sambaconfig_object_search) | **GET** /settings/sambaconfig/ | Search for Samba Configuration settings objects
*SettingsSambaconfigApi* | [**udm_settings_sambaconfig_object_update**](docs/SettingsSambaconfigApi.md#udm_settings_sambaconfig_object_update) | **PATCH** /settings/sambaconfig/{dn} | Modify an Samba Configuration object (moving is currently not possible)
*SettingsSambadomainApi* | [**udm_settings_sambadomain_object**](docs/SettingsSambadomainApi.md#udm_settings_sambadomain_object) | **GET** /settings/sambadomain/{dn} |  Get a representation of the Samba Domain object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SettingsSambadomainApi* | [**udm_settings_sambadomain_object_create**](docs/SettingsSambadomainApi.md#udm_settings_sambadomain_object_create) | **POST** /settings/sambadomain/ | Create a new Samba Domain object
*SettingsSambadomainApi* | [**udm_settings_sambadomain_object_modify**](docs/SettingsSambadomainApi.md#udm_settings_sambadomain_object_modify) | **PUT** /settings/sambadomain/{dn} | Modify or move an Samba Domain object
*SettingsSambadomainApi* | [**udm_settings_sambadomain_object_remove**](docs/SettingsSambadomainApi.md#udm_settings_sambadomain_object_remove) | **DELETE** /settings/sambadomain/{dn} | Remove a Samba Domains object
*SettingsSambadomainApi* | [**udm_settings_sambadomain_object_search**](docs/SettingsSambadomainApi.md#udm_settings_sambadomain_object_search) | **GET** /settings/sambadomain/ | Search for Samba Domains objects
*SettingsSambadomainApi* | [**udm_settings_sambadomain_object_template**](docs/SettingsSambadomainApi.md#udm_settings_sambadomain_object_template) | **GET** /settings/sambadomain/add | Get a template for creating an Samba Domain object (contains all properties and their default values)
*SettingsSambadomainApi* | [**udm_settings_sambadomain_object_update**](docs/SettingsSambadomainApi.md#udm_settings_sambadomain_object_update) | **PATCH** /settings/sambadomain/{dn} | Modify an Samba Domain object (moving is currently not possible)
*SettingsServiceApi* | [**udm_settings_service_object**](docs/SettingsServiceApi.md#udm_settings_service_object) | **GET** /settings/service/{dn} |  Get a representation of the Service object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SettingsServiceApi* | [**udm_settings_service_object_create**](docs/SettingsServiceApi.md#udm_settings_service_object_create) | **POST** /settings/service/ | Create a new Service object
*SettingsServiceApi* | [**udm_settings_service_object_modify**](docs/SettingsServiceApi.md#udm_settings_service_object_modify) | **PUT** /settings/service/{dn} | Modify or move an Service object
*SettingsServiceApi* | [**udm_settings_service_object_remove**](docs/SettingsServiceApi.md#udm_settings_service_object_remove) | **DELETE** /settings/service/{dn} | Remove a Services object
*SettingsServiceApi* | [**udm_settings_service_object_search**](docs/SettingsServiceApi.md#udm_settings_service_object_search) | **GET** /settings/service/ | Search for Services objects
*SettingsServiceApi* | [**udm_settings_service_object_template**](docs/SettingsServiceApi.md#udm_settings_service_object_template) | **GET** /settings/service/add | Get a template for creating an Service object (contains all properties and their default values)
*SettingsServiceApi* | [**udm_settings_service_object_update**](docs/SettingsServiceApi.md#udm_settings_service_object_update) | **PATCH** /settings/service/{dn} | Modify an Service object (moving is currently not possible)
*SettingsSettingsApi* | [**udm_settings_settings_object**](docs/SettingsSettingsApi.md#udm_settings_settings_object) | **GET** /settings/settings/{dn} |  Get a representation of the Preference object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SettingsSettingsApi* | [**udm_settings_settings_object_search**](docs/SettingsSettingsApi.md#udm_settings_settings_object_search) | **GET** /settings/settings/ | Search for Preferences objects
*SettingsSyntaxApi* | [**udm_settings_syntax_object**](docs/SettingsSyntaxApi.md#udm_settings_syntax_object) | **GET** /settings/syntax/{dn} |  Get a representation of the Syntax Definition object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SettingsSyntaxApi* | [**udm_settings_syntax_object_create**](docs/SettingsSyntaxApi.md#udm_settings_syntax_object_create) | **POST** /settings/syntax/ | Create a new Syntax Definition object
*SettingsSyntaxApi* | [**udm_settings_syntax_object_modify**](docs/SettingsSyntaxApi.md#udm_settings_syntax_object_modify) | **PUT** /settings/syntax/{dn} | Modify or move an Syntax Definition object
*SettingsSyntaxApi* | [**udm_settings_syntax_object_remove**](docs/SettingsSyntaxApi.md#udm_settings_syntax_object_remove) | **DELETE** /settings/syntax/{dn} | Remove a Syntax Definitions object
*SettingsSyntaxApi* | [**udm_settings_syntax_object_search**](docs/SettingsSyntaxApi.md#udm_settings_syntax_object_search) | **GET** /settings/syntax/ | Search for Syntax Definitions objects
*SettingsSyntaxApi* | [**udm_settings_syntax_object_template**](docs/SettingsSyntaxApi.md#udm_settings_syntax_object_template) | **GET** /settings/syntax/add | Get a template for creating an Syntax Definition object (contains all properties and their default values)
*SettingsSyntaxApi* | [**udm_settings_syntax_object_update**](docs/SettingsSyntaxApi.md#udm_settings_syntax_object_update) | **PATCH** /settings/syntax/{dn} | Modify an Syntax Definition object (moving is currently not possible)
*SettingsUdmHookApi* | [**udm_settings_udm_hook_object**](docs/SettingsUdmHookApi.md#udm_settings_udm_hook_object) | **GET** /settings/udm_hook/{dn} |  Get a representation of the UDM Hook object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SettingsUdmHookApi* | [**udm_settings_udm_hook_object_create**](docs/SettingsUdmHookApi.md#udm_settings_udm_hook_object_create) | **POST** /settings/udm_hook/ | Create a new UDM Hook object
*SettingsUdmHookApi* | [**udm_settings_udm_hook_object_modify**](docs/SettingsUdmHookApi.md#udm_settings_udm_hook_object_modify) | **PUT** /settings/udm_hook/{dn} | Modify or move an UDM Hook object
*SettingsUdmHookApi* | [**udm_settings_udm_hook_object_remove**](docs/SettingsUdmHookApi.md#udm_settings_udm_hook_object_remove) | **DELETE** /settings/udm_hook/{dn} | Remove a UDM Hooks object
*SettingsUdmHookApi* | [**udm_settings_udm_hook_object_search**](docs/SettingsUdmHookApi.md#udm_settings_udm_hook_object_search) | **GET** /settings/udm_hook/ | Search for UDM Hooks objects
*SettingsUdmHookApi* | [**udm_settings_udm_hook_object_template**](docs/SettingsUdmHookApi.md#udm_settings_udm_hook_object_template) | **GET** /settings/udm_hook/add | Get a template for creating an UDM Hook object (contains all properties and their default values)
*SettingsUdmHookApi* | [**udm_settings_udm_hook_object_update**](docs/SettingsUdmHookApi.md#udm_settings_udm_hook_object_update) | **PATCH** /settings/udm_hook/{dn} | Modify an UDM Hook object (moving is currently not possible)
*SettingsUdmModuleApi* | [**udm_settings_udm_module_object**](docs/SettingsUdmModuleApi.md#udm_settings_udm_module_object) | **GET** /settings/udm_module/{dn} |  Get a representation of the UDM Module object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SettingsUdmModuleApi* | [**udm_settings_udm_module_object_create**](docs/SettingsUdmModuleApi.md#udm_settings_udm_module_object_create) | **POST** /settings/udm_module/ | Create a new UDM Module object
*SettingsUdmModuleApi* | [**udm_settings_udm_module_object_modify**](docs/SettingsUdmModuleApi.md#udm_settings_udm_module_object_modify) | **PUT** /settings/udm_module/{dn} | Modify or move an UDM Module object
*SettingsUdmModuleApi* | [**udm_settings_udm_module_object_remove**](docs/SettingsUdmModuleApi.md#udm_settings_udm_module_object_remove) | **DELETE** /settings/udm_module/{dn} | Remove a UDM Modules object
*SettingsUdmModuleApi* | [**udm_settings_udm_module_object_search**](docs/SettingsUdmModuleApi.md#udm_settings_udm_module_object_search) | **GET** /settings/udm_module/ | Search for UDM Modules objects
*SettingsUdmModuleApi* | [**udm_settings_udm_module_object_template**](docs/SettingsUdmModuleApi.md#udm_settings_udm_module_object_template) | **GET** /settings/udm_module/add | Get a template for creating an UDM Module object (contains all properties and their default values)
*SettingsUdmModuleApi* | [**udm_settings_udm_module_object_update**](docs/SettingsUdmModuleApi.md#udm_settings_udm_module_object_update) | **PATCH** /settings/udm_module/{dn} | Modify an UDM Module object (moving is currently not possible)
*SettingsUdmSyntaxApi* | [**udm_settings_udm_syntax_object**](docs/SettingsUdmSyntaxApi.md#udm_settings_udm_syntax_object) | **GET** /settings/udm_syntax/{dn} |  Get a representation of the UDM Syntax object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SettingsUdmSyntaxApi* | [**udm_settings_udm_syntax_object_create**](docs/SettingsUdmSyntaxApi.md#udm_settings_udm_syntax_object_create) | **POST** /settings/udm_syntax/ | Create a new UDM Syntax object
*SettingsUdmSyntaxApi* | [**udm_settings_udm_syntax_object_modify**](docs/SettingsUdmSyntaxApi.md#udm_settings_udm_syntax_object_modify) | **PUT** /settings/udm_syntax/{dn} | Modify or move an UDM Syntax object
*SettingsUdmSyntaxApi* | [**udm_settings_udm_syntax_object_remove**](docs/SettingsUdmSyntaxApi.md#udm_settings_udm_syntax_object_remove) | **DELETE** /settings/udm_syntax/{dn} | Remove a UDM Syntaxes object
*SettingsUdmSyntaxApi* | [**udm_settings_udm_syntax_object_search**](docs/SettingsUdmSyntaxApi.md#udm_settings_udm_syntax_object_search) | **GET** /settings/udm_syntax/ | Search for UDM Syntaxes objects
*SettingsUdmSyntaxApi* | [**udm_settings_udm_syntax_object_template**](docs/SettingsUdmSyntaxApi.md#udm_settings_udm_syntax_object_template) | **GET** /settings/udm_syntax/add | Get a template for creating an UDM Syntax object (contains all properties and their default values)
*SettingsUdmSyntaxApi* | [**udm_settings_udm_syntax_object_update**](docs/SettingsUdmSyntaxApi.md#udm_settings_udm_syntax_object_update) | **PATCH** /settings/udm_syntax/{dn} | Modify an UDM Syntax object (moving is currently not possible)
*SettingsUmcOperationsetApi* | [**udm_settings_umc_operationset_object**](docs/SettingsUmcOperationsetApi.md#udm_settings_umc_operationset_object) | **GET** /settings/umc_operationset/{dn} |  Get a representation of the UMC operation set object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SettingsUmcOperationsetApi* | [**udm_settings_umc_operationset_object_create**](docs/SettingsUmcOperationsetApi.md#udm_settings_umc_operationset_object_create) | **POST** /settings/umc_operationset/ | Create a new UMC operation set object
*SettingsUmcOperationsetApi* | [**udm_settings_umc_operationset_object_modify**](docs/SettingsUmcOperationsetApi.md#udm_settings_umc_operationset_object_modify) | **PUT** /settings/umc_operationset/{dn} | Modify or move an UMC operation set object
*SettingsUmcOperationsetApi* | [**udm_settings_umc_operationset_object_remove**](docs/SettingsUmcOperationsetApi.md#udm_settings_umc_operationset_object_remove) | **DELETE** /settings/umc_operationset/{dn} | Remove a UMC operation sets object
*SettingsUmcOperationsetApi* | [**udm_settings_umc_operationset_object_search**](docs/SettingsUmcOperationsetApi.md#udm_settings_umc_operationset_object_search) | **GET** /settings/umc_operationset/ | Search for UMC operation sets objects
*SettingsUmcOperationsetApi* | [**udm_settings_umc_operationset_object_template**](docs/SettingsUmcOperationsetApi.md#udm_settings_umc_operationset_object_template) | **GET** /settings/umc_operationset/add | Get a template for creating an UMC operation set object (contains all properties and their default values)
*SettingsUmcOperationsetApi* | [**udm_settings_umc_operationset_object_update**](docs/SettingsUmcOperationsetApi.md#udm_settings_umc_operationset_object_update) | **PATCH** /settings/umc_operationset/{dn} | Modify an UMC operation set object (moving is currently not possible)
*SettingsUsertemplateApi* | [**udm_settings_usertemplate_object**](docs/SettingsUsertemplateApi.md#udm_settings_usertemplate_object) | **GET** /settings/usertemplate/{dn} |  Get a representation of the User Template object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SettingsUsertemplateApi* | [**udm_settings_usertemplate_object_create**](docs/SettingsUsertemplateApi.md#udm_settings_usertemplate_object_create) | **POST** /settings/usertemplate/ | Create a new User Template object
*SettingsUsertemplateApi* | [**udm_settings_usertemplate_object_modify**](docs/SettingsUsertemplateApi.md#udm_settings_usertemplate_object_modify) | **PUT** /settings/usertemplate/{dn} | Modify or move an User Template object
*SettingsUsertemplateApi* | [**udm_settings_usertemplate_object_remove**](docs/SettingsUsertemplateApi.md#udm_settings_usertemplate_object_remove) | **DELETE** /settings/usertemplate/{dn} | Remove a User Templates object
*SettingsUsertemplateApi* | [**udm_settings_usertemplate_object_search**](docs/SettingsUsertemplateApi.md#udm_settings_usertemplate_object_search) | **GET** /settings/usertemplate/ | Search for User Templates objects
*SettingsUsertemplateApi* | [**udm_settings_usertemplate_object_template**](docs/SettingsUsertemplateApi.md#udm_settings_usertemplate_object_template) | **GET** /settings/usertemplate/add | Get a template for creating an User Template object (contains all properties and their default values)
*SettingsUsertemplateApi* | [**udm_settings_usertemplate_object_update**](docs/SettingsUsertemplateApi.md#udm_settings_usertemplate_object_update) | **PATCH** /settings/usertemplate/{dn} | Modify an User Template object (moving is currently not possible)
*SharesPrintApi* | [**udm_shares_print_object**](docs/SharesPrintApi.md#udm_shares_print_object) | **GET** /shares/print/{dn} |  Get a representation of the Printer share object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SharesPrintApi* | [**udm_shares_print_object_search**](docs/SharesPrintApi.md#udm_shares_print_object_search) | **GET** /shares/print/ | Search for Printer shares objects
*SharesPrinterApi* | [**udm_shares_printer_object**](docs/SharesPrinterApi.md#udm_shares_printer_object) | **GET** /shares/printer/{dn} |  Get a representation of the Printer object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SharesPrinterApi* | [**udm_shares_printer_object_create**](docs/SharesPrinterApi.md#udm_shares_printer_object_create) | **POST** /shares/printer/ | Create a new Printer object
*SharesPrinterApi* | [**udm_shares_printer_object_modify**](docs/SharesPrinterApi.md#udm_shares_printer_object_modify) | **PUT** /shares/printer/{dn} | Modify or move an Printer object
*SharesPrinterApi* | [**udm_shares_printer_object_remove**](docs/SharesPrinterApi.md#udm_shares_printer_object_remove) | **DELETE** /shares/printer/{dn} | Remove a Printers object
*SharesPrinterApi* | [**udm_shares_printer_object_search**](docs/SharesPrinterApi.md#udm_shares_printer_object_search) | **GET** /shares/printer/ | Search for Printers objects
*SharesPrinterApi* | [**udm_shares_printer_object_template**](docs/SharesPrinterApi.md#udm_shares_printer_object_template) | **GET** /shares/printer/add | Get a template for creating an Printer object (contains all properties and their default values)
*SharesPrinterApi* | [**udm_shares_printer_object_update**](docs/SharesPrinterApi.md#udm_shares_printer_object_update) | **PATCH** /shares/printer/{dn} | Modify an Printer object (moving is currently not possible)
*SharesPrintergroupApi* | [**udm_shares_printergroup_object**](docs/SharesPrintergroupApi.md#udm_shares_printergroup_object) | **GET** /shares/printergroup/{dn} |  Get a representation of the Printer share group object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SharesPrintergroupApi* | [**udm_shares_printergroup_object_create**](docs/SharesPrintergroupApi.md#udm_shares_printergroup_object_create) | **POST** /shares/printergroup/ | Create a new Printer share group object
*SharesPrintergroupApi* | [**udm_shares_printergroup_object_modify**](docs/SharesPrintergroupApi.md#udm_shares_printergroup_object_modify) | **PUT** /shares/printergroup/{dn} | Modify or move an Printer share group object
*SharesPrintergroupApi* | [**udm_shares_printergroup_object_remove**](docs/SharesPrintergroupApi.md#udm_shares_printergroup_object_remove) | **DELETE** /shares/printergroup/{dn} | Remove a Printer share groups object
*SharesPrintergroupApi* | [**udm_shares_printergroup_object_search**](docs/SharesPrintergroupApi.md#udm_shares_printergroup_object_search) | **GET** /shares/printergroup/ | Search for Printer share groups objects
*SharesPrintergroupApi* | [**udm_shares_printergroup_object_template**](docs/SharesPrintergroupApi.md#udm_shares_printergroup_object_template) | **GET** /shares/printergroup/add | Get a template for creating an Printer share group object (contains all properties and their default values)
*SharesPrintergroupApi* | [**udm_shares_printergroup_object_update**](docs/SharesPrintergroupApi.md#udm_shares_printergroup_object_update) | **PATCH** /shares/printergroup/{dn} | Modify an Printer share group object (moving is currently not possible)
*SharesShareApi* | [**udm_shares_share_object**](docs/SharesShareApi.md#udm_shares_share_object) | **GET** /shares/share/{dn} |  Get a representation of the Share directory object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*SharesShareApi* | [**udm_shares_share_object_create**](docs/SharesShareApi.md#udm_shares_share_object_create) | **POST** /shares/share/ | Create a new Share directory object
*SharesShareApi* | [**udm_shares_share_object_modify**](docs/SharesShareApi.md#udm_shares_share_object_modify) | **PUT** /shares/share/{dn} | Modify or move an Share directory object
*SharesShareApi* | [**udm_shares_share_object_remove**](docs/SharesShareApi.md#udm_shares_share_object_remove) | **DELETE** /shares/share/{dn} | Remove a Share directories object
*SharesShareApi* | [**udm_shares_share_object_search**](docs/SharesShareApi.md#udm_shares_share_object_search) | **GET** /shares/share/ | Search for Share directories objects
*SharesShareApi* | [**udm_shares_share_object_template**](docs/SharesShareApi.md#udm_shares_share_object_template) | **GET** /shares/share/add | Get a template for creating an Share directory object (contains all properties and their default values)
*SharesShareApi* | [**udm_shares_share_object_update**](docs/SharesShareApi.md#udm_shares_share_object_update) | **PATCH** /shares/share/{dn} | Modify an Share directory object (moving is currently not possible)
*UsersContactApi* | [**udm_users_contact_object**](docs/UsersContactApi.md#udm_users_contact_object) | **GET** /users/contact/{dn} |  Get a representation of the Contact object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*UsersContactApi* | [**udm_users_contact_object_create**](docs/UsersContactApi.md#udm_users_contact_object_create) | **POST** /users/contact/ | Create a new Contact object
*UsersContactApi* | [**udm_users_contact_object_modify**](docs/UsersContactApi.md#udm_users_contact_object_modify) | **PUT** /users/contact/{dn} | Modify or move an Contact object
*UsersContactApi* | [**udm_users_contact_object_remove**](docs/UsersContactApi.md#udm_users_contact_object_remove) | **DELETE** /users/contact/{dn} | Remove a Contact information object
*UsersContactApi* | [**udm_users_contact_object_search**](docs/UsersContactApi.md#udm_users_contact_object_search) | **GET** /users/contact/ | Search for Contact information objects
*UsersContactApi* | [**udm_users_contact_object_template**](docs/UsersContactApi.md#udm_users_contact_object_template) | **GET** /users/contact/add | Get a template for creating an Contact object (contains all properties and their default values)
*UsersContactApi* | [**udm_users_contact_object_update**](docs/UsersContactApi.md#udm_users_contact_object_update) | **PATCH** /users/contact/{dn} | Modify an Contact object (moving is currently not possible)
*UsersLdapApi* | [**udm_users_ldap_object**](docs/UsersLdapApi.md#udm_users_ldap_object) | **GET** /users/ldap/{dn} |  Get a representation of the Simple authentication account object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*UsersLdapApi* | [**udm_users_ldap_object_create**](docs/UsersLdapApi.md#udm_users_ldap_object_create) | **POST** /users/ldap/ | Create a new Simple authentication account object
*UsersLdapApi* | [**udm_users_ldap_object_modify**](docs/UsersLdapApi.md#udm_users_ldap_object_modify) | **PUT** /users/ldap/{dn} | Modify or move an Simple authentication account object
*UsersLdapApi* | [**udm_users_ldap_object_remove**](docs/UsersLdapApi.md#udm_users_ldap_object_remove) | **DELETE** /users/ldap/{dn} | Remove a Simple authentication accounts object
*UsersLdapApi* | [**udm_users_ldap_object_search**](docs/UsersLdapApi.md#udm_users_ldap_object_search) | **GET** /users/ldap/ | Search for Simple authentication accounts objects
*UsersLdapApi* | [**udm_users_ldap_object_template**](docs/UsersLdapApi.md#udm_users_ldap_object_template) | **GET** /users/ldap/add | Get a template for creating an Simple authentication account object (contains all properties and their default values)
*UsersLdapApi* | [**udm_users_ldap_object_update**](docs/UsersLdapApi.md#udm_users_ldap_object_update) | **PATCH** /users/ldap/{dn} | Modify an Simple authentication account object (moving is currently not possible)
*UsersPasswdApi* | [**udm_users_passwd_object**](docs/UsersPasswdApi.md#udm_users_passwd_object) | **GET** /users/passwd/{dn} |  Get a representation of the Password object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*UsersPasswdApi* | [**udm_users_passwd_object_modify**](docs/UsersPasswdApi.md#udm_users_passwd_object_modify) | **PUT** /users/passwd/{dn} | Modify or move an Password object
*UsersPasswdApi* | [**udm_users_passwd_object_update**](docs/UsersPasswdApi.md#udm_users_passwd_object_update) | **PATCH** /users/passwd/{dn} | Modify an Password object (moving is currently not possible)
*UsersSelfApi* | [**udm_users_self_object**](docs/UsersSelfApi.md#udm_users_self_object) | **GET** /users/self/{dn} |  Get a representation of the Self object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*UsersSelfApi* | [**udm_users_self_object_modify**](docs/UsersSelfApi.md#udm_users_self_object_modify) | **PUT** /users/self/{dn} | Modify or move an Self object
*UsersSelfApi* | [**udm_users_self_object_search**](docs/UsersSelfApi.md#udm_users_self_object_search) | **GET** /users/self/ | Search for Self objects
*UsersSelfApi* | [**udm_users_self_object_update**](docs/UsersSelfApi.md#udm_users_self_object_update) | **PATCH** /users/self/{dn} | Modify an Self object (moving is currently not possible)
*UsersUserApi* | [**udm_users_user_object**](docs/UsersUserApi.md#udm_users_user_object) | **GET** /users/user/{dn} |  Get a representation of the User object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*UsersUserApi* | [**udm_users_user_object_create**](docs/UsersUserApi.md#udm_users_user_object_create) | **POST** /users/user/ | Create a new User object
*UsersUserApi* | [**udm_users_user_object_modify**](docs/UsersUserApi.md#udm_users_user_object_modify) | **PUT** /users/user/{dn} | Modify or move an User object
*UsersUserApi* | [**udm_users_user_object_remove**](docs/UsersUserApi.md#udm_users_user_object_remove) | **DELETE** /users/user/{dn} | Remove a Users object
*UsersUserApi* | [**udm_users_user_object_search**](docs/UsersUserApi.md#udm_users_user_object_search) | **GET** /users/user/ | Search for Users objects
*UsersUserApi* | [**udm_users_user_object_template**](docs/UsersUserApi.md#udm_users_user_object_template) | **GET** /users/user/add | Get a template for creating an User object (contains all properties and their default values)
*UsersUserApi* | [**udm_users_user_object_update**](docs/UsersUserApi.md#udm_users_user_object_update) | **PATCH** /users/user/{dn} | Modify an User object (moving is currently not possible)
*UvmmCloudconnectionApi* | [**udm_uvmm_cloudconnection_object**](docs/UvmmCloudconnectionApi.md#udm_uvmm_cloudconnection_object) | **GET** /uvmm/cloudconnection/{dn} |  Get a representation of the Cloud Connection object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*UvmmCloudconnectionApi* | [**udm_uvmm_cloudconnection_object_create**](docs/UvmmCloudconnectionApi.md#udm_uvmm_cloudconnection_object_create) | **POST** /uvmm/cloudconnection/ | Create a new Cloud Connection object
*UvmmCloudconnectionApi* | [**udm_uvmm_cloudconnection_object_modify**](docs/UvmmCloudconnectionApi.md#udm_uvmm_cloudconnection_object_modify) | **PUT** /uvmm/cloudconnection/{dn} | Modify or move an Cloud Connection object
*UvmmCloudconnectionApi* | [**udm_uvmm_cloudconnection_object_remove**](docs/UvmmCloudconnectionApi.md#udm_uvmm_cloudconnection_object_remove) | **DELETE** /uvmm/cloudconnection/{dn} | Remove a Cloud Connections object
*UvmmCloudconnectionApi* | [**udm_uvmm_cloudconnection_object_search**](docs/UvmmCloudconnectionApi.md#udm_uvmm_cloudconnection_object_search) | **GET** /uvmm/cloudconnection/ | Search for Cloud Connections objects
*UvmmCloudconnectionApi* | [**udm_uvmm_cloudconnection_object_template**](docs/UvmmCloudconnectionApi.md#udm_uvmm_cloudconnection_object_template) | **GET** /uvmm/cloudconnection/add | Get a template for creating an Cloud Connection object (contains all properties and their default values)
*UvmmCloudconnectionApi* | [**udm_uvmm_cloudconnection_object_update**](docs/UvmmCloudconnectionApi.md#udm_uvmm_cloudconnection_object_update) | **PATCH** /uvmm/cloudconnection/{dn} | Modify an Cloud Connection object (moving is currently not possible)
*UvmmCloudtypeApi* | [**udm_uvmm_cloudtype_object**](docs/UvmmCloudtypeApi.md#udm_uvmm_cloudtype_object) | **GET** /uvmm/cloudtype/{dn} |  Get a representation of the Cloud Type object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*UvmmCloudtypeApi* | [**udm_uvmm_cloudtype_object_create**](docs/UvmmCloudtypeApi.md#udm_uvmm_cloudtype_object_create) | **POST** /uvmm/cloudtype/ | Create a new Cloud Type object
*UvmmCloudtypeApi* | [**udm_uvmm_cloudtype_object_modify**](docs/UvmmCloudtypeApi.md#udm_uvmm_cloudtype_object_modify) | **PUT** /uvmm/cloudtype/{dn} | Modify or move an Cloud Type object
*UvmmCloudtypeApi* | [**udm_uvmm_cloudtype_object_remove**](docs/UvmmCloudtypeApi.md#udm_uvmm_cloudtype_object_remove) | **DELETE** /uvmm/cloudtype/{dn} | Remove a Cloud Types object
*UvmmCloudtypeApi* | [**udm_uvmm_cloudtype_object_search**](docs/UvmmCloudtypeApi.md#udm_uvmm_cloudtype_object_search) | **GET** /uvmm/cloudtype/ | Search for Cloud Types objects
*UvmmCloudtypeApi* | [**udm_uvmm_cloudtype_object_template**](docs/UvmmCloudtypeApi.md#udm_uvmm_cloudtype_object_template) | **GET** /uvmm/cloudtype/add | Get a template for creating an Cloud Type object (contains all properties and their default values)
*UvmmCloudtypeApi* | [**udm_uvmm_cloudtype_object_update**](docs/UvmmCloudtypeApi.md#udm_uvmm_cloudtype_object_update) | **PATCH** /uvmm/cloudtype/{dn} | Modify an Cloud Type object (moving is currently not possible)
*UvmmInfoApi* | [**udm_uvmm_info_object**](docs/UvmmInfoApi.md#udm_uvmm_info_object) | **GET** /uvmm/info/{dn} |  Get a representation of the Machine information object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*UvmmInfoApi* | [**udm_uvmm_info_object_create**](docs/UvmmInfoApi.md#udm_uvmm_info_object_create) | **POST** /uvmm/info/ | Create a new Machine information object
*UvmmInfoApi* | [**udm_uvmm_info_object_modify**](docs/UvmmInfoApi.md#udm_uvmm_info_object_modify) | **PUT** /uvmm/info/{dn} | Modify or move an Machine information object
*UvmmInfoApi* | [**udm_uvmm_info_object_remove**](docs/UvmmInfoApi.md#udm_uvmm_info_object_remove) | **DELETE** /uvmm/info/{dn} | Remove a Machine information object
*UvmmInfoApi* | [**udm_uvmm_info_object_search**](docs/UvmmInfoApi.md#udm_uvmm_info_object_search) | **GET** /uvmm/info/ | Search for Machine information objects
*UvmmInfoApi* | [**udm_uvmm_info_object_template**](docs/UvmmInfoApi.md#udm_uvmm_info_object_template) | **GET** /uvmm/info/add | Get a template for creating an Machine information object (contains all properties and their default values)
*UvmmInfoApi* | [**udm_uvmm_info_object_update**](docs/UvmmInfoApi.md#udm_uvmm_info_object_update) | **PATCH** /uvmm/info/{dn} | Modify an Machine information object (moving is currently not possible)
*UvmmProfileApi* | [**udm_uvmm_profile_object**](docs/UvmmProfileApi.md#udm_uvmm_profile_object) | **GET** /uvmm/profile/{dn} |  Get a representation of the Profile object with all its properties, policies, options, metadata and references. Includes also instructions how to modify, remove or move the object. 
*UvmmProfileApi* | [**udm_uvmm_profile_object_create**](docs/UvmmProfileApi.md#udm_uvmm_profile_object_create) | **POST** /uvmm/profile/ | Create a new Profile object
*UvmmProfileApi* | [**udm_uvmm_profile_object_modify**](docs/UvmmProfileApi.md#udm_uvmm_profile_object_modify) | **PUT** /uvmm/profile/{dn} | Modify or move an Profile object
*UvmmProfileApi* | [**udm_uvmm_profile_object_remove**](docs/UvmmProfileApi.md#udm_uvmm_profile_object_remove) | **DELETE** /uvmm/profile/{dn} | Remove a Profiles object
*UvmmProfileApi* | [**udm_uvmm_profile_object_search**](docs/UvmmProfileApi.md#udm_uvmm_profile_object_search) | **GET** /uvmm/profile/ | Search for Profiles objects
*UvmmProfileApi* | [**udm_uvmm_profile_object_template**](docs/UvmmProfileApi.md#udm_uvmm_profile_object_template) | **GET** /uvmm/profile/add | Get a template for creating an Profile object (contains all properties and their default values)
*UvmmProfileApi* | [**udm_uvmm_profile_object_update**](docs/UvmmProfileApi.md#udm_uvmm_profile_object_update) | **PATCH** /uvmm/profile/{dn} | Modify an Profile object (moving is currently not possible)


## Documentation For Models

 - [AppcenterApp](docs/AppcenterApp.md)
 - [AppcenterAppList](docs/AppcenterAppList.md)
 - [AppcenterAppListEmbedded](docs/AppcenterAppListEmbedded.md)
 - [AppcenterAppPolicies](docs/AppcenterAppPolicies.md)
 - [AppcenterAppRequest](docs/AppcenterAppRequest.md)
 - [AppcenterAppRequestAllOf](docs/AppcenterAppRequestAllOf.md)
 - [AppcenterAppRequestPatch](docs/AppcenterAppRequestPatch.md)
 - [AppcenterAppResponseMixin](docs/AppcenterAppResponseMixin.md)
 - [ComputersComputer](docs/ComputersComputer.md)
 - [ComputersComputerList](docs/ComputersComputerList.md)
 - [ComputersComputerListEmbedded](docs/ComputersComputerListEmbedded.md)
 - [ComputersComputerRequest](docs/ComputersComputerRequest.md)
 - [ComputersComputerRequestPatch](docs/ComputersComputerRequestPatch.md)
 - [ComputersComputerResponseMixin](docs/ComputersComputerResponseMixin.md)
 - [ComputersDomaincontrollerBackup](docs/ComputersDomaincontrollerBackup.md)
 - [ComputersDomaincontrollerBackupList](docs/ComputersDomaincontrollerBackupList.md)
 - [ComputersDomaincontrollerBackupListEmbedded](docs/ComputersDomaincontrollerBackupListEmbedded.md)
 - [ComputersDomaincontrollerBackupOptions](docs/ComputersDomaincontrollerBackupOptions.md)
 - [ComputersDomaincontrollerBackupPolicies](docs/ComputersDomaincontrollerBackupPolicies.md)
 - [ComputersDomaincontrollerBackupRequest](docs/ComputersDomaincontrollerBackupRequest.md)
 - [ComputersDomaincontrollerBackupRequestPatch](docs/ComputersDomaincontrollerBackupRequestPatch.md)
 - [ComputersDomaincontrollerBackupResponseMixin](docs/ComputersDomaincontrollerBackupResponseMixin.md)
 - [ComputersDomaincontrollerMaster](docs/ComputersDomaincontrollerMaster.md)
 - [ComputersDomaincontrollerMasterList](docs/ComputersDomaincontrollerMasterList.md)
 - [ComputersDomaincontrollerMasterListEmbedded](docs/ComputersDomaincontrollerMasterListEmbedded.md)
 - [ComputersDomaincontrollerMasterOptions](docs/ComputersDomaincontrollerMasterOptions.md)
 - [ComputersDomaincontrollerMasterPolicies](docs/ComputersDomaincontrollerMasterPolicies.md)
 - [ComputersDomaincontrollerMasterRequest](docs/ComputersDomaincontrollerMasterRequest.md)
 - [ComputersDomaincontrollerMasterRequestPatch](docs/ComputersDomaincontrollerMasterRequestPatch.md)
 - [ComputersDomaincontrollerMasterResponseMixin](docs/ComputersDomaincontrollerMasterResponseMixin.md)
 - [ComputersDomaincontrollerSlave](docs/ComputersDomaincontrollerSlave.md)
 - [ComputersDomaincontrollerSlaveList](docs/ComputersDomaincontrollerSlaveList.md)
 - [ComputersDomaincontrollerSlaveListEmbedded](docs/ComputersDomaincontrollerSlaveListEmbedded.md)
 - [ComputersDomaincontrollerSlaveOptions](docs/ComputersDomaincontrollerSlaveOptions.md)
 - [ComputersDomaincontrollerSlavePolicies](docs/ComputersDomaincontrollerSlavePolicies.md)
 - [ComputersDomaincontrollerSlaveRequest](docs/ComputersDomaincontrollerSlaveRequest.md)
 - [ComputersDomaincontrollerSlaveRequestPatch](docs/ComputersDomaincontrollerSlaveRequestPatch.md)
 - [ComputersDomaincontrollerSlaveResponseMixin](docs/ComputersDomaincontrollerSlaveResponseMixin.md)
 - [ComputersIpmanagedclient](docs/ComputersIpmanagedclient.md)
 - [ComputersIpmanagedclientList](docs/ComputersIpmanagedclientList.md)
 - [ComputersIpmanagedclientListEmbedded](docs/ComputersIpmanagedclientListEmbedded.md)
 - [ComputersIpmanagedclientOptions](docs/ComputersIpmanagedclientOptions.md)
 - [ComputersIpmanagedclientRequest](docs/ComputersIpmanagedclientRequest.md)
 - [ComputersIpmanagedclientRequestPatch](docs/ComputersIpmanagedclientRequestPatch.md)
 - [ComputersIpmanagedclientResponseMixin](docs/ComputersIpmanagedclientResponseMixin.md)
 - [ComputersLinux](docs/ComputersLinux.md)
 - [ComputersLinuxList](docs/ComputersLinuxList.md)
 - [ComputersLinuxListEmbedded](docs/ComputersLinuxListEmbedded.md)
 - [ComputersLinuxOptions](docs/ComputersLinuxOptions.md)
 - [ComputersLinuxRequest](docs/ComputersLinuxRequest.md)
 - [ComputersLinuxRequestPatch](docs/ComputersLinuxRequestPatch.md)
 - [ComputersLinuxResponseMixin](docs/ComputersLinuxResponseMixin.md)
 - [ComputersMacos](docs/ComputersMacos.md)
 - [ComputersMacosList](docs/ComputersMacosList.md)
 - [ComputersMacosListEmbedded](docs/ComputersMacosListEmbedded.md)
 - [ComputersMacosOptions](docs/ComputersMacosOptions.md)
 - [ComputersMacosRequest](docs/ComputersMacosRequest.md)
 - [ComputersMacosRequestPatch](docs/ComputersMacosRequestPatch.md)
 - [ComputersMacosResponseMixin](docs/ComputersMacosResponseMixin.md)
 - [ComputersMemberserver](docs/ComputersMemberserver.md)
 - [ComputersMemberserverList](docs/ComputersMemberserverList.md)
 - [ComputersMemberserverListEmbedded](docs/ComputersMemberserverListEmbedded.md)
 - [ComputersMemberserverOptions](docs/ComputersMemberserverOptions.md)
 - [ComputersMemberserverPolicies](docs/ComputersMemberserverPolicies.md)
 - [ComputersMemberserverRequest](docs/ComputersMemberserverRequest.md)
 - [ComputersMemberserverRequestPatch](docs/ComputersMemberserverRequestPatch.md)
 - [ComputersMemberserverResponseMixin](docs/ComputersMemberserverResponseMixin.md)
 - [ComputersTrustaccount](docs/ComputersTrustaccount.md)
 - [ComputersTrustaccountList](docs/ComputersTrustaccountList.md)
 - [ComputersTrustaccountListEmbedded](docs/ComputersTrustaccountListEmbedded.md)
 - [ComputersTrustaccountOptions](docs/ComputersTrustaccountOptions.md)
 - [ComputersTrustaccountRequest](docs/ComputersTrustaccountRequest.md)
 - [ComputersTrustaccountRequestPatch](docs/ComputersTrustaccountRequestPatch.md)
 - [ComputersTrustaccountResponseMixin](docs/ComputersTrustaccountResponseMixin.md)
 - [ComputersUbuntu](docs/ComputersUbuntu.md)
 - [ComputersUbuntuList](docs/ComputersUbuntuList.md)
 - [ComputersUbuntuListEmbedded](docs/ComputersUbuntuListEmbedded.md)
 - [ComputersUbuntuOptions](docs/ComputersUbuntuOptions.md)
 - [ComputersUbuntuRequest](docs/ComputersUbuntuRequest.md)
 - [ComputersUbuntuRequestPatch](docs/ComputersUbuntuRequestPatch.md)
 - [ComputersUbuntuResponseMixin](docs/ComputersUbuntuResponseMixin.md)
 - [ComputersWindows](docs/ComputersWindows.md)
 - [ComputersWindowsDomaincontroller](docs/ComputersWindowsDomaincontroller.md)
 - [ComputersWindowsDomaincontrollerList](docs/ComputersWindowsDomaincontrollerList.md)
 - [ComputersWindowsDomaincontrollerListEmbedded](docs/ComputersWindowsDomaincontrollerListEmbedded.md)
 - [ComputersWindowsDomaincontrollerOptions](docs/ComputersWindowsDomaincontrollerOptions.md)
 - [ComputersWindowsDomaincontrollerRequest](docs/ComputersWindowsDomaincontrollerRequest.md)
 - [ComputersWindowsDomaincontrollerRequestPatch](docs/ComputersWindowsDomaincontrollerRequestPatch.md)
 - [ComputersWindowsDomaincontrollerResponseMixin](docs/ComputersWindowsDomaincontrollerResponseMixin.md)
 - [ComputersWindowsList](docs/ComputersWindowsList.md)
 - [ComputersWindowsListEmbedded](docs/ComputersWindowsListEmbedded.md)
 - [ComputersWindowsOptions](docs/ComputersWindowsOptions.md)
 - [ComputersWindowsRequest](docs/ComputersWindowsRequest.md)
 - [ComputersWindowsRequestPatch](docs/ComputersWindowsRequestPatch.md)
 - [ComputersWindowsResponseMixin](docs/ComputersWindowsResponseMixin.md)
 - [ContainerCn](docs/ContainerCn.md)
 - [ContainerCnList](docs/ContainerCnList.md)
 - [ContainerCnListEmbedded](docs/ContainerCnListEmbedded.md)
 - [ContainerCnPolicies](docs/ContainerCnPolicies.md)
 - [ContainerCnRequest](docs/ContainerCnRequest.md)
 - [ContainerCnRequestPatch](docs/ContainerCnRequestPatch.md)
 - [ContainerCnResponseMixin](docs/ContainerCnResponseMixin.md)
 - [ContainerDc](docs/ContainerDc.md)
 - [ContainerDcList](docs/ContainerDcList.md)
 - [ContainerDcListEmbedded](docs/ContainerDcListEmbedded.md)
 - [ContainerDcOptions](docs/ContainerDcOptions.md)
 - [ContainerDcPolicies](docs/ContainerDcPolicies.md)
 - [ContainerDcRequest](docs/ContainerDcRequest.md)
 - [ContainerDcRequestPatch](docs/ContainerDcRequestPatch.md)
 - [ContainerDcResponseMixin](docs/ContainerDcResponseMixin.md)
 - [ContainerMsgpo](docs/ContainerMsgpo.md)
 - [ContainerMsgpoList](docs/ContainerMsgpoList.md)
 - [ContainerMsgpoListEmbedded](docs/ContainerMsgpoListEmbedded.md)
 - [ContainerMsgpoPolicies](docs/ContainerMsgpoPolicies.md)
 - [ContainerMsgpoRequest](docs/ContainerMsgpoRequest.md)
 - [ContainerMsgpoRequestPatch](docs/ContainerMsgpoRequestPatch.md)
 - [ContainerMsgpoResponseMixin](docs/ContainerMsgpoResponseMixin.md)
 - [ContainerOu](docs/ContainerOu.md)
 - [ContainerOuList](docs/ContainerOuList.md)
 - [ContainerOuListEmbedded](docs/ContainerOuListEmbedded.md)
 - [ContainerOuPolicies](docs/ContainerOuPolicies.md)
 - [ContainerOuRequest](docs/ContainerOuRequest.md)
 - [ContainerOuRequestPatch](docs/ContainerOuRequestPatch.md)
 - [ContainerOuResponseMixin](docs/ContainerOuResponseMixin.md)
 - [DhcpDhcp](docs/DhcpDhcp.md)
 - [DhcpDhcpList](docs/DhcpDhcpList.md)
 - [DhcpDhcpListEmbedded](docs/DhcpDhcpListEmbedded.md)
 - [DhcpDhcpRequest](docs/DhcpDhcpRequest.md)
 - [DhcpDhcpRequestPatch](docs/DhcpDhcpRequestPatch.md)
 - [DhcpDhcpResponseMixin](docs/DhcpDhcpResponseMixin.md)
 - [DhcpHost](docs/DhcpHost.md)
 - [DhcpHostList](docs/DhcpHostList.md)
 - [DhcpHostListEmbedded](docs/DhcpHostListEmbedded.md)
 - [DhcpHostOptions](docs/DhcpHostOptions.md)
 - [DhcpHostPolicies](docs/DhcpHostPolicies.md)
 - [DhcpHostRequest](docs/DhcpHostRequest.md)
 - [DhcpHostRequestPatch](docs/DhcpHostRequestPatch.md)
 - [DhcpHostResponseMixin](docs/DhcpHostResponseMixin.md)
 - [DhcpPool](docs/DhcpPool.md)
 - [DhcpPoolList](docs/DhcpPoolList.md)
 - [DhcpPoolListEmbedded](docs/DhcpPoolListEmbedded.md)
 - [DhcpPoolOptions](docs/DhcpPoolOptions.md)
 - [DhcpPoolPolicies](docs/DhcpPoolPolicies.md)
 - [DhcpPoolRequest](docs/DhcpPoolRequest.md)
 - [DhcpPoolRequestPatch](docs/DhcpPoolRequestPatch.md)
 - [DhcpPoolResponseMixin](docs/DhcpPoolResponseMixin.md)
 - [DhcpServer](docs/DhcpServer.md)
 - [DhcpServerList](docs/DhcpServerList.md)
 - [DhcpServerListEmbedded](docs/DhcpServerListEmbedded.md)
 - [DhcpServerRequest](docs/DhcpServerRequest.md)
 - [DhcpServerRequestPatch](docs/DhcpServerRequestPatch.md)
 - [DhcpServerResponseMixin](docs/DhcpServerResponseMixin.md)
 - [DhcpService](docs/DhcpService.md)
 - [DhcpServiceList](docs/DhcpServiceList.md)
 - [DhcpServiceListEmbedded](docs/DhcpServiceListEmbedded.md)
 - [DhcpServiceOptions](docs/DhcpServiceOptions.md)
 - [DhcpServicePolicies](docs/DhcpServicePolicies.md)
 - [DhcpServiceRequest](docs/DhcpServiceRequest.md)
 - [DhcpServiceRequestPatch](docs/DhcpServiceRequestPatch.md)
 - [DhcpServiceResponseMixin](docs/DhcpServiceResponseMixin.md)
 - [DhcpShared](docs/DhcpShared.md)
 - [DhcpSharedList](docs/DhcpSharedList.md)
 - [DhcpSharedListEmbedded](docs/DhcpSharedListEmbedded.md)
 - [DhcpSharedOptions](docs/DhcpSharedOptions.md)
 - [DhcpSharedPolicies](docs/DhcpSharedPolicies.md)
 - [DhcpSharedRequest](docs/DhcpSharedRequest.md)
 - [DhcpSharedRequestPatch](docs/DhcpSharedRequestPatch.md)
 - [DhcpSharedResponseMixin](docs/DhcpSharedResponseMixin.md)
 - [DhcpSharedsubnet](docs/DhcpSharedsubnet.md)
 - [DhcpSharedsubnetList](docs/DhcpSharedsubnetList.md)
 - [DhcpSharedsubnetListEmbedded](docs/DhcpSharedsubnetListEmbedded.md)
 - [DhcpSharedsubnetOptions](docs/DhcpSharedsubnetOptions.md)
 - [DhcpSharedsubnetPolicies](docs/DhcpSharedsubnetPolicies.md)
 - [DhcpSharedsubnetRequest](docs/DhcpSharedsubnetRequest.md)
 - [DhcpSharedsubnetRequestPatch](docs/DhcpSharedsubnetRequestPatch.md)
 - [DhcpSharedsubnetResponseMixin](docs/DhcpSharedsubnetResponseMixin.md)
 - [DhcpSubnet](docs/DhcpSubnet.md)
 - [DhcpSubnetList](docs/DhcpSubnetList.md)
 - [DhcpSubnetListEmbedded](docs/DhcpSubnetListEmbedded.md)
 - [DhcpSubnetOptions](docs/DhcpSubnetOptions.md)
 - [DhcpSubnetPolicies](docs/DhcpSubnetPolicies.md)
 - [DhcpSubnetRequest](docs/DhcpSubnetRequest.md)
 - [DhcpSubnetRequestPatch](docs/DhcpSubnetRequestPatch.md)
 - [DhcpSubnetResponseMixin](docs/DhcpSubnetResponseMixin.md)
 - [DnsAlias](docs/DnsAlias.md)
 - [DnsAliasList](docs/DnsAliasList.md)
 - [DnsAliasListEmbedded](docs/DnsAliasListEmbedded.md)
 - [DnsAliasRequest](docs/DnsAliasRequest.md)
 - [DnsAliasRequestPatch](docs/DnsAliasRequestPatch.md)
 - [DnsAliasResponseMixin](docs/DnsAliasResponseMixin.md)
 - [DnsDns](docs/DnsDns.md)
 - [DnsDnsList](docs/DnsDnsList.md)
 - [DnsDnsListEmbedded](docs/DnsDnsListEmbedded.md)
 - [DnsDnsRequest](docs/DnsDnsRequest.md)
 - [DnsDnsRequestPatch](docs/DnsDnsRequestPatch.md)
 - [DnsDnsResponseMixin](docs/DnsDnsResponseMixin.md)
 - [DnsForwardZone](docs/DnsForwardZone.md)
 - [DnsForwardZoneList](docs/DnsForwardZoneList.md)
 - [DnsForwardZoneListEmbedded](docs/DnsForwardZoneListEmbedded.md)
 - [DnsForwardZonePolicies](docs/DnsForwardZonePolicies.md)
 - [DnsForwardZoneRequest](docs/DnsForwardZoneRequest.md)
 - [DnsForwardZoneRequestPatch](docs/DnsForwardZoneRequestPatch.md)
 - [DnsForwardZoneResponseMixin](docs/DnsForwardZoneResponseMixin.md)
 - [DnsHostRecord](docs/DnsHostRecord.md)
 - [DnsHostRecordList](docs/DnsHostRecordList.md)
 - [DnsHostRecordListEmbedded](docs/DnsHostRecordListEmbedded.md)
 - [DnsHostRecordRequest](docs/DnsHostRecordRequest.md)
 - [DnsHostRecordRequestPatch](docs/DnsHostRecordRequestPatch.md)
 - [DnsHostRecordResponseMixin](docs/DnsHostRecordResponseMixin.md)
 - [DnsNsRecord](docs/DnsNsRecord.md)
 - [DnsNsRecordList](docs/DnsNsRecordList.md)
 - [DnsNsRecordListEmbedded](docs/DnsNsRecordListEmbedded.md)
 - [DnsNsRecordRequest](docs/DnsNsRecordRequest.md)
 - [DnsNsRecordRequestPatch](docs/DnsNsRecordRequestPatch.md)
 - [DnsNsRecordResponseMixin](docs/DnsNsRecordResponseMixin.md)
 - [DnsPtrRecord](docs/DnsPtrRecord.md)
 - [DnsPtrRecordList](docs/DnsPtrRecordList.md)
 - [DnsPtrRecordListEmbedded](docs/DnsPtrRecordListEmbedded.md)
 - [DnsPtrRecordRequest](docs/DnsPtrRecordRequest.md)
 - [DnsPtrRecordRequestPatch](docs/DnsPtrRecordRequestPatch.md)
 - [DnsPtrRecordResponseMixin](docs/DnsPtrRecordResponseMixin.md)
 - [DnsReverseZone](docs/DnsReverseZone.md)
 - [DnsReverseZoneList](docs/DnsReverseZoneList.md)
 - [DnsReverseZoneListEmbedded](docs/DnsReverseZoneListEmbedded.md)
 - [DnsReverseZonePolicies](docs/DnsReverseZonePolicies.md)
 - [DnsReverseZoneRequest](docs/DnsReverseZoneRequest.md)
 - [DnsReverseZoneRequestPatch](docs/DnsReverseZoneRequestPatch.md)
 - [DnsReverseZoneResponseMixin](docs/DnsReverseZoneResponseMixin.md)
 - [DnsSrvRecord](docs/DnsSrvRecord.md)
 - [DnsSrvRecordList](docs/DnsSrvRecordList.md)
 - [DnsSrvRecordListEmbedded](docs/DnsSrvRecordListEmbedded.md)
 - [DnsSrvRecordRequest](docs/DnsSrvRecordRequest.md)
 - [DnsSrvRecordRequestPatch](docs/DnsSrvRecordRequestPatch.md)
 - [DnsSrvRecordResponseMixin](docs/DnsSrvRecordResponseMixin.md)
 - [DnsTxtRecord](docs/DnsTxtRecord.md)
 - [DnsTxtRecordList](docs/DnsTxtRecordList.md)
 - [DnsTxtRecordListEmbedded](docs/DnsTxtRecordListEmbedded.md)
 - [DnsTxtRecordRequest](docs/DnsTxtRecordRequest.md)
 - [DnsTxtRecordRequestPatch](docs/DnsTxtRecordRequestPatch.md)
 - [DnsTxtRecordResponseMixin](docs/DnsTxtRecordResponseMixin.md)
 - [EmbeddedError](docs/EmbeddedError.md)
 - [GroupsGroup](docs/GroupsGroup.md)
 - [GroupsGroupList](docs/GroupsGroupList.md)
 - [GroupsGroupListEmbedded](docs/GroupsGroupListEmbedded.md)
 - [GroupsGroupOptions](docs/GroupsGroupOptions.md)
 - [GroupsGroupPolicies](docs/GroupsGroupPolicies.md)
 - [GroupsGroupRequest](docs/GroupsGroupRequest.md)
 - [GroupsGroupRequestPatch](docs/GroupsGroupRequestPatch.md)
 - [GroupsGroupResponseMixin](docs/GroupsGroupResponseMixin.md)
 - [InlineResponse201](docs/InlineResponse201.md)
 - [KerberosKdcentry](docs/KerberosKdcentry.md)
 - [KerberosKdcentryList](docs/KerberosKdcentryList.md)
 - [KerberosKdcentryListEmbedded](docs/KerberosKdcentryListEmbedded.md)
 - [KerberosKdcentryRequest](docs/KerberosKdcentryRequest.md)
 - [KerberosKdcentryRequestPatch](docs/KerberosKdcentryRequestPatch.md)
 - [KerberosKdcentryResponseMixin](docs/KerberosKdcentryResponseMixin.md)
 - [Links](docs/Links.md)
 - [MailDomain](docs/MailDomain.md)
 - [MailDomainList](docs/MailDomainList.md)
 - [MailDomainListEmbedded](docs/MailDomainListEmbedded.md)
 - [MailDomainRequest](docs/MailDomainRequest.md)
 - [MailDomainRequestPatch](docs/MailDomainRequestPatch.md)
 - [MailDomainResponseMixin](docs/MailDomainResponseMixin.md)
 - [MailFolder](docs/MailFolder.md)
 - [MailFolderList](docs/MailFolderList.md)
 - [MailFolderListEmbedded](docs/MailFolderListEmbedded.md)
 - [MailFolderRequest](docs/MailFolderRequest.md)
 - [MailFolderRequestPatch](docs/MailFolderRequestPatch.md)
 - [MailFolderResponseMixin](docs/MailFolderResponseMixin.md)
 - [MailLists](docs/MailLists.md)
 - [MailListsList](docs/MailListsList.md)
 - [MailListsListEmbedded](docs/MailListsListEmbedded.md)
 - [MailListsRequest](docs/MailListsRequest.md)
 - [MailListsRequestPatch](docs/MailListsRequestPatch.md)
 - [MailListsResponseMixin](docs/MailListsResponseMixin.md)
 - [MailMail](docs/MailMail.md)
 - [MailMailList](docs/MailMailList.md)
 - [MailMailListEmbedded](docs/MailMailListEmbedded.md)
 - [MailMailRequest](docs/MailMailRequest.md)
 - [MailMailRequestPatch](docs/MailMailRequestPatch.md)
 - [MailMailResponseMixin](docs/MailMailResponseMixin.md)
 - [MonitoringAlert](docs/MonitoringAlert.md)
 - [MonitoringAlertList](docs/MonitoringAlertList.md)
 - [MonitoringAlertListEmbedded](docs/MonitoringAlertListEmbedded.md)
 - [MonitoringAlertRequest](docs/MonitoringAlertRequest.md)
 - [MonitoringAlertRequestPatch](docs/MonitoringAlertRequestPatch.md)
 - [MonitoringAlertResponseMixin](docs/MonitoringAlertResponseMixin.md)
 - [MsDomainpolicy](docs/MsDomainpolicy.md)
 - [MsDomainpolicyList](docs/MsDomainpolicyList.md)
 - [MsDomainpolicyListEmbedded](docs/MsDomainpolicyListEmbedded.md)
 - [MsDomainpolicyPolicies](docs/MsDomainpolicyPolicies.md)
 - [MsDomainpolicyRequest](docs/MsDomainpolicyRequest.md)
 - [MsDomainpolicyRequestPatch](docs/MsDomainpolicyRequestPatch.md)
 - [MsDomainpolicyResponseMixin](docs/MsDomainpolicyResponseMixin.md)
 - [MsGpipsecFilter](docs/MsGpipsecFilter.md)
 - [MsGpipsecFilterList](docs/MsGpipsecFilterList.md)
 - [MsGpipsecFilterListEmbedded](docs/MsGpipsecFilterListEmbedded.md)
 - [MsGpipsecFilterPolicies](docs/MsGpipsecFilterPolicies.md)
 - [MsGpipsecFilterRequest](docs/MsGpipsecFilterRequest.md)
 - [MsGpipsecFilterRequestPatch](docs/MsGpipsecFilterRequestPatch.md)
 - [MsGpipsecFilterResponseMixin](docs/MsGpipsecFilterResponseMixin.md)
 - [MsGpipsecIsakmpPolicy](docs/MsGpipsecIsakmpPolicy.md)
 - [MsGpipsecIsakmpPolicyList](docs/MsGpipsecIsakmpPolicyList.md)
 - [MsGpipsecIsakmpPolicyListEmbedded](docs/MsGpipsecIsakmpPolicyListEmbedded.md)
 - [MsGpipsecIsakmpPolicyPolicies](docs/MsGpipsecIsakmpPolicyPolicies.md)
 - [MsGpipsecIsakmpPolicyRequest](docs/MsGpipsecIsakmpPolicyRequest.md)
 - [MsGpipsecIsakmpPolicyRequestPatch](docs/MsGpipsecIsakmpPolicyRequestPatch.md)
 - [MsGpipsecIsakmpPolicyResponseMixin](docs/MsGpipsecIsakmpPolicyResponseMixin.md)
 - [MsGpipsecNegotiationPolicy](docs/MsGpipsecNegotiationPolicy.md)
 - [MsGpipsecNegotiationPolicyList](docs/MsGpipsecNegotiationPolicyList.md)
 - [MsGpipsecNegotiationPolicyListEmbedded](docs/MsGpipsecNegotiationPolicyListEmbedded.md)
 - [MsGpipsecNegotiationPolicyPolicies](docs/MsGpipsecNegotiationPolicyPolicies.md)
 - [MsGpipsecNegotiationPolicyRequest](docs/MsGpipsecNegotiationPolicyRequest.md)
 - [MsGpipsecNegotiationPolicyRequestPatch](docs/MsGpipsecNegotiationPolicyRequestPatch.md)
 - [MsGpipsecNegotiationPolicyResponseMixin](docs/MsGpipsecNegotiationPolicyResponseMixin.md)
 - [MsGpipsecNfa](docs/MsGpipsecNfa.md)
 - [MsGpipsecNfaList](docs/MsGpipsecNfaList.md)
 - [MsGpipsecNfaListEmbedded](docs/MsGpipsecNfaListEmbedded.md)
 - [MsGpipsecNfaPolicies](docs/MsGpipsecNfaPolicies.md)
 - [MsGpipsecNfaRequest](docs/MsGpipsecNfaRequest.md)
 - [MsGpipsecNfaRequestPatch](docs/MsGpipsecNfaRequestPatch.md)
 - [MsGpipsecNfaResponseMixin](docs/MsGpipsecNfaResponseMixin.md)
 - [MsGpipsecPolicy](docs/MsGpipsecPolicy.md)
 - [MsGpipsecPolicyList](docs/MsGpipsecPolicyList.md)
 - [MsGpipsecPolicyListEmbedded](docs/MsGpipsecPolicyListEmbedded.md)
 - [MsGpipsecPolicyPolicies](docs/MsGpipsecPolicyPolicies.md)
 - [MsGpipsecPolicyRequest](docs/MsGpipsecPolicyRequest.md)
 - [MsGpipsecPolicyRequestPatch](docs/MsGpipsecPolicyRequestPatch.md)
 - [MsGpipsecPolicyResponseMixin](docs/MsGpipsecPolicyResponseMixin.md)
 - [MsGpsiCategoryRegistration](docs/MsGpsiCategoryRegistration.md)
 - [MsGpsiCategoryRegistrationList](docs/MsGpsiCategoryRegistrationList.md)
 - [MsGpsiCategoryRegistrationListEmbedded](docs/MsGpsiCategoryRegistrationListEmbedded.md)
 - [MsGpsiCategoryRegistrationPolicies](docs/MsGpsiCategoryRegistrationPolicies.md)
 - [MsGpsiCategoryRegistrationRequest](docs/MsGpsiCategoryRegistrationRequest.md)
 - [MsGpsiCategoryRegistrationRequestPatch](docs/MsGpsiCategoryRegistrationRequestPatch.md)
 - [MsGpsiCategoryRegistrationResponseMixin](docs/MsGpsiCategoryRegistrationResponseMixin.md)
 - [MsGpsiClassStore](docs/MsGpsiClassStore.md)
 - [MsGpsiClassStoreList](docs/MsGpsiClassStoreList.md)
 - [MsGpsiClassStoreListEmbedded](docs/MsGpsiClassStoreListEmbedded.md)
 - [MsGpsiClassStorePolicies](docs/MsGpsiClassStorePolicies.md)
 - [MsGpsiClassStoreRequest](docs/MsGpsiClassStoreRequest.md)
 - [MsGpsiClassStoreRequestPatch](docs/MsGpsiClassStoreRequestPatch.md)
 - [MsGpsiClassStoreResponseMixin](docs/MsGpsiClassStoreResponseMixin.md)
 - [MsGpsiPackageRegistration](docs/MsGpsiPackageRegistration.md)
 - [MsGpsiPackageRegistrationList](docs/MsGpsiPackageRegistrationList.md)
 - [MsGpsiPackageRegistrationListEmbedded](docs/MsGpsiPackageRegistrationListEmbedded.md)
 - [MsGpsiPackageRegistrationPolicies](docs/MsGpsiPackageRegistrationPolicies.md)
 - [MsGpsiPackageRegistrationRequest](docs/MsGpsiPackageRegistrationRequest.md)
 - [MsGpsiPackageRegistrationRequestPatch](docs/MsGpsiPackageRegistrationRequestPatch.md)
 - [MsGpsiPackageRegistrationResponseMixin](docs/MsGpsiPackageRegistrationResponseMixin.md)
 - [MsGpwlWired](docs/MsGpwlWired.md)
 - [MsGpwlWiredList](docs/MsGpwlWiredList.md)
 - [MsGpwlWiredListEmbedded](docs/MsGpwlWiredListEmbedded.md)
 - [MsGpwlWiredPolicies](docs/MsGpwlWiredPolicies.md)
 - [MsGpwlWiredRequest](docs/MsGpwlWiredRequest.md)
 - [MsGpwlWiredRequestPatch](docs/MsGpwlWiredRequestPatch.md)
 - [MsGpwlWiredResponseMixin](docs/MsGpwlWiredResponseMixin.md)
 - [MsGpwlWireless](docs/MsGpwlWireless.md)
 - [MsGpwlWirelessBlob](docs/MsGpwlWirelessBlob.md)
 - [MsGpwlWirelessBlobList](docs/MsGpwlWirelessBlobList.md)
 - [MsGpwlWirelessBlobListEmbedded](docs/MsGpwlWirelessBlobListEmbedded.md)
 - [MsGpwlWirelessBlobPolicies](docs/MsGpwlWirelessBlobPolicies.md)
 - [MsGpwlWirelessBlobRequest](docs/MsGpwlWirelessBlobRequest.md)
 - [MsGpwlWirelessBlobRequestPatch](docs/MsGpwlWirelessBlobRequestPatch.md)
 - [MsGpwlWirelessBlobResponseMixin](docs/MsGpwlWirelessBlobResponseMixin.md)
 - [MsGpwlWirelessList](docs/MsGpwlWirelessList.md)
 - [MsGpwlWirelessListEmbedded](docs/MsGpwlWirelessListEmbedded.md)
 - [MsGpwlWirelessPolicies](docs/MsGpwlWirelessPolicies.md)
 - [MsGpwlWirelessRequest](docs/MsGpwlWirelessRequest.md)
 - [MsGpwlWirelessRequestPatch](docs/MsGpwlWirelessRequestPatch.md)
 - [MsGpwlWirelessResponseMixin](docs/MsGpwlWirelessResponseMixin.md)
 - [NagiosNagios](docs/NagiosNagios.md)
 - [NagiosNagiosList](docs/NagiosNagiosList.md)
 - [NagiosNagiosListEmbedded](docs/NagiosNagiosListEmbedded.md)
 - [NagiosNagiosRequest](docs/NagiosNagiosRequest.md)
 - [NagiosNagiosRequestPatch](docs/NagiosNagiosRequestPatch.md)
 - [NagiosNagiosResponseMixin](docs/NagiosNagiosResponseMixin.md)
 - [NagiosService](docs/NagiosService.md)
 - [NagiosServiceList](docs/NagiosServiceList.md)
 - [NagiosServiceListEmbedded](docs/NagiosServiceListEmbedded.md)
 - [NagiosServiceRequest](docs/NagiosServiceRequest.md)
 - [NagiosServiceRequestPatch](docs/NagiosServiceRequestPatch.md)
 - [NagiosServiceResponseMixin](docs/NagiosServiceResponseMixin.md)
 - [NagiosTimeperiod](docs/NagiosTimeperiod.md)
 - [NagiosTimeperiodList](docs/NagiosTimeperiodList.md)
 - [NagiosTimeperiodListEmbedded](docs/NagiosTimeperiodListEmbedded.md)
 - [NagiosTimeperiodRequest](docs/NagiosTimeperiodRequest.md)
 - [NagiosTimeperiodRequestPatch](docs/NagiosTimeperiodRequestPatch.md)
 - [NagiosTimeperiodResponseMixin](docs/NagiosTimeperiodResponseMixin.md)
 - [NetworksNetwork](docs/NetworksNetwork.md)
 - [NetworksNetworkList](docs/NetworksNetworkList.md)
 - [NetworksNetworkListEmbedded](docs/NetworksNetworkListEmbedded.md)
 - [NetworksNetworkRequest](docs/NetworksNetworkRequest.md)
 - [NetworksNetworkRequestPatch](docs/NetworksNetworkRequestPatch.md)
 - [NetworksNetworkResponseMixin](docs/NetworksNetworkResponseMixin.md)
 - [PoliciesAdminContainer](docs/PoliciesAdminContainer.md)
 - [PoliciesAdminContainerList](docs/PoliciesAdminContainerList.md)
 - [PoliciesAdminContainerListEmbedded](docs/PoliciesAdminContainerListEmbedded.md)
 - [PoliciesAdminContainerRequest](docs/PoliciesAdminContainerRequest.md)
 - [PoliciesAdminContainerRequestPatch](docs/PoliciesAdminContainerRequestPatch.md)
 - [PoliciesAdminContainerResponseMixin](docs/PoliciesAdminContainerResponseMixin.md)
 - [PoliciesDesktop](docs/PoliciesDesktop.md)
 - [PoliciesDesktopList](docs/PoliciesDesktopList.md)
 - [PoliciesDesktopListEmbedded](docs/PoliciesDesktopListEmbedded.md)
 - [PoliciesDesktopRequest](docs/PoliciesDesktopRequest.md)
 - [PoliciesDesktopRequestPatch](docs/PoliciesDesktopRequestPatch.md)
 - [PoliciesDesktopResponseMixin](docs/PoliciesDesktopResponseMixin.md)
 - [PoliciesDhcpBoot](docs/PoliciesDhcpBoot.md)
 - [PoliciesDhcpBootList](docs/PoliciesDhcpBootList.md)
 - [PoliciesDhcpBootListEmbedded](docs/PoliciesDhcpBootListEmbedded.md)
 - [PoliciesDhcpBootRequest](docs/PoliciesDhcpBootRequest.md)
 - [PoliciesDhcpBootRequestPatch](docs/PoliciesDhcpBootRequestPatch.md)
 - [PoliciesDhcpBootResponseMixin](docs/PoliciesDhcpBootResponseMixin.md)
 - [PoliciesDhcpDns](docs/PoliciesDhcpDns.md)
 - [PoliciesDhcpDnsList](docs/PoliciesDhcpDnsList.md)
 - [PoliciesDhcpDnsListEmbedded](docs/PoliciesDhcpDnsListEmbedded.md)
 - [PoliciesDhcpDnsRequest](docs/PoliciesDhcpDnsRequest.md)
 - [PoliciesDhcpDnsRequestPatch](docs/PoliciesDhcpDnsRequestPatch.md)
 - [PoliciesDhcpDnsResponseMixin](docs/PoliciesDhcpDnsResponseMixin.md)
 - [PoliciesDhcpDnsupdate](docs/PoliciesDhcpDnsupdate.md)
 - [PoliciesDhcpDnsupdateList](docs/PoliciesDhcpDnsupdateList.md)
 - [PoliciesDhcpDnsupdateListEmbedded](docs/PoliciesDhcpDnsupdateListEmbedded.md)
 - [PoliciesDhcpDnsupdateRequest](docs/PoliciesDhcpDnsupdateRequest.md)
 - [PoliciesDhcpDnsupdateRequestPatch](docs/PoliciesDhcpDnsupdateRequestPatch.md)
 - [PoliciesDhcpDnsupdateResponseMixin](docs/PoliciesDhcpDnsupdateResponseMixin.md)
 - [PoliciesDhcpLeasetime](docs/PoliciesDhcpLeasetime.md)
 - [PoliciesDhcpLeasetimeList](docs/PoliciesDhcpLeasetimeList.md)
 - [PoliciesDhcpLeasetimeListEmbedded](docs/PoliciesDhcpLeasetimeListEmbedded.md)
 - [PoliciesDhcpLeasetimeRequest](docs/PoliciesDhcpLeasetimeRequest.md)
 - [PoliciesDhcpLeasetimeRequestPatch](docs/PoliciesDhcpLeasetimeRequestPatch.md)
 - [PoliciesDhcpLeasetimeResponseMixin](docs/PoliciesDhcpLeasetimeResponseMixin.md)
 - [PoliciesDhcpNetbios](docs/PoliciesDhcpNetbios.md)
 - [PoliciesDhcpNetbiosList](docs/PoliciesDhcpNetbiosList.md)
 - [PoliciesDhcpNetbiosListEmbedded](docs/PoliciesDhcpNetbiosListEmbedded.md)
 - [PoliciesDhcpNetbiosRequest](docs/PoliciesDhcpNetbiosRequest.md)
 - [PoliciesDhcpNetbiosRequestPatch](docs/PoliciesDhcpNetbiosRequestPatch.md)
 - [PoliciesDhcpNetbiosResponseMixin](docs/PoliciesDhcpNetbiosResponseMixin.md)
 - [PoliciesDhcpRouting](docs/PoliciesDhcpRouting.md)
 - [PoliciesDhcpRoutingList](docs/PoliciesDhcpRoutingList.md)
 - [PoliciesDhcpRoutingListEmbedded](docs/PoliciesDhcpRoutingListEmbedded.md)
 - [PoliciesDhcpRoutingRequest](docs/PoliciesDhcpRoutingRequest.md)
 - [PoliciesDhcpRoutingRequestPatch](docs/PoliciesDhcpRoutingRequestPatch.md)
 - [PoliciesDhcpRoutingResponseMixin](docs/PoliciesDhcpRoutingResponseMixin.md)
 - [PoliciesDhcpScope](docs/PoliciesDhcpScope.md)
 - [PoliciesDhcpScopeList](docs/PoliciesDhcpScopeList.md)
 - [PoliciesDhcpScopeListEmbedded](docs/PoliciesDhcpScopeListEmbedded.md)
 - [PoliciesDhcpScopeRequest](docs/PoliciesDhcpScopeRequest.md)
 - [PoliciesDhcpScopeRequestPatch](docs/PoliciesDhcpScopeRequestPatch.md)
 - [PoliciesDhcpScopeResponseMixin](docs/PoliciesDhcpScopeResponseMixin.md)
 - [PoliciesDhcpStatements](docs/PoliciesDhcpStatements.md)
 - [PoliciesDhcpStatementsList](docs/PoliciesDhcpStatementsList.md)
 - [PoliciesDhcpStatementsListEmbedded](docs/PoliciesDhcpStatementsListEmbedded.md)
 - [PoliciesDhcpStatementsRequest](docs/PoliciesDhcpStatementsRequest.md)
 - [PoliciesDhcpStatementsRequestPatch](docs/PoliciesDhcpStatementsRequestPatch.md)
 - [PoliciesDhcpStatementsResponseMixin](docs/PoliciesDhcpStatementsResponseMixin.md)
 - [PoliciesLdapserver](docs/PoliciesLdapserver.md)
 - [PoliciesLdapserverList](docs/PoliciesLdapserverList.md)
 - [PoliciesLdapserverListEmbedded](docs/PoliciesLdapserverListEmbedded.md)
 - [PoliciesLdapserverRequest](docs/PoliciesLdapserverRequest.md)
 - [PoliciesLdapserverRequestPatch](docs/PoliciesLdapserverRequestPatch.md)
 - [PoliciesLdapserverResponseMixin](docs/PoliciesLdapserverResponseMixin.md)
 - [PoliciesMaintenance](docs/PoliciesMaintenance.md)
 - [PoliciesMaintenanceList](docs/PoliciesMaintenanceList.md)
 - [PoliciesMaintenanceListEmbedded](docs/PoliciesMaintenanceListEmbedded.md)
 - [PoliciesMaintenanceRequest](docs/PoliciesMaintenanceRequest.md)
 - [PoliciesMaintenanceRequestPatch](docs/PoliciesMaintenanceRequestPatch.md)
 - [PoliciesMaintenanceResponseMixin](docs/PoliciesMaintenanceResponseMixin.md)
 - [PoliciesMasterpackages](docs/PoliciesMasterpackages.md)
 - [PoliciesMasterpackagesList](docs/PoliciesMasterpackagesList.md)
 - [PoliciesMasterpackagesListEmbedded](docs/PoliciesMasterpackagesListEmbedded.md)
 - [PoliciesMasterpackagesRequest](docs/PoliciesMasterpackagesRequest.md)
 - [PoliciesMasterpackagesRequestPatch](docs/PoliciesMasterpackagesRequestPatch.md)
 - [PoliciesMasterpackagesResponseMixin](docs/PoliciesMasterpackagesResponseMixin.md)
 - [PoliciesMemberpackages](docs/PoliciesMemberpackages.md)
 - [PoliciesMemberpackagesList](docs/PoliciesMemberpackagesList.md)
 - [PoliciesMemberpackagesListEmbedded](docs/PoliciesMemberpackagesListEmbedded.md)
 - [PoliciesMemberpackagesRequest](docs/PoliciesMemberpackagesRequest.md)
 - [PoliciesMemberpackagesRequestPatch](docs/PoliciesMemberpackagesRequestPatch.md)
 - [PoliciesMemberpackagesResponseMixin](docs/PoliciesMemberpackagesResponseMixin.md)
 - [PoliciesNfsmounts](docs/PoliciesNfsmounts.md)
 - [PoliciesNfsmountsList](docs/PoliciesNfsmountsList.md)
 - [PoliciesNfsmountsListEmbedded](docs/PoliciesNfsmountsListEmbedded.md)
 - [PoliciesNfsmountsRequest](docs/PoliciesNfsmountsRequest.md)
 - [PoliciesNfsmountsRequestPatch](docs/PoliciesNfsmountsRequestPatch.md)
 - [PoliciesNfsmountsResponseMixin](docs/PoliciesNfsmountsResponseMixin.md)
 - [PoliciesPolicy](docs/PoliciesPolicy.md)
 - [PoliciesPolicyList](docs/PoliciesPolicyList.md)
 - [PoliciesPolicyListEmbedded](docs/PoliciesPolicyListEmbedded.md)
 - [PoliciesPolicyRequest](docs/PoliciesPolicyRequest.md)
 - [PoliciesPolicyRequestPatch](docs/PoliciesPolicyRequestPatch.md)
 - [PoliciesPolicyResponseMixin](docs/PoliciesPolicyResponseMixin.md)
 - [PoliciesPrintserver](docs/PoliciesPrintserver.md)
 - [PoliciesPrintserverList](docs/PoliciesPrintserverList.md)
 - [PoliciesPrintserverListEmbedded](docs/PoliciesPrintserverListEmbedded.md)
 - [PoliciesPrintserverRequest](docs/PoliciesPrintserverRequest.md)
 - [PoliciesPrintserverRequestPatch](docs/PoliciesPrintserverRequestPatch.md)
 - [PoliciesPrintserverResponseMixin](docs/PoliciesPrintserverResponseMixin.md)
 - [PoliciesPwhistory](docs/PoliciesPwhistory.md)
 - [PoliciesPwhistoryList](docs/PoliciesPwhistoryList.md)
 - [PoliciesPwhistoryListEmbedded](docs/PoliciesPwhistoryListEmbedded.md)
 - [PoliciesPwhistoryRequest](docs/PoliciesPwhistoryRequest.md)
 - [PoliciesPwhistoryRequestPatch](docs/PoliciesPwhistoryRequestPatch.md)
 - [PoliciesPwhistoryResponseMixin](docs/PoliciesPwhistoryResponseMixin.md)
 - [PoliciesRegistry](docs/PoliciesRegistry.md)
 - [PoliciesRegistryList](docs/PoliciesRegistryList.md)
 - [PoliciesRegistryListEmbedded](docs/PoliciesRegistryListEmbedded.md)
 - [PoliciesRegistryRequest](docs/PoliciesRegistryRequest.md)
 - [PoliciesRegistryRequestPatch](docs/PoliciesRegistryRequestPatch.md)
 - [PoliciesRegistryResponseMixin](docs/PoliciesRegistryResponseMixin.md)
 - [PoliciesRelease](docs/PoliciesRelease.md)
 - [PoliciesReleaseList](docs/PoliciesReleaseList.md)
 - [PoliciesReleaseListEmbedded](docs/PoliciesReleaseListEmbedded.md)
 - [PoliciesReleaseRequest](docs/PoliciesReleaseRequest.md)
 - [PoliciesReleaseRequestPatch](docs/PoliciesReleaseRequestPatch.md)
 - [PoliciesReleaseResponseMixin](docs/PoliciesReleaseResponseMixin.md)
 - [PoliciesRepositoryserver](docs/PoliciesRepositoryserver.md)
 - [PoliciesRepositoryserverList](docs/PoliciesRepositoryserverList.md)
 - [PoliciesRepositoryserverListEmbedded](docs/PoliciesRepositoryserverListEmbedded.md)
 - [PoliciesRepositoryserverRequest](docs/PoliciesRepositoryserverRequest.md)
 - [PoliciesRepositoryserverRequestPatch](docs/PoliciesRepositoryserverRequestPatch.md)
 - [PoliciesRepositoryserverResponseMixin](docs/PoliciesRepositoryserverResponseMixin.md)
 - [PoliciesRepositorysync](docs/PoliciesRepositorysync.md)
 - [PoliciesRepositorysyncList](docs/PoliciesRepositorysyncList.md)
 - [PoliciesRepositorysyncListEmbedded](docs/PoliciesRepositorysyncListEmbedded.md)
 - [PoliciesRepositorysyncRequest](docs/PoliciesRepositorysyncRequest.md)
 - [PoliciesRepositorysyncRequestPatch](docs/PoliciesRepositorysyncRequestPatch.md)
 - [PoliciesRepositorysyncResponseMixin](docs/PoliciesRepositorysyncResponseMixin.md)
 - [PoliciesShareUserquota](docs/PoliciesShareUserquota.md)
 - [PoliciesShareUserquotaList](docs/PoliciesShareUserquotaList.md)
 - [PoliciesShareUserquotaListEmbedded](docs/PoliciesShareUserquotaListEmbedded.md)
 - [PoliciesShareUserquotaRequest](docs/PoliciesShareUserquotaRequest.md)
 - [PoliciesShareUserquotaRequestPatch](docs/PoliciesShareUserquotaRequestPatch.md)
 - [PoliciesShareUserquotaResponseMixin](docs/PoliciesShareUserquotaResponseMixin.md)
 - [PoliciesSlavepackages](docs/PoliciesSlavepackages.md)
 - [PoliciesSlavepackagesList](docs/PoliciesSlavepackagesList.md)
 - [PoliciesSlavepackagesListEmbedded](docs/PoliciesSlavepackagesListEmbedded.md)
 - [PoliciesSlavepackagesRequest](docs/PoliciesSlavepackagesRequest.md)
 - [PoliciesSlavepackagesRequestPatch](docs/PoliciesSlavepackagesRequestPatch.md)
 - [PoliciesSlavepackagesResponseMixin](docs/PoliciesSlavepackagesResponseMixin.md)
 - [PoliciesUmc](docs/PoliciesUmc.md)
 - [PoliciesUmcList](docs/PoliciesUmcList.md)
 - [PoliciesUmcListEmbedded](docs/PoliciesUmcListEmbedded.md)
 - [PoliciesUmcRequest](docs/PoliciesUmcRequest.md)
 - [PoliciesUmcRequestPatch](docs/PoliciesUmcRequestPatch.md)
 - [PoliciesUmcResponseMixin](docs/PoliciesUmcResponseMixin.md)
 - [PortalsAll](docs/PortalsAll.md)
 - [PortalsAllList](docs/PortalsAllList.md)
 - [PortalsAllListEmbedded](docs/PortalsAllListEmbedded.md)
 - [PortalsAllRequest](docs/PortalsAllRequest.md)
 - [PortalsAllRequestPatch](docs/PortalsAllRequestPatch.md)
 - [PortalsAllResponseMixin](docs/PortalsAllResponseMixin.md)
 - [PortalsAnnouncement](docs/PortalsAnnouncement.md)
 - [PortalsAnnouncementList](docs/PortalsAnnouncementList.md)
 - [PortalsAnnouncementListEmbedded](docs/PortalsAnnouncementListEmbedded.md)
 - [PortalsAnnouncementRequest](docs/PortalsAnnouncementRequest.md)
 - [PortalsAnnouncementRequestPatch](docs/PortalsAnnouncementRequestPatch.md)
 - [PortalsAnnouncementResponseMixin](docs/PortalsAnnouncementResponseMixin.md)
 - [PortalsCategory](docs/PortalsCategory.md)
 - [PortalsCategoryList](docs/PortalsCategoryList.md)
 - [PortalsCategoryListEmbedded](docs/PortalsCategoryListEmbedded.md)
 - [PortalsCategoryRequest](docs/PortalsCategoryRequest.md)
 - [PortalsCategoryRequestPatch](docs/PortalsCategoryRequestPatch.md)
 - [PortalsCategoryResponseMixin](docs/PortalsCategoryResponseMixin.md)
 - [PortalsEntry](docs/PortalsEntry.md)
 - [PortalsEntryList](docs/PortalsEntryList.md)
 - [PortalsEntryListEmbedded](docs/PortalsEntryListEmbedded.md)
 - [PortalsEntryRequest](docs/PortalsEntryRequest.md)
 - [PortalsEntryRequestPatch](docs/PortalsEntryRequestPatch.md)
 - [PortalsEntryResponseMixin](docs/PortalsEntryResponseMixin.md)
 - [PortalsFolder](docs/PortalsFolder.md)
 - [PortalsFolderList](docs/PortalsFolderList.md)
 - [PortalsFolderListEmbedded](docs/PortalsFolderListEmbedded.md)
 - [PortalsFolderRequest](docs/PortalsFolderRequest.md)
 - [PortalsFolderRequestPatch](docs/PortalsFolderRequestPatch.md)
 - [PortalsFolderResponseMixin](docs/PortalsFolderResponseMixin.md)
 - [PortalsPortal](docs/PortalsPortal.md)
 - [PortalsPortalList](docs/PortalsPortalList.md)
 - [PortalsPortalListEmbedded](docs/PortalsPortalListEmbedded.md)
 - [PortalsPortalRequest](docs/PortalsPortalRequest.md)
 - [PortalsPortalRequestPatch](docs/PortalsPortalRequestPatch.md)
 - [PortalsPortalResponseMixin](docs/PortalsPortalResponseMixin.md)
 - [SamlIdpconfig](docs/SamlIdpconfig.md)
 - [SamlIdpconfigList](docs/SamlIdpconfigList.md)
 - [SamlIdpconfigListEmbedded](docs/SamlIdpconfigListEmbedded.md)
 - [SamlIdpconfigRequest](docs/SamlIdpconfigRequest.md)
 - [SamlIdpconfigRequestPatch](docs/SamlIdpconfigRequestPatch.md)
 - [SamlIdpconfigResponseMixin](docs/SamlIdpconfigResponseMixin.md)
 - [SamlServiceprovider](docs/SamlServiceprovider.md)
 - [SamlServiceproviderList](docs/SamlServiceproviderList.md)
 - [SamlServiceproviderListEmbedded](docs/SamlServiceproviderListEmbedded.md)
 - [SamlServiceproviderRequest](docs/SamlServiceproviderRequest.md)
 - [SamlServiceproviderRequestPatch](docs/SamlServiceproviderRequestPatch.md)
 - [SamlServiceproviderResponseMixin](docs/SamlServiceproviderResponseMixin.md)
 - [SettingsCn](docs/SettingsCn.md)
 - [SettingsCnList](docs/SettingsCnList.md)
 - [SettingsCnListEmbedded](docs/SettingsCnListEmbedded.md)
 - [SettingsCnPolicies](docs/SettingsCnPolicies.md)
 - [SettingsCnRequest](docs/SettingsCnRequest.md)
 - [SettingsCnRequestPatch](docs/SettingsCnRequestPatch.md)
 - [SettingsCnResponseMixin](docs/SettingsCnResponseMixin.md)
 - [SettingsData](docs/SettingsData.md)
 - [SettingsDataList](docs/SettingsDataList.md)
 - [SettingsDataListEmbedded](docs/SettingsDataListEmbedded.md)
 - [SettingsDataRequest](docs/SettingsDataRequest.md)
 - [SettingsDataRequestPatch](docs/SettingsDataRequestPatch.md)
 - [SettingsDataResponseMixin](docs/SettingsDataResponseMixin.md)
 - [SettingsDefault](docs/SettingsDefault.md)
 - [SettingsDefaultList](docs/SettingsDefaultList.md)
 - [SettingsDefaultListEmbedded](docs/SettingsDefaultListEmbedded.md)
 - [SettingsDefaultRequest](docs/SettingsDefaultRequest.md)
 - [SettingsDefaultRequestPatch](docs/SettingsDefaultRequestPatch.md)
 - [SettingsDefaultResponseMixin](docs/SettingsDefaultResponseMixin.md)
 - [SettingsDirectory](docs/SettingsDirectory.md)
 - [SettingsDirectoryList](docs/SettingsDirectoryList.md)
 - [SettingsDirectoryListEmbedded](docs/SettingsDirectoryListEmbedded.md)
 - [SettingsDirectoryRequest](docs/SettingsDirectoryRequest.md)
 - [SettingsDirectoryRequestPatch](docs/SettingsDirectoryRequestPatch.md)
 - [SettingsDirectoryResponseMixin](docs/SettingsDirectoryResponseMixin.md)
 - [SettingsExtendedAttribute](docs/SettingsExtendedAttribute.md)
 - [SettingsExtendedAttributeList](docs/SettingsExtendedAttributeList.md)
 - [SettingsExtendedAttributeListEmbedded](docs/SettingsExtendedAttributeListEmbedded.md)
 - [SettingsExtendedAttributeRequest](docs/SettingsExtendedAttributeRequest.md)
 - [SettingsExtendedAttributeRequestPatch](docs/SettingsExtendedAttributeRequestPatch.md)
 - [SettingsExtendedAttributeResponseMixin](docs/SettingsExtendedAttributeResponseMixin.md)
 - [SettingsExtendedOptions](docs/SettingsExtendedOptions.md)
 - [SettingsExtendedOptionsList](docs/SettingsExtendedOptionsList.md)
 - [SettingsExtendedOptionsListEmbedded](docs/SettingsExtendedOptionsListEmbedded.md)
 - [SettingsExtendedOptionsRequest](docs/SettingsExtendedOptionsRequest.md)
 - [SettingsExtendedOptionsRequestPatch](docs/SettingsExtendedOptionsRequestPatch.md)
 - [SettingsExtendedOptionsResponseMixin](docs/SettingsExtendedOptionsResponseMixin.md)
 - [SettingsLdapacl](docs/SettingsLdapacl.md)
 - [SettingsLdapaclList](docs/SettingsLdapaclList.md)
 - [SettingsLdapaclListEmbedded](docs/SettingsLdapaclListEmbedded.md)
 - [SettingsLdapaclRequest](docs/SettingsLdapaclRequest.md)
 - [SettingsLdapaclRequestPatch](docs/SettingsLdapaclRequestPatch.md)
 - [SettingsLdapaclResponseMixin](docs/SettingsLdapaclResponseMixin.md)
 - [SettingsLdapschema](docs/SettingsLdapschema.md)
 - [SettingsLdapschemaList](docs/SettingsLdapschemaList.md)
 - [SettingsLdapschemaListEmbedded](docs/SettingsLdapschemaListEmbedded.md)
 - [SettingsLdapschemaRequest](docs/SettingsLdapschemaRequest.md)
 - [SettingsLdapschemaRequestPatch](docs/SettingsLdapschemaRequestPatch.md)
 - [SettingsLdapschemaResponseMixin](docs/SettingsLdapschemaResponseMixin.md)
 - [SettingsLicense](docs/SettingsLicense.md)
 - [SettingsLicenseList](docs/SettingsLicenseList.md)
 - [SettingsLicenseListEmbedded](docs/SettingsLicenseListEmbedded.md)
 - [SettingsLicenseOptions](docs/SettingsLicenseOptions.md)
 - [SettingsLicenseRequest](docs/SettingsLicenseRequest.md)
 - [SettingsLicenseRequestPatch](docs/SettingsLicenseRequestPatch.md)
 - [SettingsLicenseResponseMixin](docs/SettingsLicenseResponseMixin.md)
 - [SettingsLock](docs/SettingsLock.md)
 - [SettingsLockList](docs/SettingsLockList.md)
 - [SettingsLockListEmbedded](docs/SettingsLockListEmbedded.md)
 - [SettingsLockRequest](docs/SettingsLockRequest.md)
 - [SettingsLockRequestPatch](docs/SettingsLockRequestPatch.md)
 - [SettingsLockResponseMixin](docs/SettingsLockResponseMixin.md)
 - [SettingsMsprintconnectionpolicy](docs/SettingsMsprintconnectionpolicy.md)
 - [SettingsMsprintconnectionpolicyList](docs/SettingsMsprintconnectionpolicyList.md)
 - [SettingsMsprintconnectionpolicyListEmbedded](docs/SettingsMsprintconnectionpolicyListEmbedded.md)
 - [SettingsMsprintconnectionpolicyPolicies](docs/SettingsMsprintconnectionpolicyPolicies.md)
 - [SettingsMsprintconnectionpolicyRequest](docs/SettingsMsprintconnectionpolicyRequest.md)
 - [SettingsMsprintconnectionpolicyRequestPatch](docs/SettingsMsprintconnectionpolicyRequestPatch.md)
 - [SettingsMsprintconnectionpolicyResponseMixin](docs/SettingsMsprintconnectionpolicyResponseMixin.md)
 - [SettingsMswmifilter](docs/SettingsMswmifilter.md)
 - [SettingsMswmifilterList](docs/SettingsMswmifilterList.md)
 - [SettingsMswmifilterListEmbedded](docs/SettingsMswmifilterListEmbedded.md)
 - [SettingsMswmifilterPolicies](docs/SettingsMswmifilterPolicies.md)
 - [SettingsMswmifilterRequest](docs/SettingsMswmifilterRequest.md)
 - [SettingsMswmifilterRequestPatch](docs/SettingsMswmifilterRequestPatch.md)
 - [SettingsMswmifilterResponseMixin](docs/SettingsMswmifilterResponseMixin.md)
 - [SettingsPackages](docs/SettingsPackages.md)
 - [SettingsPackagesList](docs/SettingsPackagesList.md)
 - [SettingsPackagesListEmbedded](docs/SettingsPackagesListEmbedded.md)
 - [SettingsPackagesRequest](docs/SettingsPackagesRequest.md)
 - [SettingsPackagesRequestPatch](docs/SettingsPackagesRequestPatch.md)
 - [SettingsPackagesResponseMixin](docs/SettingsPackagesResponseMixin.md)
 - [SettingsPortal](docs/SettingsPortal.md)
 - [SettingsPortalAll](docs/SettingsPortalAll.md)
 - [SettingsPortalAllList](docs/SettingsPortalAllList.md)
 - [SettingsPortalAllListEmbedded](docs/SettingsPortalAllListEmbedded.md)
 - [SettingsPortalAllRequest](docs/SettingsPortalAllRequest.md)
 - [SettingsPortalAllRequestPatch](docs/SettingsPortalAllRequestPatch.md)
 - [SettingsPortalAllResponseMixin](docs/SettingsPortalAllResponseMixin.md)
 - [SettingsPortalCategory](docs/SettingsPortalCategory.md)
 - [SettingsPortalCategoryList](docs/SettingsPortalCategoryList.md)
 - [SettingsPortalCategoryListEmbedded](docs/SettingsPortalCategoryListEmbedded.md)
 - [SettingsPortalCategoryRequest](docs/SettingsPortalCategoryRequest.md)
 - [SettingsPortalCategoryRequestPatch](docs/SettingsPortalCategoryRequestPatch.md)
 - [SettingsPortalCategoryResponseMixin](docs/SettingsPortalCategoryResponseMixin.md)
 - [SettingsPortalEntry](docs/SettingsPortalEntry.md)
 - [SettingsPortalEntryList](docs/SettingsPortalEntryList.md)
 - [SettingsPortalEntryListEmbedded](docs/SettingsPortalEntryListEmbedded.md)
 - [SettingsPortalEntryRequest](docs/SettingsPortalEntryRequest.md)
 - [SettingsPortalEntryRequestPatch](docs/SettingsPortalEntryRequestPatch.md)
 - [SettingsPortalEntryResponseMixin](docs/SettingsPortalEntryResponseMixin.md)
 - [SettingsPortalList](docs/SettingsPortalList.md)
 - [SettingsPortalListEmbedded](docs/SettingsPortalListEmbedded.md)
 - [SettingsPortalRequest](docs/SettingsPortalRequest.md)
 - [SettingsPortalRequestPatch](docs/SettingsPortalRequestPatch.md)
 - [SettingsPortalResponseMixin](docs/SettingsPortalResponseMixin.md)
 - [SettingsPrintermodel](docs/SettingsPrintermodel.md)
 - [SettingsPrintermodelList](docs/SettingsPrintermodelList.md)
 - [SettingsPrintermodelListEmbedded](docs/SettingsPrintermodelListEmbedded.md)
 - [SettingsPrintermodelRequest](docs/SettingsPrintermodelRequest.md)
 - [SettingsPrintermodelRequestPatch](docs/SettingsPrintermodelRequestPatch.md)
 - [SettingsPrintermodelResponseMixin](docs/SettingsPrintermodelResponseMixin.md)
 - [SettingsPrinteruri](docs/SettingsPrinteruri.md)
 - [SettingsPrinteruriList](docs/SettingsPrinteruriList.md)
 - [SettingsPrinteruriListEmbedded](docs/SettingsPrinteruriListEmbedded.md)
 - [SettingsPrinteruriRequest](docs/SettingsPrinteruriRequest.md)
 - [SettingsPrinteruriRequestPatch](docs/SettingsPrinteruriRequestPatch.md)
 - [SettingsPrinteruriResponseMixin](docs/SettingsPrinteruriResponseMixin.md)
 - [SettingsProhibitedUsername](docs/SettingsProhibitedUsername.md)
 - [SettingsProhibitedUsernameList](docs/SettingsProhibitedUsernameList.md)
 - [SettingsProhibitedUsernameListEmbedded](docs/SettingsProhibitedUsernameListEmbedded.md)
 - [SettingsProhibitedUsernameRequest](docs/SettingsProhibitedUsernameRequest.md)
 - [SettingsProhibitedUsernameRequestPatch](docs/SettingsProhibitedUsernameRequestPatch.md)
 - [SettingsProhibitedUsernameResponseMixin](docs/SettingsProhibitedUsernameResponseMixin.md)
 - [SettingsSambaconfig](docs/SettingsSambaconfig.md)
 - [SettingsSambaconfigList](docs/SettingsSambaconfigList.md)
 - [SettingsSambaconfigListEmbedded](docs/SettingsSambaconfigListEmbedded.md)
 - [SettingsSambaconfigRequest](docs/SettingsSambaconfigRequest.md)
 - [SettingsSambaconfigRequestPatch](docs/SettingsSambaconfigRequestPatch.md)
 - [SettingsSambaconfigResponseMixin](docs/SettingsSambaconfigResponseMixin.md)
 - [SettingsSambadomain](docs/SettingsSambadomain.md)
 - [SettingsSambadomainList](docs/SettingsSambadomainList.md)
 - [SettingsSambadomainListEmbedded](docs/SettingsSambadomainListEmbedded.md)
 - [SettingsSambadomainRequest](docs/SettingsSambadomainRequest.md)
 - [SettingsSambadomainRequestPatch](docs/SettingsSambadomainRequestPatch.md)
 - [SettingsSambadomainResponseMixin](docs/SettingsSambadomainResponseMixin.md)
 - [SettingsService](docs/SettingsService.md)
 - [SettingsServiceList](docs/SettingsServiceList.md)
 - [SettingsServiceListEmbedded](docs/SettingsServiceListEmbedded.md)
 - [SettingsServiceRequest](docs/SettingsServiceRequest.md)
 - [SettingsServiceRequestPatch](docs/SettingsServiceRequestPatch.md)
 - [SettingsServiceResponseMixin](docs/SettingsServiceResponseMixin.md)
 - [SettingsSettings](docs/SettingsSettings.md)
 - [SettingsSettingsList](docs/SettingsSettingsList.md)
 - [SettingsSettingsListEmbedded](docs/SettingsSettingsListEmbedded.md)
 - [SettingsSettingsRequest](docs/SettingsSettingsRequest.md)
 - [SettingsSettingsRequestPatch](docs/SettingsSettingsRequestPatch.md)
 - [SettingsSettingsResponseMixin](docs/SettingsSettingsResponseMixin.md)
 - [SettingsSyntax](docs/SettingsSyntax.md)
 - [SettingsSyntaxList](docs/SettingsSyntaxList.md)
 - [SettingsSyntaxListEmbedded](docs/SettingsSyntaxListEmbedded.md)
 - [SettingsSyntaxRequest](docs/SettingsSyntaxRequest.md)
 - [SettingsSyntaxRequestPatch](docs/SettingsSyntaxRequestPatch.md)
 - [SettingsSyntaxResponseMixin](docs/SettingsSyntaxResponseMixin.md)
 - [SettingsUdmHook](docs/SettingsUdmHook.md)
 - [SettingsUdmHookList](docs/SettingsUdmHookList.md)
 - [SettingsUdmHookListEmbedded](docs/SettingsUdmHookListEmbedded.md)
 - [SettingsUdmHookRequest](docs/SettingsUdmHookRequest.md)
 - [SettingsUdmHookRequestPatch](docs/SettingsUdmHookRequestPatch.md)
 - [SettingsUdmHookResponseMixin](docs/SettingsUdmHookResponseMixin.md)
 - [SettingsUdmModule](docs/SettingsUdmModule.md)
 - [SettingsUdmModuleList](docs/SettingsUdmModuleList.md)
 - [SettingsUdmModuleListEmbedded](docs/SettingsUdmModuleListEmbedded.md)
 - [SettingsUdmModuleRequest](docs/SettingsUdmModuleRequest.md)
 - [SettingsUdmModuleRequestPatch](docs/SettingsUdmModuleRequestPatch.md)
 - [SettingsUdmModuleResponseMixin](docs/SettingsUdmModuleResponseMixin.md)
 - [SettingsUdmSyntax](docs/SettingsUdmSyntax.md)
 - [SettingsUdmSyntaxList](docs/SettingsUdmSyntaxList.md)
 - [SettingsUdmSyntaxListEmbedded](docs/SettingsUdmSyntaxListEmbedded.md)
 - [SettingsUdmSyntaxRequest](docs/SettingsUdmSyntaxRequest.md)
 - [SettingsUdmSyntaxRequestPatch](docs/SettingsUdmSyntaxRequestPatch.md)
 - [SettingsUdmSyntaxResponseMixin](docs/SettingsUdmSyntaxResponseMixin.md)
 - [SettingsUmcOperationset](docs/SettingsUmcOperationset.md)
 - [SettingsUmcOperationsetList](docs/SettingsUmcOperationsetList.md)
 - [SettingsUmcOperationsetListEmbedded](docs/SettingsUmcOperationsetListEmbedded.md)
 - [SettingsUmcOperationsetRequest](docs/SettingsUmcOperationsetRequest.md)
 - [SettingsUmcOperationsetRequestPatch](docs/SettingsUmcOperationsetRequestPatch.md)
 - [SettingsUmcOperationsetResponseMixin](docs/SettingsUmcOperationsetResponseMixin.md)
 - [SettingsUsertemplate](docs/SettingsUsertemplate.md)
 - [SettingsUsertemplateList](docs/SettingsUsertemplateList.md)
 - [SettingsUsertemplateListEmbedded](docs/SettingsUsertemplateListEmbedded.md)
 - [SettingsUsertemplateRequest](docs/SettingsUsertemplateRequest.md)
 - [SettingsUsertemplateRequestPatch](docs/SettingsUsertemplateRequestPatch.md)
 - [SettingsUsertemplateResponseMixin](docs/SettingsUsertemplateResponseMixin.md)
 - [SharesPrint](docs/SharesPrint.md)
 - [SharesPrintList](docs/SharesPrintList.md)
 - [SharesPrintListEmbedded](docs/SharesPrintListEmbedded.md)
 - [SharesPrintRequest](docs/SharesPrintRequest.md)
 - [SharesPrintRequestPatch](docs/SharesPrintRequestPatch.md)
 - [SharesPrintResponseMixin](docs/SharesPrintResponseMixin.md)
 - [SharesPrinter](docs/SharesPrinter.md)
 - [SharesPrinterList](docs/SharesPrinterList.md)
 - [SharesPrinterListEmbedded](docs/SharesPrinterListEmbedded.md)
 - [SharesPrinterRequest](docs/SharesPrinterRequest.md)
 - [SharesPrinterRequestPatch](docs/SharesPrinterRequestPatch.md)
 - [SharesPrinterResponseMixin](docs/SharesPrinterResponseMixin.md)
 - [SharesPrintergroup](docs/SharesPrintergroup.md)
 - [SharesPrintergroupList](docs/SharesPrintergroupList.md)
 - [SharesPrintergroupListEmbedded](docs/SharesPrintergroupListEmbedded.md)
 - [SharesPrintergroupRequest](docs/SharesPrintergroupRequest.md)
 - [SharesPrintergroupRequestPatch](docs/SharesPrintergroupRequestPatch.md)
 - [SharesPrintergroupResponseMixin](docs/SharesPrintergroupResponseMixin.md)
 - [SharesShare](docs/SharesShare.md)
 - [SharesShareList](docs/SharesShareList.md)
 - [SharesShareListEmbedded](docs/SharesShareListEmbedded.md)
 - [SharesShareOptions](docs/SharesShareOptions.md)
 - [SharesSharePolicies](docs/SharesSharePolicies.md)
 - [SharesShareRequest](docs/SharesShareRequest.md)
 - [SharesShareRequestPatch](docs/SharesShareRequestPatch.md)
 - [SharesShareResponseMixin](docs/SharesShareResponseMixin.md)
 - [UsersContact](docs/UsersContact.md)
 - [UsersContactList](docs/UsersContactList.md)
 - [UsersContactListEmbedded](docs/UsersContactListEmbedded.md)
 - [UsersContactRequest](docs/UsersContactRequest.md)
 - [UsersContactRequestPatch](docs/UsersContactRequestPatch.md)
 - [UsersContactResponseMixin](docs/UsersContactResponseMixin.md)
 - [UsersLdap](docs/UsersLdap.md)
 - [UsersLdapList](docs/UsersLdapList.md)
 - [UsersLdapListEmbedded](docs/UsersLdapListEmbedded.md)
 - [UsersLdapOptions](docs/UsersLdapOptions.md)
 - [UsersLdapPolicies](docs/UsersLdapPolicies.md)
 - [UsersLdapRequest](docs/UsersLdapRequest.md)
 - [UsersLdapRequestPatch](docs/UsersLdapRequestPatch.md)
 - [UsersLdapResponseMixin](docs/UsersLdapResponseMixin.md)
 - [UsersPasswd](docs/UsersPasswd.md)
 - [UsersPasswdList](docs/UsersPasswdList.md)
 - [UsersPasswdListEmbedded](docs/UsersPasswdListEmbedded.md)
 - [UsersPasswdRequest](docs/UsersPasswdRequest.md)
 - [UsersPasswdRequestPatch](docs/UsersPasswdRequestPatch.md)
 - [UsersPasswdResponseMixin](docs/UsersPasswdResponseMixin.md)
 - [UsersSelf](docs/UsersSelf.md)
 - [UsersSelfList](docs/UsersSelfList.md)
 - [UsersSelfListEmbedded](docs/UsersSelfListEmbedded.md)
 - [UsersSelfOptions](docs/UsersSelfOptions.md)
 - [UsersSelfRequest](docs/UsersSelfRequest.md)
 - [UsersSelfRequestPatch](docs/UsersSelfRequestPatch.md)
 - [UsersSelfResponseMixin](docs/UsersSelfResponseMixin.md)
 - [UsersUser](docs/UsersUser.md)
 - [UsersUserList](docs/UsersUserList.md)
 - [UsersUserListEmbedded](docs/UsersUserListEmbedded.md)
 - [UsersUserOptions](docs/UsersUserOptions.md)
 - [UsersUserPolicies](docs/UsersUserPolicies.md)
 - [UsersUserRequest](docs/UsersUserRequest.md)
 - [UsersUserRequestPatch](docs/UsersUserRequestPatch.md)
 - [UsersUserResponseMixin](docs/UsersUserResponseMixin.md)
 - [UvmmCloudconnection](docs/UvmmCloudconnection.md)
 - [UvmmCloudconnectionList](docs/UvmmCloudconnectionList.md)
 - [UvmmCloudconnectionListEmbedded](docs/UvmmCloudconnectionListEmbedded.md)
 - [UvmmCloudconnectionRequest](docs/UvmmCloudconnectionRequest.md)
 - [UvmmCloudconnectionRequestPatch](docs/UvmmCloudconnectionRequestPatch.md)
 - [UvmmCloudconnectionResponseMixin](docs/UvmmCloudconnectionResponseMixin.md)
 - [UvmmCloudtype](docs/UvmmCloudtype.md)
 - [UvmmCloudtypeList](docs/UvmmCloudtypeList.md)
 - [UvmmCloudtypeListEmbedded](docs/UvmmCloudtypeListEmbedded.md)
 - [UvmmCloudtypeRequest](docs/UvmmCloudtypeRequest.md)
 - [UvmmCloudtypeRequestPatch](docs/UvmmCloudtypeRequestPatch.md)
 - [UvmmCloudtypeResponseMixin](docs/UvmmCloudtypeResponseMixin.md)
 - [UvmmInfo](docs/UvmmInfo.md)
 - [UvmmInfoList](docs/UvmmInfoList.md)
 - [UvmmInfoListEmbedded](docs/UvmmInfoListEmbedded.md)
 - [UvmmInfoRequest](docs/UvmmInfoRequest.md)
 - [UvmmInfoRequestPatch](docs/UvmmInfoRequestPatch.md)
 - [UvmmInfoResponseMixin](docs/UvmmInfoResponseMixin.md)
 - [UvmmProfile](docs/UvmmProfile.md)
 - [UvmmProfileList](docs/UvmmProfileList.md)
 - [UvmmProfileListEmbedded](docs/UvmmProfileListEmbedded.md)
 - [UvmmProfileRequest](docs/UvmmProfileRequest.md)
 - [UvmmProfileRequestPatch](docs/UvmmProfileRequestPatch.md)
 - [UvmmProfileResponseMixin](docs/UvmmProfileResponseMixin.md)


## Documentation For Authorization


## basic

- **Type**: HTTP basic authentication


## Author




